(function ($) {
    'use strict';

    $(document).ready(function () {
	$("#pcd-cases-type").hide();

        $(".edit-php.post-type-pcd-template .wrap h2 .add-new-h2").show();
        $(".js-example-basic-single").select2();
        setTimeout(function () {

            //check if at least one model has been created
            if ($('body.post-type-pcd-metas').length > 0) {
                // call function to reindex models
                reindex_models_table();
                $("#pcd-metas-models-table > tbody").sortable({
                    update: function (event, ui) {
                        reindex_models_table();
                    }
                });
            }

            // call function to build review 
            build_preview();

            set_modals_position();
            update_models_id();
            update_cases_id();


        }, 3000);
        $(document).on("click", ".add-rf-row", function (e) {
            setTimeout(function () {
                update_models_id();
                update_cases_id();
            }, 200);
        });

        function build_preview() {
            $("#pcd-preview").html("");
            $(".default-config:checked").each(function () {
                var src = $(this).closest(".pcd-case-row").find(".pcd-case-img img").attr("data-original");
                if (!src)
                    src = $(this).closest(".pcd-case-row").find(".pcd-case-img img").attr("src");
                if (src)
                    $("#pcd-preview").append("<img src='" + src + "'>");
            });
        }
        function sanitize_title(value) {
            var rExps = [
                {re: /[\xC0-\xC6]/g, ch: 'A'},
                {re: /[\xE0-\xE6]/g, ch: 'a'},
                {re: /[\xC8-\xCB]/g, ch: 'E'},
                {re: /[\xE8-\xEB]/g, ch: 'e'},
                {re: /[\xCC-\xCF]/g, ch: 'I'},
                {re: /[\xEC-\xEF]/g, ch: 'i'},
                {re: /[\xD2-\xD6]/g, ch: 'O'},
                {re: /[\xF2-\xF6]/g, ch: 'o'},
                {re: /[\xD9-\xDC]/g, ch: 'U'},
                {re: /[\xF9-\xFC]/g, ch: 'u'},
                {re: /[\xC7-\xE7]/g, ch: 'c'},
                {re: /[\xD1]/g, ch: 'N'},
                {re: /[\xF1]/g, ch: 'n'}];

            // converti les caractères accentués en leurs équivalent alpha
            for (var i = 0, len = rExps.length; i < len; i++)
                value = value.replace(rExps[i].re, rExps[i].ch);

            // 1) met en bas de casse
            // 2) remplace les espace par des tirets
            // 3) enleve tout les caratères non alphanumeriques
            // 4) enlève les doubles tirets
            // 6) enlève les tirets en début de chaine
            // 6) enlève les tirets en fin de chaine
            return value.toLowerCase()
                    .replace(/\s+/g, '-')
                    .replace(/[^a-z0-9-]/g, '')
                    .replace(/\-{2,}/g, '-')
                    .replace(/^\-/g, '')
                    .replace(/\-$/, '');
        }

        function update_models_id() {

            $('.pcd-model-id[value=""]').each(function (index, model_id_field) {
                var model_id = o_uniqid("model-");
                $(model_id_field).val(model_id);
                var old_model_id = 'model_' + sanitize_title($(model_id_field).parent().parent().find('.pcd-model-name').val().replace(/ /g, ''));

                $('case[value="' + old_model_id + '"]').attr('value', model_id);
            })
        }

        function update_cases_id() {

            $('.pcd-case-id[value=""]').each(function (index, case_id_field) {

                var old_case_id = 'model_' + sanitize_title($(case_id_field).parents('.omodal').parents().parents().find('.pcd-model-name').val().replace(/ /g, '')) + '_case_' + sanitize_title($(case_id_field).parent().parent().find('.pcd-case-name').val().replace(/ /g, ''));

                var case_id = o_uniqid("case-");

                $('case[value="' + old_case_id + '"]').attr('value', case_id);
                $(case_id_field).val(case_id);
            });

        }
        $(".pcd-colors-palette-type").each(function () {
            var type = $(this).val();
            if (type === "palette") {
                $("#pcd-predefined-colors-options").show();
                $("#pcd-default-color").hide();

            } else if (type === "picker") {
                $("#pcd-predefined-colors-options").hide();
                $("#pcd-default-color").show();
            }
        });
        $(document).on("change", ".pcd-colors-palette-type", function () {

            var type = $(this).val();
            if (type === "palette") {
                $("#pcd-predefined-colors-options").show();
                $("#pcd-default-color").hide();

            } else if (type === "picker") {
                $("#pcd-predefined-colors-options").hide();
                $("#pcd-default-color").show();
            }
        });

        function isEmpty(value) {
            return typeof value == 'string' && !value.trim() || typeof value == 'undefined' || value === null || $.isEmptyObject(value);
        }
        ;

        if ($('#pcd-use-global-fonts').val() === "no") {
            $("#pcd-use-global-fonts").parent().parent().next().show();

        } else {
            $("#pcd-use-global-fonts").parent().parent().next().hide();
            $("#select-fonts").attr("required", false);
        }
        $(document).on("change", "#pcd-use-global-fonts", function () {

            var type = $(this).val();
            if (type === "no") {
                $("#pcd-use-global-fonts").parent().parent().next().show();
                $("#select-fonts").attr("required", true);
            } else {
                $("#pcd-use-global-fonts").parent().parent().next().hide();
                $("#select-fonts").attr("required", false);
            }
        });

        if ($('.pcd-cases-type').val() === "photo") {
            $("#pcd-background-settings").show();
            $("table#pcd-metas-model-table tr td:nth-child(4)").show();
            $("#pcd-devices-and-cases-settings .o-modal-trigger").html('Manage cases');
        } else {
            $("#pcd-background-settings").hide();
            $("table#pcd-metas-model-table tr td:nth-child(4)").hide();
            $("table#pcd-metas-model-table .omodal-body tr td:nth-child(4)").show();
            $("#pcd-devices-and-cases-settings .o-modal-trigger").html('Manage options');
        }
        $(document).on("change", ".default-config", function (e) {
            $(this).parents(".omodal-body").find("input[type=radio]").not($(this)).attr('checked', false);
        });
        $(document).on("change", ".pcd-cases-type", function () {

            var type = $(this).val();

            if (type === "photo") {
                $("#pcd-background-settings").show();
                $("table#pcd-metas-model-table tr td:nth-child(4)").show();
                $("#pcd-devices-and-cases-settings .o-modal-trigger").html('Manage cases');
            } else {
                $("#pcd-background-settings").hide();
                $("table#pcd-metas-model-table tr td:nth-child(4)").hide();
                $("table#pcd-metas-model-table .omodal-body tr td:nth-child(4)").show();
                $("#pcd-devices-and-cases-settings .o-modal-trigger").html('Manage options');

            }
        });
        $("#select-fonts").select2({placeholder: "Select fonts", width: '100%'});

        $("#select-background").select2({placeholder: "select backgrounds",
            width: '100%',
            "language": {
                "noResults": function () {
                    return "Please add at list one clipart group in order to select it here.";
                }
            },
            escapeMarkup: function (markup) {
                return markup;
            }});
        function setCurrency(currency) {
      
            if (!currency.id) {
                return currency.text;
            }
            if (isEmpty(pcd_admin_layouts[currency.id])) {
                return currency.text;
            }
            var $currency = $('<div style="height: 100px; line-height: 100px; text-align: center;"><span style="display: inline-block; vertical-align: middle; line-height: normal;"><img src="' + pcd_admin_layouts[currency.id]["general_info"]["path"] + '"/></span><span  style=" margin-left:5%; display: inline-block; vertical-align: middle; line-height: normal;">' + currency.text + '</span></div>');
            return $currency;
        }
        $(document).on("change", ".select-layouts", function () {
            if ("selected" === $(this).find("option[value='all']").attr("selected"))
            {
                $(this).find("option").removeAttr("selected");
                $(this).triggerHandler("change");
                $(this).find("option[value='all']").attr("selected", true);
                $(this).triggerHandler("change");
            }
        });
        $(document).on("click", ".duplicate", function () {

            $(".select-layouts").each(function () {
                $(this).select2("destroy");
            });
            var model_line = $(this).parent().parent().html();
            var old = $(this).parent().parent().find('.pcd-model-name').val();

            var new_tr = $("<tr>");

            new_tr.html(model_line);
            setTimeout(function () {
                $(".select-layouts").each(function () {
                    $(this).select2({
                        width: '200px',
                        placeholder: "Select layouts",
                        templateResult: setCurrency,
                        templateSelection: setCurrency
                    });

                });
            }, 200);
            $($(this).parent().parent()).after(new_tr);
            var model_id = o_uniqid("model-");
            $(this).parent().parent().find('.pcd-model-id').attr('value', model_id);
            $(this).parent().parent().find('.pcd-model-name').val(old + ' (copy)');
            reindex_models_table();
            //console.log($('input[value="'+model_id+'"]').parent().parent().find('.omodal-title').attr('id'));
            var new_modal_id = o_uniqid("o-modal-");
            var modal_title_id = "myModalLabel" + new_modal_id;
            $('input[value="' + model_id + '"]').parent().parent().find('.o-modal-trigger').attr('data-modalid', new_modal_id);
            $('input[value="' + model_id + '"]').parent().parent().find('.o-modal-trigger').attr('data-target', '#' + new_modal_id);
            $('input[value="' + model_id + '"]').parent().parent().find('.o-modal').attr('id', new_modal_id);
            $('input[value="' + model_id + '"]').parent().parent().find('.omodal-title').attr('id', modal_title_id);
            var selector = $("#" + new_modal_id + " .omodal-body>table>tbody>tr .pcd-case-id");
            $.each(selector, function (index, value) {
                $(value).attr('value', '');
                var case_id = o_uniqid("case-");
                $(value).attr('value', case_id);
            });

        });
        setTimeout(function () {
            $(".select-layouts").each(function () {
                $(this).attr('name', $(this).attr('name').split('[select-layouts]')[0] + '[select-layouts][]');
                $(this).select2({
                    width: '200px',
                    multiple: true,
                    placeholder: "Select layouts",
                    templateResult: setCurrency,
                    templateSelection: setCurrency
                });
            });
        }, 200);
        $(document).on("click", "#pcd-devices-and-cases-settings .add-rf-row", function (e) {
            setTimeout(function () {
                $(".select-layouts").each(function () {
                    if (!$(this).hasClass("select2-hidden-accessible")) {
                        $(this).attr('name', $(this).attr('name').split('[select-layouts]')[0] + '[select-layouts][]');
                        $(this).select2({
                            width: '200px',
                            placeholder: "Select layouts",
                            templateResult: setCurrency,
                            templateSelection: setCurrency
                        });
                    }
                });
                if ($('.pcd-cases-type').val() === "photo") {
                    $("table#pcd-metas-model-table tr td:nth-child(4)").show();
                    $("#pcd-devices-and-cases-settings .o-modal-trigger").html('Manage cases');
                } else {
                    $("table#pcd-metas-model-table tr td:nth-child(4)").hide();
                    $("table#pcd-metas-model-table .omodal-body tr td:nth-child(4)").show();
                    $("#pcd-devices-and-cases-settings .o-modal-trigger").html('Manage options');
                }
            }, 200);




        });
        $(document).on("click", "#pcd-devices-and-cases-settings .o-modal-trigger", function (e) {
            if (!$(this).closest("tr").find(".pcd-case-row").length && !$(this).closest("tr").find(".o-rf-row").length)
            {
                $(this).closest("tr").find(".add-rf-row").trigger("click");
            }

        });

        $(document).on("click", ".omodal-content .add-rf-row", function (e) {
            setTimeout(function () {
                $(".pcd-case-product").each(function () {
                    if (!$(this).hasClass("select2-hidden-accessible")) {
                        $(this).select2({
                            searchInputPlaceholder: "Select product"
                        });
                    }
                });
            }, 200);

        });

        $(document).on("keyup", ".pcd-meta-custom-palette-hex", function (e) {
            var color = $(this).val();
            $(this).css("background-color", color);
        });
        window.load_colorpicker_palette = function () {
            $('.pcd-meta-custom-palette-hex').each(function (index, element) {
                var e = $(this);
                var initial_color = e.val();
                e.css("background-color", initial_color);
                $(this).ColorPicker({
                    color: initial_color,
                    onShow: function (colpkr) {
                        $(colpkr).fadeIn(500);
                        return false;
                    },
                    onChange: function (hsb, hex, rgb) {
                        e.css("background-color", "#" + hex);
                        e.val("#" + hex);
                    }
                });
            });
        }
        load_colorpicker_palette();
        $("#pcd-text-settings #pcd-add-color").click(function (e) {
            e.preventDefault();
            var new_color = '<table><tr><td><input type="text" name="pcd-metas[pcd-custom-palette-name][]" placeholder="Color name" class="pcd-meta-custom-palette-name"><input type="text" placeholder="Click inside" name="pcd-metas[pcd-custom-palette-hex][]" class="pcd-meta-custom-palette-hex"><button class="button pcd-remove-color">Remove</button></td></tr></table>';
            $(".pcd-colors").append(new_color);

            load_colorpicker_palette();

        });


        $(document).on("click", ".pcd-remove-color", function (e) {
            e.preventDefault();
            $(this).parent().remove();
        });
        function set_modals_position() {
            if (!$("#pcd-metas-settings-box").length)
                return;
            var left = $("#pcd-metas-settings-box").offset().left;
            var width = $("#pcd-metas-settings-box").outerWidth();
            $("body").append("<style>.o-modal .omodal-dialog{width: " + width + "px;margin-left: " + left + "px;}</style");
        }
        $(document).on("click", ".pcd_img_upload", function (e) {
            e.preventDefault();
            var selector = $(this).attr('data-selector');
            var uploader = wp.media({
                title: 'Please set the picture',
                button: {
                    text: "Set Image"
                },
                multiple: false
            })
                    .on('select', function () {
                        var selection = uploader.state().get('selection');
                        selection.map(
                                function (attachment) {
                                    attachment = attachment.toJSON();
                                    $("#" + selector).attr('value', attachment.id);
                                    $("#" + selector + "_preview").html("<img src='" + attachment.url + "'>");
                                }
                        );
                    })
                    .open();
        });

        //we delay the init to avoid conflicts with plugin that hook on the select2 classes and create conflicts
        setTimeout(function () {
            $("#font").select2({allowClear: true, placeholder: "Pick a google font"});
        }, 500);

        load_select2();

        function load_select2(container) {
            if (typeof container === "undefined")
                container = "";
            $(container + " select.o-select2").each(function () {
                //                console.log($(this));
                $(this).select2({allowClear: true});
            });
        }

        $(document).on('change', '#font', function () {

            var name = $('#font  option:selected').text();
            var url = $('#font   option:selected').val();
            $('.font_auto_name').val(name);
            $('.font_auto_url').val(url);

        });

        //Cliparts add image
        $(document).on("click", "#pcd-add-clipart", function (e) {
            e.preventDefault();
            var selector = $(this).attr('data-selector');
            var trigger = $(this);
            var uploader = wp.media({
                title: 'Please set the picture',
                button: {
                    text: "Set Image"
                },
                multiple: true
            })
                    .on('select', function () {
                        var selection = uploader.state().get('selection');
                        selection.map(
                                function (attachment) {
                                    attachment = attachment.toJSON();
                                    var code = "<input type='hidden' value='" + attachment.id + "' name='selected-cliparts[]'>";
                                    code = code + "<span class='pcd-clipart-holder'><img src='" + attachment.url + "'>";
                                    code = code + "<label>Price: <input type='text' value='0' name='pcd-cliparts-prices[]'></label>";
                                    code = code + "<a href='#' class='button pcd-remove-clipart' data-id='" + attachment.id + "'>Remove</a></span>";
                                    $("#cliparts-container").prepend(code);
                                }
                        );
                    })
                    .open();
        });

        $(document).on("click", ".pcd-remove-clipart", function (e) {
            e.preventDefault();
            var id = $(this).data("id");
            $('#cliparts-form > input[value="' + id + '"]').remove();
            $(this).parent().remove();
        });

        $(document).on("click", ".o-add-font-file", function (e) {
            e.preventDefault();
            var uploader = wp.media({
                title: 'Please set the picture',
                button: {
                    text: "Select picture(s)"
                },
                multiple: false
            })
                    .on('select', function () {
                        var selection = uploader.state().get('selection');
                        selection.map(
                                function (attachment) {
                                    attachment = attachment.toJSON();
                                    var new_rule_index = $(".font_style_table tbody tr").length;
                                    var font_tpl = $("#pcd-font-tpl").val();
                                    var tpl = font_tpl.replace(/{index}/g, new_rule_index);
                                    $('.font_style_table tbody').prepend(tpl);
                                    $('#file_data_' + new_rule_index).find("input[type=hidden]").val(attachment.id);
                                    $('#file_data_' + new_rule_index).parent().find(".media-name").html(attachment.filename);
                                }
                        );
                    })
                    .open();
        });

        $(document).on("click", ".o-remove-font-file", function (e) {
            e.preventDefault();
            $(this).parent().find("input[type=hidden]").val("");
            $(this).parent().parent().find(".media-name").html("");
            $(this).parent().parent().remove();
        });

        $(document).on("click", "#pcd-customizer button", function (e) {
            e.preventDefault();
        });

        $(document).on("change", ".pcd-activate-part-cb", function (e) {
            var is_checked = $(this).is(":checked");
            var selector = $(this).attr('data-selector');
            var output_area = selector + "_preview";
            if (is_checked)
                $("#" + selector).attr('value', 0);
            else
                $("#" + selector).attr('value', '');
            $("#" + output_area).html("");

        });

        $(document).on("change", ".pcd-ovni-cb", function (e) {
            var is_checked = $(this).is(":checked");
            var selector = $(this).parent().find("input[type=hidden]");
            if (is_checked)
                selector.val(1);
            else
                selector.val(-1);

        });

        $(document).on("click", ".pcd_img_remove", function (e) {
            e.preventDefault();
            var is_active = $(this).siblings(".pcd-activate-part-cb").is(":checked");
            var selector = $(this).attr('data-selector');
            var output_area = selector + "_preview";
            if (is_active)
                $("#" + selector).attr('value', 0);
            else
                $("#" + selector).attr('value', "");

            $("#" + output_area).html("");
        });

        $('[href="#pcd_related_products_tab_data"]').on('click', function () {
            var post_id = $("#post_ID").val();
            $.post(
                    ajax_object.ajax_url,
                    {
                        action: "get_related_products_content",
                        product_id: post_id,
                    },
                    function (data) {
                        $("#pcd_related_products_tab_data .related-products-container").html(data);
                    }
            );
        });

        $('a[href*="post-new.php?post_type=pcd-template"]').click(function (e) {
            e.preventDefault();
            $('#pcd-products-selector-modal').omodal("show");
        });

        $(".pcd_order_item .o-modal-trigger").click(function () {
            var target = $(this).data("target");
            $(target).omodal("show");
        });

        $("#pcd-select-template").click(function (e) {
            var selected_product = $('select[name=template_base_pdt]').val();
            if (typeof selected_product == 'undefined')
                alert("Please select a product first");
            else {
                var url = $('a[href*="post-new.php?post_type=pcd-template"]').first().attr("href");
                $(location).attr('href', url + "&base-product=" + selected_product);
            }
        });

        $("#pcd-settings .help_tip").each(function (i, e) {
            var tip = $(e).data("tip");
            $(e).tooltip({title: tip});
        });

        $("#pcd-settings [name='pcd-colors-options[pcd-color-palette]']").change(function () {
            var palette = $(this).val();
            if (palette == "custom")
                $("#pcd-predefined-colors-options").show();
            else
                $("#pcd-predefined-colors-options").hide();
        });

        $(document).on("keyup", "#pcd-settings [name='pcd-colors-options[pcd-custom-palette][]']", function (e) {
            var color = $(this).val();
            $(this).css("background-color", color);
        });

        $("#pcd-settings #pcd-add-color").click(function (e) {
            e.preventDefault();
            var new_color = '<div><input type="text" name="pcd-colors-options[pcd-custom-palette][]" class="pcd-color"><button class="button pcd-remove-color">Remove</button></div>';
            $("#pcd-settings .pcd-colors").append(new_color);
            load_colorpicker();
        });

        $(document).on("click", "#pcd-settings .pcd-remove-color", function (e) {
            e.preventDefault();
            $(this).parent().remove();
        });

        $(document).on("click", ".pcd-add-rule", function (e) {
            var new_rule_index = $(".pcd-rules-table tr").length;
            var group_index = $(this).data("group");
            var raw_tpl = $("#pcd-rule-tpl").val();
            var tpl1 = raw_tpl.replace(/{rule-group}/g, group_index);
            var tpl2 = tpl1.replace(/{rule-index}/g, new_rule_index);
            $(this).parents(".pcd-rules-table").find("tbody").append(tpl2);
            $(this).parents(".pcd-rules-table").find(".a_price").attr("rowspan", new_rule_index + 1);
        });

        $(document).on("click", ".pcd-add-group", function (e) {
            var new_rule_index = 0;
            var group_index = $(".pcd-rules-table").length;
            var raw_tpl = $("#pcd-first-rule-tpl").val();
            var tpl1 = raw_tpl.replace(/{rule-group}/g, group_index);
            var tpl2 = tpl1.replace(/{rule-index}/g, new_rule_index);
            var html = '<table class="pcd-rules-table widefat"><tbody>' + tpl2 + '</tbody></table>';
            $(".pcd-rules-table-container").append(html);
        });

        $(document).on("click", ".pcd-remove-rule", function (e) {
            var nb_rules = $(".pcd-rules-table tr").length;
            $(this).parents(".pcd-rules-table").find(".a_price").attr("rowspan", nb_rules - 1);
            $(this).parents("tr").remove();

        });

        $(document).on("keyup", ".color_field", function (e) {
            var color = $(this).val();
            $(this).css("background-color", color);
        });


        window.load_colorpicker = function () {
            $('.pcd-color').each(function (index, element) {
                var e = $(this);
                var initial_color = e.val();
                e.css("background-color", initial_color);
                $(this).ColorPicker({
                    color: initial_color,
                    onShow: function (colpkr) {
                        $(colpkr).fadeIn(500);
                        return false;
                    },
                    onChange: function (hsb, hex, rgb) {
                        e.css("background-color", "#" + hex);
                        e.val("#" + hex);
                    }
                });
            });
        }
        load_colorpicker();
        function load_tabbed_panels(container) {
            $(container + " .TabbedPanels").each(function () {
                var cookie_id = 'tabbedpanels_' + $(this).attr("id");
                var defaultTab = ($.cookie(cookie_id) ? parseInt($.cookie(cookie_id)) : 0);
                new Spry.Widget.TabbedPanels($(this).attr("id"), {defaultTab: defaultTab - 1});
            });
        }

        load_tabbed_panels("body");

        $('.TabbedPanelsTab').click(function (event) {
            var cookie_id = 'tabbedpanels_' + $(this).parent().parent('.TabbedPanels').attr('id');
            $.cookie(cookie_id, parseInt($(this).attr('tabindex')));
        });

        $(document).on("click", ".pcd-add-media", function (e) {
            e.preventDefault();
            var trigger = $(this);
            var uploader = wp.media({
                title: 'Please select the background image',
                button: {
                    text: "Set"
                },
                multiple: false
            })
                    .on('select', function () {
                        var selection = uploader.state().get('selection');
                        selection.map(
                                function (attachment) {
                                    attachment = attachment.toJSON();
                                    trigger.parent().find("img").attr("src", attachment.url);
                                    trigger.parent().find("input[type=hidden]").val(attachment.id);
                                }
                        );
                    })
                    .open();
        });

        $(document).on("click", ".pcd-remove-media", function (e) {
            e.preventDefault();
            $(this).parent().find("img").attr("src", "");
            $(this).parent().find("input[type=hidden]").val("");
        });

        $(document).on("change", ".pcd-grid.pcd-grid-pad .pcd-color", function (e) {
            var color = $(this).val();
            $(this).css("background-color", color);
        });

        $(document).on("change", "#pcd-texts-cases input[name='pcd-texts-cases[visible-tab]']", function (e) {
            var checked = $(this).is(":checked");
            $("#pcd-texts-cases tr:not(:first-child) input[name^='pcd-texts-cases'][type='checkbox']").prop("checked", checked);
        });

        $(document).on("change", "#pcd-images-cases input[name='pcd-images-cases[visible-tab]']", function (e) {
            var checked = $(this).is(":checked");
            $("#pcd-images-cases tr:not(:first-child) input[name^='pcd-images-cases'][type='checkbox']").prop("checked", checked);
        });

        $(document).on("change", "#pcd-designs-cases input[name='pcd-designs-cases[visible-tab]']", function (e) {
            var checked = $(this).is(":checked");
            $("#pcd-designs-cases tr:not(:first-child) input[name^='pcd-designs-cases'][type='checkbox']").prop("checked", checked);
        });


        if ($(".datatable").length) {
            $(".datatable").DataTable({"bAutoWidth": false});
        }

        $("#pcd-check-all-products").change(function () {
            var is_checked = this.checked;
            $("#bulk-definition-table tbody input[type=checkbox]").prop('checked', is_checked);
        });

        $(document).on("woocommerce_variations_loaded", "#woocommerce-product-data", function (e) {
            load_tabbed_panels("#woocommerce-product-data");
            load_select2("#woocommerce-product-data");
        });

        $(document).on("click", ".pcd-add-cliparts", function (e) {
            e.preventDefault();
            var uploader = wp.media({
                title: 'Please set the picture',
                button: {
                    text: "Select picture(s)"
                },
                multiple: true
            })
                    .on('select', function () {
                        var selection = uploader.state().get('selection');
                        selection.map(
                                function (attachment) {
                                    attachment = attachment.toJSON();
                                    var url_without_root = attachment.url.replace(home_url, "");
                                    setTimeout(function () {
                                        $('.add-rf-row').click();
                                        var trigger = $('#cliparts-container table .o-rf-row').last().find('.o-add-media');
                                        trigger.parent().find("input[type=hidden]").val(url_without_root);
                                        trigger.parent().find(".media-preview").html("<img src='" + attachment.url + "'>");
                                        trigger.parent().find(".media-name").html(attachment.filename);
                                        if (trigger.parent().hasClass("trigger-change"))
                                            trigger.parent().find("input[type=hidden]").trigger("propertychange");
                                    }, 200);


                                }
                        );
                    })
                    .open();
        });

        function get_output_fields_based_on_format() {
            $("[class*='show-if-']").hide();
            var selected_value = $('.config-output-format input:checked').val();
            //            console.log(selected_value);
            if (selected_value.indexOf("pdf") >= 0) {
                $('.show-if-pdf').show();
                $('.hide-if-pdf').hide();
            } else {
                $('.show-if-pdf').hide();
                $('.hide-if-pdf').show();
            }

            if (selected_value.indexOf("jpg") >= 0)
                $('.show-if-jpg').show();
            else
                $('.show-if-jpg').hide();

            //Zip output
            $(".show-if-zip").hide();
            var zip = $('.zip-output input:checked').val();
            if (zip == 'yes')
                $('.show-if-zip').show();
            else
                $('.show-if-zip').hide();
        }

        $(document).on("change", ".config-output-format input, .zip-output input", function (e) {
            get_output_fields_based_on_format();

        });

        if ($('.config-output-format').length)
            get_output_fields_based_on_format();

        $(document).on("change", ".pdf-unit", function (e) {
            $(".hide-if-pixels").hide();
            var selected_value = $(this).val();
            if (selected_value.indexOf("px") >= 0)
                $('.hide-if-pixels').hide();
            else
                $('.hide-if-pixels').show();
        });

        if ($('.post-type-pcd-config .config-output-format').length)
            $('.post-type-pcd-config .config-output-format').trigger('change');
        if ($('.zip-output').length)
            $('.zip-output').trigger('change');
    });

    $(document).on("click", "#pcd-dismiss", function () {
        $.post(
                ajaxurl,
                {
                    action: "pcd_hide_notice",
                },
                function (data) {
                    if (data === "ok") {
                        $('#subscription-notice').hide();
                    }
                })
                .fail(function (xhr, status, error) {
                    alert(error);
                });

    });

    $(document).on("click", "#pcd-subscribe", function () {
        $("#pcd-subscribe-loader").show();
        $("#pcd-subscribe").attr("disabled", true);
        $("#pcd-subscribe").addClass('disabled');
        if (!$('#o_user_email').val()) {
            alert('No email found. Please add an email address to subscribe.');
            $("#pcd-subscribe-loader").hide();
            $("#pcd-subscribe").attr("disabled", false);
            $("#pcd-subscribe").removeClass('disabled');
        } else {
            var email = $('#o_user_email').val();
            $.post(
                    ajaxurl,
                    {
                        action: "pcd_subscribe",
                        email: email
                    },
                    function (data) {
                        if (data == "true") {
                            $("#pcd-subscribe-loader").hide();
                            $('#subscription-notice').hide();
                            $('#subscription-success-notice').show();
                        } else {
                            $("#pcd-subscribe-loader").hide();
                            $("#pcd-subscribe").attr("disabled", false);
                            $("#pcd-subscribe").removeClass('disabled');
                            alert(data);
                        }
                    })
                    .fail(function (xhr, status, error) {
                        $("#pcd-subscribe-loader").hide();
                        $("#pcd-subscribe").attr("disabled", false);
                        $("#pcd-subscribe").removeClass('disabled');
                        alert(error);
                    });
        }

    });
    function update_model_id() {
        $('.pcd-model-id[value=""]').each(function (index, model_id_field) {
            var model_id = o_uniqid("model-");
            $(model_id_field).val(model_id);
            var old_model_id = 'model_' + sanitize_title($(model_id_field).parent().parent().find('.pcd-model-name').val().replace(/ /g, ''));

            $('case[value="' + old_model_id + '"]').attr('value', model_id);
        })
    }

    function update_cases_id() {
        $('.pcd-case-id[value=""]').each(function (index, case_id_field) {
            var old_case_id = 'model_' + sanitize_title($(case_id_field).parents('.omodal').parents().parents().find('.pcd-model-name').val().replace(/ /g, '')) + '_group_' + sanitize_title($(case_id_field).parents().parent().find('.pcd-case-group').val().replace(/ /g, '')) + '_case_' + sanitize_title($(case_id_field).parent().parent().find('.pcd-case-name').val().replace(/ /g, ''));

            var case_id = o_uniqid("case-");
            $('case[value="' + old_case_id + '"]').attr('value', case_id);
            $(case_id_field).val(case_id);
        });

    }
    function reindex_models_table() {
        $("#pcd-metas-model-table > tbody > tr").each(function (i, e) {
            //Replace the inputs names

            var prefix = "pcd-metas[models][" + i + "]";
            $(this).find(":input[name^='pcd-metas[models]']").each(function (i2, e2) {
                var new_name = this.name.replace(/pcd-metas\[models\]\[\d+\]/, prefix);
                //                    console.log(this.name+" => "+new_name);
                $(this).attr("name", new_name);

            });
        });
    }

    function reindex_cases_table() {
        $(".o-modal .omodal-body>.table-fixed-layout> tbody > tr:visible").each(function (i, e) {
            //Replace the inputs names
            var replacement = "[cases][" + i + "]";
            $(this).find(":input[name*='[cases]']").each(function (i2, e2) {
                var new_name = this.name.replace(/\[cases\]\[\d+\]/, replacement);
                //                    console.log(this.name+" => "+new_name);
                $(this).attr("name", new_name);
            });
        });
    }

    $(".duplicate").parent().parent().each(function () {
        var uniq = $(this).find('.pcd-model-id').val();
        $(this).find('.duplicate').attr("id", uniq);
    });

    $(".duplicate_case").parent().parent().each(function () {
        var uniq = $(this).find('.pcd-case-id').val();
        $(this).find('.duplicate_case').attr("id", uniq);
    });

    $(document).on("click", ".duplicate_case", function () {
        var case_line = $(this).parent().parent().html();
        var old_opt_name = $(this).parent().parent().find('.pcd-case-name').val();
        var new_tr = $("<tr>");
        new_tr.html(case_line);
        $($(this).parent().parent()).after(new_tr);
        var case_id = o_uniqid("case-");
        $(this).parent().parent().find('.pcd-case-id').attr('value', case_id);
        $(this).parent().parent().find('.pcd-case-name').val(old_opt_name + ' (copy)');
        reindex_cases_table();
    });
    $(document).on("keyup mouseup", ".repeatable-fields-table :input", function () {
        $(this).attr("value", $(this).val());
    });
    $(document).on("keyup", ".repeatable-fields-table textarea", function () {
        $(this).html($(this).val());
    });



})(jQuery);
