var PCD_EDITOR = (function ($, pcd_editor) {
    $(document).ready(function () {
	//Lazy load
	function init_lazy_loader(container)
	{
	    $("img.o-lazy").lazyload({
		//            event: "scrollstop",
		placeholder: pcd.lazy_placeholder,
		container: $(container),
		skip_invisible: true
			//                threshold: 10
	    });
	}

	init_lazy_loader("#pcd-cliparts-wrapper");


	$(document).on("click", ".pcd-cliparts-groups>li,#pcd-search-cliparts-group-results > li", function (e) {
	    show_all_cliparts();
	    var group_id = $(this).data("groupid");
	    var group_name = $(this).html();
	    $(".pcd-cliparts-container").hide();
	    $(".pcd-cliparts-groups>li").removeClass("selected");
	    $(this).addClass("selected");
	    $(".pcd-cliparts-container[data-groupid=" + group_id + "]").show();
	    setTimeout(function () {
		$(".pcd-cliparts-container[data-groupid=" + group_id + "]").trigger("scroll");
	    }, 500);
	    $('#pcd-clipart-group-selected').html(group_name);
	    $('#cliparts-panel-content-child').addClass('is-open');

	});

	$(".pcd-cliparts-container").bind('scrollstop', function (e) {
	    $(".pcd-cliparts-container:visible").trigger("scroll");
	});

	$(document).on("click", "#pcd-cliparts-opener", function (e) {
	    $(".pcd-cliparts-groups>li").first().click();
	});

	//setup before functions
	var typingTimer;                //timer identifier
	var doneTypingInterval = 1000;  //time in ms, 5 second for example
	var $input = $('#pcd-cliparts-search');
	var $input_group_parent = $('#pcd-cliparts-group-parent-search');
	var $input_group = $('#pcd-cliparts-group-search');

//on keyup, start the countdown
	$input.on('keyup', function () {
	    clearTimeout(typingTimer);
	    typingTimer = setTimeout(doneTyping, doneTypingInterval);
	});
	//clipart_parent_group
	$input_group_parent.on('keyup', function () {
	    clearTimeout(typingTimer);
	    typingTimer = setTimeout(doneTyping_group_parent, doneTypingInterval);
	});
	//clipart_group
	$input_group.on('keyup', function () {
	    clearTimeout(typingTimer);
	    typingTimer = setTimeout(doneTyping_group, doneTypingInterval);
	});

//on keydown, clear the countdown 
	$input.on('keydown', function () {
	    clearTimeout(typingTimer);
	});

	//clipart_parent_group
	$input_group_parent.on('keydown', function () {
	    clearTimeout(typingTimer);
	});
	//clipart_group
	$input_group.on('keydown', function () {
	    clearTimeout(typingTimer);
	});

//user is "finished typing," do something
	function doneTyping() {
	    $("#pcd-search-cliparts-results").html("");
	    var searched_value = $input.val().toLowerCase();
	    var results = $('#pcd-all-cliparts .clipart-img').filter(function () {
		return $(this).attr('data-src').toLowerCase().indexOf(searched_value) > -1;
	    });
	    if (results.length)
		results.clone().appendTo("#pcd-search-cliparts-results");
	    else
		$("#pcd-search-cliparts-results").html(pcd.translated_strings.cliparts_search_no_result);

	    show_cliparts_search_results();
	}

	//clipart_parent_group
	function doneTyping_group_parent() {
	    $("#pcd-search-cliparts-group-parent-results").html("");
	    var searched_value = $input_group_parent.val().toLowerCase();
	    var results = $('.pcd-cliparts-groups-parent li').filter(function () {
		return $(this).attr('data-group-parent-name').toLowerCase().indexOf(searched_value) > -1;
	    });
	    if (results.length) {
		var get_result_clone = results.clone();
		$("#pcd-search-cliparts-group-parent-results").html(get_result_clone);
	    } else {
		$("#pcd-search-cliparts-group-parent-results").html(pcd.translated_strings.cliparts_search_no_result);
	    }

	    show_cliparts_group_parent_search_results();
	}
	//clipart_group
	function doneTyping_group() {
	    $("#pcd-search-cliparts-group-results").html("");
	    var searched_value = $input_group.val().toLowerCase();
	    var results = $('.pcd-cliparts-groups li').filter(function () {
		return $(this).attr('data-group-name').toLowerCase().indexOf(searched_value) > -1;
	    });
	    if (results.length) {
		var get_result_clone = results.clone();
		$("#pcd-search-cliparts-group-results").html(get_result_clone);
	    } else {
		$("#pcd-search-cliparts-group-results").html(pcd.translated_strings.cliparts_search_no_result);
	    }

	    show_cliparts_group_search_results();
	}
	function show_cliparts_group_parent_search_results()
	{
	    $(".pcd-cliparts-groups-parent").hide();
	    $("#pcd-search-cliparts-group-parent-results").show();
	}

	function show_cliparts_group_search_results()
	{
	    $(".pcd-cliparts-groups").hide();
	    $("#pcd-search-cliparts-group-results").show();
	}

	function show_cliparts_search_results()
	{
	    $("#pcd-all-cliparts").hide();
	    $("#pcd-search-cliparts-results").show();
	    setTimeout(function () {
		//$("#pcd-search-cliparts-results").trigger("scroll");
		init_lazy_loader("#pcd-search-cliparts-results");
	    }, 500);
	}

	function show_all_cliparts()
	{
	    $("#pcd-all-cliparts").show();
	    $("#pcd-search-cliparts-results").hide();
	}

	//Images
	$(document).on('click', '.clipart-img', function (e)
	{
	    if (e.target !== e.currentTarget)
		return;
	    if (!$(this).parent(".clipart-img").hasClass("image-uploaded") && !$(this).parent(".clipart-img").hasClass("image-bg"))
	    {
		var medium_url = $(this).attr("src");
		if (typeof medium_url == "undefined")
		    medium_url = $(this).attr("data-original");
//            console.log(medium_url);
		var price = $(this).data("price");
		add_img_on_editor(medium_url, price);
		$('#pcd-cliparts-modal').omodal("hide");

	    }
	});
	$(document).on('click', '.image-uploaded img', function ()
	{ if(!PCD_EDITOR.isEmpty(PCD_EDITOR.pcd_current_layout_image)){
	    $('.pcd-upload-notice').removeClass('active');
	    var box = PCD_EDITOR.pcd_current_layout_image.box;

	    if ("undefined" !== typeof (PCD_EDITOR.pcd_current_layout_image) && "undefined" !== typeof (PCD_EDITOR.findByClipName(box.clipFor))) {
		var medium_url = $(this).attr("src");
		if (typeof medium_url == "undefined")
		    medium_url = $(this).attr("data-original");

		var ext = medium_url.split('.').pop();

		if (ext == "svg")
		{
		    fabric.loadSVGFromURL(medium_url, function (objects, options) {
			var img1 = fabric.util.groupSVGElements(objects, options);
			pcd_editor.setCustomProperties(img1);
			var initial_height = img1.height;
			var initial_width = img1.width;
			img1.set('originX', box.originX);
			img1.set('originY', box.originY);
			img1.set('left', box.left);
			img1.set('top', box.top);
			img1.set('height', box.height);
			img1.set('width', (box.height * initial_width) / initial_height);
			img1.set('selectable', true);
			img1.set('strokeWidth', box.strokeWidth);
			img1.set('clipName', PCD_EDITOR.pcd_current_layout_image.get('clipName'));
			img1.set('box', PCD_EDITOR.pcd_current_layout_image.get('box'));
			img1.set('is_bounding_box_real_image', true);
			img1.set('clipTo', function (ctx) {
			    return _.bind(PCD_EDITOR.clipByName, img1)(ctx);
			});
			wp.hooks.doAction('PCD_EDITOR.before_adding_img_on_canvas', img1);

			PCD_EDITOR.canvas.add(img1);
			PCD_EDITOR.pcd_current_layout_image.remove();
			PCD_EDITOR.save_canvas();
		    });
		} else {
		    var pug1 = new fabric.Image.fromURL(medium_url, function (img1) {

			var initial_height = img1.height;
			var initial_width = img1.width;
			img1.set('originX', box.originX);
			img1.set('originY', box.originY);
			img1.set('left', box.left);
			img1.set('top', box.top);
			img1.set('height', box.height);
			img1.set('width', (box.height * initial_width) / initial_height);
			img1.set('selectable', true);
			img1.set('strokeWidth', box.strokeWidth);
			img1.set('clipName', PCD_EDITOR.pcd_current_layout_image.get('clipName'));
			img1.set('box', PCD_EDITOR.pcd_current_layout_image.get('box'));
			img1.set('is_bounding_box_real_image', true);
			img1.set('clipTo', function (ctx) {
			    return _.bind(PCD_EDITOR.clipByName, img1)(ctx);
			});

			PCD_EDITOR.canvas.add(img1);
			PCD_EDITOR.pcd_current_layout_image.remove();
			PCD_EDITOR.save_canvas();

		    });
		}

	    }
	}else{
		alert("Please First choose the box where you want to upload this image by clicking on the icon representing a camera located in the said box before clicking on the image to upload. ");
	}
	});

	$(document).on("click", "#wpc-add-img", function (e) {
	    e.preventDefault();
	    var selector = $(this).attr('data-selector');
	    var trigger = $(this);
	    var uploader = wp.media({
		title: 'Add image on the design area',
		button: {
		    text: "Add image"
		},
		multiple: false
	    })
		    .on('select', function () {
			var selection = uploader.state().get('selection');
			selection.map(
				function (attachment) {
				    attachment = attachment.toJSON();
				    add_img_on_editor(attachment.url);
				}
			)
		    })
		    .open();
	});

	$(".native-uploader #userfile").change(function () {
	    var file = $(this).val().toLowerCase();
	    if (file != "")
	    {
		$("#userfile_upload_form").ajaxForm({
		    success: upload_image_callback
		}).submit();
	    }
	});
	$('.drop a').click(function () {
	    // Simulate a click on the file input button
	    // to show the file browser dialog
	    $(this).parent().find('input').click();
	});

	if ($('#userfile_upload_form.custom-uploader').length)
	{

	    var userfile_ul = $('#userfile_upload_form.custom-uploader .acd-upload-info');
	    // Initialize the jQuery File Upload plugin
	    $('#userfile_upload_form.custom-uploader').fileupload({
		// This element will accept file drag/drop uploading
		dropZone: $('.drop'),
		url: ajax_object.ajax_url,
		// This function is called when a file is added to the queue;
		// either via the browse button, or via drag/drop:
		add: function (e, data) {
		    var tpl = $('<div class="working"><div class="acd-info"></div><div class="acd-progress-bar"><div class="acd-progress"></div></div></div>');

		    // Append the file name and file size
		    tpl.find('.acd-info').text(data.files[0].name).append('<i>' + formatFileSize(data.files[0].size) + '</i>');

		    // Add the HTML to the UL element
		    userfile_ul.html("");
		    data.context = tpl.appendTo(userfile_ul);

		    // Initialize the knob plugin
		    tpl.find('input').knob();

		    // Listen for clicks on the cancel icon
		    tpl.find('span').click(function () {

			if (tpl.hasClass('working')) {
			    jqXHR.abort();
			}

			tpl.fadeOut(function () {
			    tpl.remove();
			});

		    });

		    // Automatically upload the file once it is added to the queue
		    var jqXHR = data.submit();



		},
		progress: function (e, data) {

		    // Calculate the completion percentage of the upload
		    var progress = parseInt(data.loaded / data.total * 100, 10);
		    // Update the hidden input field and trigger a change
		    // so that the jQuery knob plugin knows to update the dial
		    //data.context.find('input').val(progress).change();
		    data.context.find('.acd-progress').css("width", progress + "%");

		    if (progress == 100) {
			data.context.removeClass('working');
		    }
		},
		fail: function (e, data) {
		    // Something has gone wrong!
		    data.context.addClass('error');
		},
		done: function (e, data) {
		    var name = data.files[0].name;
		    if (is_json(data.result)) {
			var response = $.parseJSON(data.result);
			if (response.is_bg_upload) {
			    upload_image_callback(data.result, false, false, false, true);
			    $('#no-bg-img').hide();
			} else {
			    upload_image_callback(data.result, false, false, false, false);
			    $('#no-uploaded-img').hide();
			}
		    }
		}
	    });
	}

//delete image on click on close icon
	$(document).on('touchstart click', 'span.pcd-del-img', function () {
	    var remove = $(this);
	    var img_id = $(this).parent(".clipart-img").find('img').attr("data-upload-id");
	    var img_name = $(this).parent(".clipart-img").find('img').attr("data-img-name");
	    var img_url = $(this).parent(".clipart-img").find('img').attr("data-url");
	    var is_bg_delete = 0;
	    if ($(this).hasClass('uploaded-bg-del')) {
		is_bg_delete = 1;
	    }
	    if (undefined !== img_id && undefined !== img_name && undefined !== img_url) {

		var frm_data = new FormData();
		frm_data.append("img_id", img_id);
		frm_data.append("img_name", img_name);
		frm_data.append("img_url", img_url);
		frm_data.append("is_bg_delete", is_bg_delete);

		frm_data.append("action", "pcd_handle_delete_picture_upload");
		$.ajax({
		    type: 'POST',
		    url: ajax_object.ajax_url,
		    data: frm_data,
		    processData: false,
		    contentType: false
		}).done(function (data) {
		    if (is_json(data))
		    {	
			var response = JSON.parse(data);
			if (1 === response) {
			    remove.parent(".clipart-img").remove();
			    alert("Upload delete successfuly!");
			} else {
			    alert("Delete fail!");
			}
		    }
		});
	    }
	});

	// Prevent the default action when a file is dropped on the window
	$(document).on('drop dragover', function (e) {
	    e.preventDefault();
	});

	$('.acd-grayscale').change(function ()
	{
	    apply_filter(new fabric.Image.filters.Grayscale(), $(this).is(':checked'));

	});

	$('.acd-invert').change(function () {
	    apply_filter(new fabric.Image.filters.Invert(), $(this).is(':checked'));
	});

	$('.acd-sepia').change(function () {
	    apply_filter(new fabric.Image.filters.Sepia(), $(this).is(':checked'));
	});

//	$('.acd-sepia2').change(function () {
//	    apply_filter(new fabric.Image.filters.Sepia2(), $(this).is(':checked'));
//	});

	$('.acd-blur').change(function () {
	    if ($(this).is(':checked'))
		$("#sharpen, #emboss").removeAttr('checked');

	    apply_filter(new fabric.Image.filters.Blur({
		blur: 0.5
	    }),
		    $(this).is(':checked'));
	});

	$('.acd-brownie').change(function ()
	{
	    apply_filter(new fabric.Image.filters.Brownie(), $(this).is(':checked'));

	});
	$('.acd-vintage').change(function ()
	{
	    apply_filter(new fabric.Image.filters.Vintage(), $(this).is(':checked'));

	});

	$('.acd-polaroid').change(function ()
	{
	    apply_filter(new fabric.Image.filters.Polaroid(), $(this).is(':checked'));

	});
	$('.acd-blackwhite').change(function ()
	{
	    apply_filter(new fabric.Image.filters.BlackWhite(), $(this).is(':checked'));

	});

	function apply_filter(filter, toApply) {
	    var selected_object = pcd_editor.canvas.getActiveObject();

	    var filter_index = jQuery.inArray(filter.type.toLowerCase(), pcd_editor.arr_filters);

	    if ((selected_object != null) && (selected_object.type == "image"))
	    {
		if (toApply)
		{
		    selected_object.filters[filter_index] = filter;
		} else {
		    selected_object.filters[filter_index] = false;
		}

		var timeStart = +new Date();
		var prevheigth = selected_object.heigth;
		var prevwidth = selected_object.width;
		selected_object.applyFilters();
		var timeEnd = +new Date();
		var dimString = pcd_editor.canvas.getActiveObject().width + ' x ' +
			pcd_editor.canvas.getActiveObject().height;
		$('bench').innerHTML = dimString + 'px ' +
			parseFloat(timeEnd - timeStart) + 'ms';
		pcd_editor.canvas.renderAll();
		pcd_editor.save_canvas();
	    }

	}

	pcd_editor.is_json = function (data)
	{
	    if (/^[\],:{}\s]*$/.test(data.replace(/\\["\\\/bfnrtu]/g, '@').
		    replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']').
		    replace(/(?:^|:|,)(?:\s*\[)+/g, '')))
		return true;
	    else
		return false;
	}

	function add_img_on_editor(url, price)
	{
	    var ext = url.split('.').pop();
	    if (typeof price == "undefined")
		price = 0;
	    if (ext == "svg")
	    {
		fabric.loadSVGFromURL(url, function (objects, options) {
		    var obj = fabric.util.groupSVGElements(objects, options);
		    optimize_img_width(obj);
		    pcd_editor.setCustomProperties(obj);
		    obj.set("price", price);
		    obj.set("originX", "center");
		    obj.set("originY", "center");
		    wp.hooks.doAction('PCD_EDITOR.before_adding_img_on_canvas', obj);
		    if (pcd_editor.box_center_x)
		    {
			pcd_editor.centerObject(obj);
			pcd_editor.canvas.add(obj).calcOffset().renderAll();
		    } else
		    {
			pcd_editor.canvas.add(obj);
			pcd_editor.centerObject(obj);
			pcd_editor.canvas.calcOffset().renderAll();
		    }
		    obj.setCoords();
		    pcd_editor.save_canvas();
		});
	    } else
	    {
		fabric.Image.fromURL(url, function (img)
		{
		    optimize_img_width(img);
		    pcd_editor.setCustomProperties(img);
		    img.set("price", price);
		    img.set("originX", "center");
		    img.set("originY", "center");
		    wp.hooks.doAction('PCD_EDITOR.before_adding_img_on_canvas', img);
		    if (pcd_editor.box_center_x)
		    {
			pcd_editor.canvas.add(img.set(
				{
				    angle: 0
				})
				).renderAll();
			pcd_editor.centerObject(img);
			pcd_editor.canvas.calcOffset().renderAll();
		    } else
		    {
			pcd_editor.canvas.add(img.set(
				{
				    angle: 0
				})
				);//.centerObject(img).renderAll();
			pcd_editor.centerObject(img);
			pcd_editor.canvas.calcOffset().renderAll();
		    }
		    wp.hooks.doAction('PCD_EDITOR.after_adding_img_on_canvas', img);

		    img.setCoords();
		    pcd_editor.save_canvas();
		}, {crossOrigin: 'anonymous'});
	    }
	}

	function optimize_img_width(obj)
	{
	    var displayable_area_width = pcd_editor.canvas.getWidth();
	    var displayable_area_height = pcd_editor.canvas.getHeight();
	    if (pcd.clip_w && pcd.clip_h && pcd.clip_w > 0 && pcd.clip_h > 0 && pcd.clip_type == "rect")
	    {
		displayable_area_width = pcd.clip_w;
		displayable_area_height = pcd.clip_h;
	    } else if (pcd.clip_r && pcd.clip_r > 0 && pcd.clip_type == "arc")
	    {
		displayable_area_width = pcd.clip_r;
		displayable_area_height = pcd.clip_r;
	    }
	    var dimensions = pcd_editor.get_img_best_fit_dimensions(obj, displayable_area_width, displayable_area_height);
	    var scaleW = displayable_area_width / dimensions[0];
	    var scaleH = displayable_area_height / dimensions[1];
	    if (scaleW > scaleH)
		obj.scaleToWidth(dimensions[0]);
	    else
		obj.scaleToHeight(dimensions[1]);
	    return dimensions;
	}

	function upload_image_callback(responseText, statusText, xhr, form, is_bg_upload)
	{
	    if (pcd_editor.is_json(responseText))
	    {
		var response = $.parseJSON(responseText);

		if (response.success)
		{
		    if (!is_bg_upload) {
			$("#acd-uploaded-img .pcd-cliparts-groups-parent").append(response.message);
//                        if (response.img_url)
//                            add_img_on_editor(response.img_url, 0);
		    } else {
			$("#acd-bg-uploaded-img .pcd-cliparts-groups-parent").append(response.message);
			if (response.img_url)
			    PCD_EDITOR.setBackgroundImage(response.img_url);
		    }

		    wp.hooks.applyFilters('pcd.after_upload_image');
		} else
		    alert(response.message);
	    } else
		$("#debug").html(responseText);
	    $("#userfile").val("");
	}

	// Helper function that formats the file sizes
	function formatFileSize(bytes) {
	    if (typeof bytes !== 'number') {
		return '';
	    }

	    if (bytes >= 1000000000) {
		return (bytes / 1000000000).toFixed(2) + ' GB';
	    }

	    if (bytes >= 1000000) {
		return (bytes / 1000000).toFixed(2) + ' MB';
	    }

	    return (bytes / 1000).toFixed(2) + ' KB';
	}
    });



    return pcd_editor;
}(jQuery, (PCD_EDITOR || {})))