var PCD_EDITOR = (function ($, pcd_editor) {
    'use strict';
    var pcd_editor = {};
    pcd_editor.canvas = {};
    pcd_editor.serialized_parts = {};
    pcd_editor.final_canvas_parts = {};
    pcd_editor.selected_index = "";
    pcd_editor.canvasManipulationsPosition = [];
    pcd_editor.box_center_x = false;
    pcd_editor.box_center_y = false;
    pcd_editor.scale_factor = false;
    pcd_editor.pcd_current_layout_image;
    pcd_editor.current_uploaded_image;
    pcd_editor.upload_image_path = pcd_upload_image_path;
    pcd_editor.show_notification = function (message)
    {
	$("#wpc-editor-container").prepend('<div class="pcd-notifications"><span class="wpc-tools-close fa fa-close"><span class="icon"></span></span><div class="pcd-item-notif">' + message + '</div></div>')
	$("#pcd-notifications").show();
    };

//    var output_multiplier = pcd.output_w / pcd.canvas_width;
    pcd_editor.isEmpty = function (value) {
	return typeof value == 'string' && !value.trim() || typeof value == 'undefined' || value === null || $.isEmptyObject(value);
    };
    pcd_editor.arr_filters = ['grayscale', 'invert', 'remove-white', 'sepia', 'sepia2',
	'brightness', 'noise', 'gradient-transparency', 'pixelate',
	'blur', 'convolute', 'brownie', 'vintage', 'polaroid', 'blackwhite'];
    $(document).ready(function () {
	if (typeof to_load !== "undefined") {
	    if (typeof to_load.output !== "undefined") {
		if (typeof to_load.output.form_fields !== "undefined") {
		    var fields = to_load.output.form_fields;
		    if (fields) {
			set_form_builder_preload_data(fields);
		    }
		}
	    }
	}



	function set_form_builder_preload_data(fields) {
	    $('form.formbuilt').find('[name]').each(function (index, value) {
		var that = $(this),
			name = that.attr('name'),
			type = that.prop('type');
		// console.log(name);
		if (type == 'select-one') {
		    $(that).find('[value]').each(function (index, value) {
			var option = $(this);
			var value = option.attr('value');
			for (var i in fields) {
			    if (name == i && value == fields[i]) {
				option.attr('selected', 'selected');
			    }
			}
		    });
		} else if (type == 'radio' || type == 'checkbox') {
		    var price = that.attr('data-price');
		    for (var i in fields) {
			if (name == i) {
			    if (typeof (fields[i]) == 'object') {
				var options = fields[i];
				for (var j in options) {
				    if (value.value == options[j]) {
					that.attr('checked', 'checked');
				    }
				}
			    } else {
				if (value.value == fields[i]) {
				    that.attr('checked', 'checked');
				}
			    }
			}
		    }
		} else if (type == 'file') {
		    for (var i in fields) {
			if (name == i) {
// that.prop('value', fields[i]);
// var file = that.prop('file');
// file[0]['name'] = fields[i];
			}
		    }
		} else {
		    for (var i in fields) {
			if (name == i) {
			    that.attr('value', fields[i]);
			}
		    }
		}
	    });
	    update_price();
	}

	function isEmpty(obj) {
	    for (var prop in obj) {
		if (obj.hasOwnProperty(prop))
		    return false;
	    }
	    return JSON.stringify(obj) === JSON.stringify({});
	}

	$("form.formbuilt input").change(function () {
	    update_price();
	});
	$("form.formbuilt textarea").change(function () {
	    update_price();
	});
	$("form.formbuilt select").change(function () {
	    update_price();
	});
	// $(".pcd-responsive-mode .wpc-editor-menu").toggle(
	//         function wpc_editor_menu_on() {

	//             $(".pcd-responsive-mode .wpc-editor-col:first-child").css("display", "inline-block");
	//         },
	//         function wpc_editor_menu_off() {

	//             $(".pcd-responsive-mode .wpc-editor-col:first-child").css("display", "none");

	//         }

	// );

	$(".pcd-responsive-mode .wpc-editor-menu-right").toggle(
		function () {

		    $(".pcd-responsive-mode .wpc-editor-col.right").css("display", "inline-block");
		},
		function () {

		    $(".pcd-responsive-mode .wpc-editor-col.right").css("display", "none");
		}

	);
	var resizeId;
	var tools_accordion = new Spry.Widget.Accordion("wpc-tools-box-container", {useFixedPanelHeights: false, defaultPanel: -1});
//        var cliparts_accordion= new Spry.Widget.Accordion("img-cliparts-accordion", {useFixedPanelHeights: false, defaultPanel: -1});
//        cliparts_accordion.onPanelTabClick()
	new Spry.Widget.Accordion("my-designs-accordion", {useFixedPanelHeights: false, defaultPanel: -1});
	$("[data-tooltip-title]").otooltip();
	//init_canvas();
	//init_empty_canvas_data_array();

	function get_optimal_canvas_dimensions()
	{
	    var available_width = $("#wpc-editor-container").outerWidth();
	    var canvas_w = 0;
	    var canvas_h = 0;
	    if (pcd.responsive == 1 && pcd.canvas_w > available_width)
	    {

		canvas_w = available_width;
		canvas_h = (canvas_w * pcd.canvas_h) / pcd.canvas_w;
	    } else
	    {
		canvas_w = pcd.canvas_w;
		canvas_h = pcd.canvas_h;
	    }

	    return [canvas_w, canvas_h];
	}

	/* $(document).on("click", "#wpc-parts-bar > li", function (e) {
	 if (pcd_editor.selected_part == $(this).index())
	 {
	 return;
	 } else
	 {
	 var part_index = $(this).index();
	 pcd_editor.load_background_overlay_if_needed(part_index);
	 $("#wpc-parts-bar > li").removeClass("active");
	 $(this).addClass("active");
	 if (pcd_editor.selected_part >= 0)
	 {
	 pcd_editor.save_canvas();
	 pcd_editor.canvas.clear();
	 }
	 pcd_editor.selected_part = $(this).index();
	 }
	 
	 var data_id = $(this).attr("data-id");
	 if (typeof pcd_editor.serialized_parts[data_id] == "undefined")//Fixe les parts non chargÃ©s lorsque le to_load est dÃ©fini
	 {
	 pcd_editor.serialized_parts[data_id] = [];
	 pcd_editor.canvasManipulationsPosition[data_id] = -1;
	 }
	 if (pcd_editor.serialized_parts[data_id][pcd_editor.canvasManipulationsPosition[data_id]])
	 {
	 //            resetZoom();
	 $.blockUI({message: pcd.translated_strings.loading_msg});
	 pcd_editor.canvas.loadFromJSON(pcd_editor.serialized_parts[data_id][pcd_editor.canvasManipulationsPosition[data_id]], function () {
	 pcd_editor.load_background_overlay_if_needed(part_index);
	 pcd_editor.rescale_canvas_if_needed();
	 $.unblockUI();
	 });
	 }
	 pcd_editor.refresh_undo_redo_status();
	 });*/


	init_canvas();
	// init_empty_canvas_data_array();
	$(document).on('click', 'li.phone-type-details', function () {

	    pcd.canvas_w = pcd_models[$(this).attr("data-modelid")]["cases"][$(this).attr("data-caseid")]["width"];
	    pcd.canvas_h = pcd_models[$(this).attr("data-modelid")]["cases"][$(this).attr("data-caseid")]["height"];
	    pcd.responsive = 1;
	    resize_canvas_if_needed($(this).data("index"));

	    if (pcd_editor.selected_index == $(this).data("index"))
	    {
		return;
	    } else
	    {
		if (pcd_editor.selected_index.search("_") !== -1)
		{
		    pcd_editor.save_canvas();
		    pcd_editor.canvas.clear();
		    pcd_editor.rescale_canvas_if_needed();
		}
		var case_index = $(this).data('index');
		pcd_editor.load_background_overlay_if_needed(case_index);
		$("li.phone-type-details").removeClass("active");
		$(this).addClass("active");
		pcd_editor.selected_index = $(this).data("index");

	    }
	    if (typeof to_load === 'undefined')
	    {
		var data_id = $(this).data("index");
		if (typeof pcd_editor.serialized_parts[data_id] == "undefined")//Fixe les parts non chargÃ©s lorsque le to_load est dÃ©fini
		{
		    pcd_editor.serialized_parts[data_id] = [];
		    pcd_editor.canvasManipulationsPosition[data_id] = -1;
		}
		if (pcd_editor.serialized_parts[data_id][pcd_editor.canvasManipulationsPosition[data_id]])
		{
		    //            resetZoom();
		    $.blockUI({message: pcd.translated_strings.loading_msg});
		    pcd_editor.canvas.loadFromJSON(pcd_editor.serialized_parts[data_id][pcd_editor.canvasManipulationsPosition[data_id]], function () {

			pcd_editor.clipto_after_load_from_json();
			pcd_editor.load_background_overlay_if_needed(data_id);
			pcd_editor.rescale_canvas_if_needed();
			$.unblockUI();
		    });
		}
		if (typeof to_load === 'undefined')
		{
		    $('li.layout-img[data-id="layout_1"]').trigger("click");
		}
		pcd_editor.refresh_undo_redo_status();
	    }

	});
//	PCD_EDITOR.init_case=function (model_name,model_tab){
//	    pcd.canvas_w = model_tab[model_name]["cases"][0]["width"];
//            pcd.canvas_h = model_tab[model_name]["cases"][0]["width"];
//            pcd.responsive = 1;
//            resize_canvas_if_needed(model_name);
//
//            if (pcd_editor.selected_index == model_name)
//            {
//                return;
//            } else
//            {
////                if (pcd_editor.selected_index.search("_") !== -1)
////                {
//                    pcd_editor.save_canvas();
//                    pcd_editor.canvas.clear();
//                    pcd_editor.rescale_canvas_if_needed();
////                }
//                var case_index = model_name;
//                pcd_editor.load_background_overlay_if_needed(case_index);
//                $("li.phone-type-details").removeClass("active");
//                $(this).addClass("active");
//                pcd_editor.selected_index = $(this).data("index");
//
//            }
//            if (typeof to_load === 'undefined')
//            {
//                var data_id = $(this).data("index");
//                if (typeof pcd_editor.serialized_parts[data_id] == "undefined")//Fixe les parts non chargÃ©s lorsque le to_load est dÃ©fini
//                {
//                    pcd_editor.serialized_parts[data_id] = [];
//                    pcd_editor.canvasManipulationsPosition[data_id] = -1;
//                }
//                if (pcd_editor.serialized_parts[data_id][pcd_editor.canvasManipulationsPosition[data_id]])
//                {
//                    //            resetZoom();
//                    $.blockUI({message: pcd.translated_strings.loading_msg});
//                    pcd_editor.canvas.loadFromJSON(pcd_editor.serialized_parts[data_id][pcd_editor.canvasManipulationsPosition[data_id]], function () {
//
//                        pcd_editor.clipto_after_load_from_json();
//                        pcd_editor.load_background_overlay_if_needed(data_id);
//                        pcd_editor.rescale_canvas_if_needed();
//                        $.unblockUI();
//                    });
//                }
//                if (typeof to_load === 'undefined')
//                {
//                    $('li.layout-img[data-id="layout_1"]').trigger("click");
//                }
//                pcd_editor.refresh_undo_redo_status();
//            }
//	};
	PCD_EDITOR.findByClipName = function (name) {
	    return _(pcd_editor.canvas.getObjects()).filter({
		clipFor: name
	    }).first();
	};
	PCD_EDITOR.clipByName = function (ctx) {

	    if (null !== this)
	    {

		this.setCoords();
		var clipRect = PCD_EDITOR.findByClipName(this.clipName);

		var scaleXTo1 = (1 / this.scaleX);
		var scaleYTo1 = (1 / this.scaleY);
		ctx.save();
		var ctxLeft = -(this.width / 2) + clipRect.strokeWidth;
		var ctxTop = -(this.height / 2) + clipRect.strokeWidth;
		var ctxWidth = clipRect.width - clipRect.strokeWidth;
		var ctxHeight = clipRect.height - clipRect.strokeWidth;
		ctx.translate(ctxLeft, ctxTop);
		ctx.scale(scaleXTo1, scaleYTo1);
		ctx.rotate(degToRad(this.angle * -1));
		ctx.beginPath();
		if ('rect' === clipRect.box_type)
		{
		    ctx.rect(
			    clipRect.left - this.oCoords.tl.x,
			    clipRect.top - this.oCoords.tl.y,
			    clipRect.width,
			    clipRect.height
			    );
		} else if ('circle' === clipRect.box_type)
		{
		    ctx.arc(
			    clipRect.left - this.oCoords.tl.x + clipRect.radius - clipRect.strokeWidth,
			    clipRect.top - this.oCoords.tl.y + clipRect.radius - clipRect.strokeWidth,
			    clipRect.radius - clipRect.strokeWidth,
			    0,
			    Math.PI * 2,
			    true
			    );
		} else if ('poly' === clipRect.box_type)
		{
		    var points = [];
		    var i = 0;
		    for (i in clipRect.points)
			points.push({
			    x:  clipRect.points[i].x - this.oCoords.tl.x - clipRect.strokeWidth,
			    y:  clipRect.points[i].y - this.oCoords.tl.y - clipRect.strokeWidth
			});

		    ctx.moveTo(points[0].x, points[0].y);
		    for (i = 1; i < points.length; ++i)
		    {
			ctx.lineTo(points[i].x, points[i].y);
		    }
		    ctx.lineTo(points[0].x, points[0].y);
		}
		ctx.closePath();
		ctx.restore();

	    }
	};
	function findByClipBylayoutName(layout_name) {

	    var boundind_boxs = _(pcd_editor.canvas.getObjects()).filter({
		layout_name: layout_name
	    });
	    return boundind_boxs;
	}

// Since the `angle` property of the Image object is stored 
// in degrees, we'll use this to convert it to radians.
	function degToRad(degrees) {
	    return degrees * (Math.PI / 180);
	}

	$(document).on('click', 'li.layout-img', function () {
	    var boundind_boxs = _(pcd_editor.canvas.getObjects()).filter({
		is_bounding_box: true
	    });
	    var boundind_boxs_uploaded_image = _(pcd_editor.canvas.getObjects()).filter({
		is_bounding_box_upload_image: true
	    });

	    var boundind_boxs_real_image = _(pcd_editor.canvas.getObjects()).filter({
		is_bounding_box_real_image: true
	    });
	    boundind_boxs_real_image.each(function (real_image) {
		real_image.remove();
	    });
	    boundind_boxs_uploaded_image.each(function (upload_image) {
		upload_image.remove();
	    });
	    boundind_boxs.each(function (box) {
		box.remove();
	    });


	    var layout_id = $(this).data("id");

	    var canvas = pcd_editor.canvas;
// Note the use of the `originX` and `originY` properties, which we set
// to 'left' and 'top', respectively. This makes the math in the `clipTo`
// functions a little bit more straight-forward.
	    var current_layout = PCD_EDITOR.pcd_layouts[layout_id];
	    var angle = 0;
	    $.each(current_layout['raws'], function (index_raw, raw) {
		$.each(raw, function (index_box, box) {
		    if ('undefined' != typeof (box.angle))
		    {
			angle = box.angle;
		    }
		    if ('rect' === box.type) {
			window['box_' + index_box + '_' + index_raw + '_' + layout_id] = new fabric.Rect({
			    originX: box.originX,
			    originY: box.originY,
			    angle: angle,
			    left: box.left * pcd.canvas_w,
			    top: box.top * pcd.canvas_h,
			    width: box.width * pcd.canvas_w,
			    height: box.height * pcd.canvas_h,
			    fill: 'transparent', /* use transparent for no fill */
			    strokeWidth: 0.2,
			    strokeDashArray: [5, 5],
			    stroke: 'red',
			    selectable: false
			});
// We give these `Rect` objects a name property so the `clipTo` functions can
// find the one by which they want to be clipped.
			window['box_' + index_box + '_' + index_raw + '_' + layout_id].set({
			    clipFor: 'box_' + index_box + '_' + index_raw + '_' + layout_id,
			    layout_name: layout_id,
			    clipId: 'box_' + index_box + '_' + index_raw + '_' + layout_id,
			    box_type: 'rect',
			    is_bounding_box: true
			});
			if ('layout_1' === layout_id)
			{
			    window['box_' + index_box + '_' + index_raw + '_' + layout_id].set({
				strokeWidth: 0
			    });
			}

			canvas.add(window['box_' + index_box + '_' + index_raw + '_' + layout_id]);


		    } else if ('cercle' === box.type)
		    {
			window['box_' + index_box + '_' + index_raw + '_' + layout_id] = new fabric.Circle({
			    originX: box.originX,
			    originY: box.originY,
			    angle: angle,
			    left: box.left * pcd.canvas_w,
			    top: box.top * pcd.canvas_h,
			    radius: box.radius * pcd.canvas_w,
			    fill: 'transparent', /* use transparent for no fill */
			    strokeWidth: 0.2,
			    strokeDashArray: [5, 5],
			    stroke: 'red',
			    selectable: false
			});
// We give these `Rect` objects a name property so the `clipTo` functions can
// find the one by which they want to be clipped.
			window['box_' + index_box + '_' + index_raw + '_' + layout_id].set({
			    clipFor: 'box_' + index_box + '_' + index_raw + '_' + layout_id,
			    layout_name: layout_id,
			    clipId: 'box_' + index_box + '_' + index_raw + '_' + layout_id,
			    box_type: 'circle',
			    is_bounding_box: true
			});

			canvas.add(window['box_' + index_box + '_' + index_raw + '_' + layout_id]);


		    } else if ('poly' === box.type)
		    {
			var box_points = [];
			$.each(box.points, function (index_point, point) {
			    box_points.push({x: point.x * pcd.canvas_w, y: point.y * pcd.canvas_h});
			});
			window['box_' + index_box + '_' + index_raw + '_' + layout_id] = new fabric.Polygon(
				box_points, {
				    originX: box.originX,
				    originY: box.originY,
				    angle: angle,
				    left: box.left * pcd.canvas_w,
				    top: box.top * pcd.canvas_h,
				    width: box.width * pcd.canvas_w,
				    height: box.height * pcd.canvas_h,
				    fill: 'transparent', /* use transparent for no fill */
				    strokeWidth: 0.2,
				    strokeDashArray: [5, 5],
				    stroke: 'red',
				    selectable: false
				});
// We give these `Rect` objects a name property so the `clipTo` functions can
// find the one by which they want to be clipped.
			window['box_' + index_box + '_' + index_raw + '_' + layout_id].set({
			    clipFor: 'box_' + index_box + '_' + index_raw + '_' + layout_id,
			    layout_name: layout_id,
			    clipId: 'box_' + index_box + '_' + index_raw + '_' + layout_id,
			    box_type: 'poly',
			    is_bounding_box: true
			});
			canvas.add(window['box_' + index_box + '_' + index_raw + '_' + layout_id]);
		    }
		    angle = 0;
		});

	    });




	    var img_angle = 0;
	    var first=true;
	    findByClipBylayoutName(layout_id).each(function (index) {
		
		window['box_img' + index.clipId] = new fabric.Image.fromURL(PCD_EDITOR.upload_image_path, function (img) {
		    img.setPositionByOrigin({x: index.get('left') + index.get('width') / 2, y: index.get('top') + index.get('height') / 2}, 'center', 'center');
		    img.setCoords();
		    img.set('strokeWidth', index.get('strokeWidth'));
		    img.set('selectable', false);
//		    img.set('width', 68.81);
//		    img.set('height', 56.75);
		    img.set('clipName', index.get('clipFor'));
		    img.set('box', index.toJSON(['lockMovementX', 'lockMovementY', 'lockRotation', 'lockScalingX', 'lockScalingY', 'price', 'lockDeletion', 'originalText', 'radius', 'spacing', 'clipFor', 'clipId', 'clipName', 'clipTo', 'layout_name', 'type', 'box', 'is_bounding_box', 'is_bounding_box_upload_image', 'is_bounding_box_real_image', 'box_type'])),
	            img.set('clipTo', function (ctx) {
				return _.bind(PCD_EDITOR.clipByName, img)(ctx);
			    });
		    img.set('is_bounding_box_upload_image', true);
		    img.on('mousedown', function (e) {
			$("#uploads-panel").trigger("click");
			if ($("#pcd-uploads-filters-wrap").hasClass("is-open"))
			{
			    $("#pcd-uploads-filters-wrap").removeClass("is-open");
			}
                        $('.pcd-upload-notice').addClass('active');
			pcd_editor.pcd_current_layout_image = this;
		    });
		    canvas.add(img);
		    canvas.renderAll();
		    if(first)
		    {
			pcd_editor.pcd_current_layout_image =img;
			first=false;
		    }


		});

	    });

	    setTimeout(function () {
		pcd_editor.save_canvas();
	    }, 3000);


	});

	function resize_canvas_if_needed(index)
	{
	    if (pcd_editor.selected_index != index)
	    {
		if (pcd.responsive != 1)
		    return false;
		var optimal_dimensions = get_optimal_canvas_dimensions();
		pcd_editor.canvas.setWidth(optimal_dimensions[0]);
		pcd_editor.canvas.setHeight(optimal_dimensions[1]);
		pcd_editor.canvas.renderAll();
	    }
	}
	function applyImageFilters() {
	    pcd_editor.canvas.forEachObject(function (obj) {
		if (obj.type === 'image' && obj.filters.length) {
		    obj.applyFilters();
		}
	    });
	}
	if (typeof to_load !== 'undefined')
	    setTimeout(function () {
		preload_canvas(to_load);
	    }, 500);
	function reformat_pcd_parameters_arr()
	{
	    var keys = ["canvas_h", "canvas_w", "clip_h", "clip_r", "clip_rr", "clip_w", "clip_x", "clip_y", "output_loop_delay", "output_w"];
	    var i = 0;
	    for (i = 0; i < keys.length; i++) {
		pcd[keys[i]] = parseFloat(pcd[keys[i]]);
	    }
	}

	function init_canvas()
	{

	    //Converts pcd elements strings into float to avoid formatting issues
	    reformat_pcd_parameters_arr();
	    //We determine the best dimensions to use
	    var optimal_dimensions = get_optimal_canvas_dimensions();
	    pcd_editor.canvas = new fabric.Canvas('wpc-editor', {width: optimal_dimensions[0], height: optimal_dimensions[1]});
	    pcd_editor.canvas.backgroundImageStretch = false;
	    set_clipping_area();
	    pcd_editor.canvas.renderAll();
	    load_canvas_listeners();
	    if (typeof pcd != 'undefined')
	    {
		accounting.settings = {
		    currency: {
			symbol: pcd.currency, // default currency symbol is '$'
			format: pcd.price_format, // controls output: %s = symbol, %v = value/number (can be object: see below)
			decimal: pcd.decimal_sep, // decimal point separator
			thousand: pcd.thousand_sep, // thousands separator
			precision: pcd.nb_decimals   // decimal places
		    },
		    number: {
			precision: pcd.nb_decimals, // default precision on numbers is 0
			thousand: pcd.thousand_sep,
			decimal: pcd.decimal_sep
		    }
		}
	    }
	}



	function add_rect_bounding_box(width, height, left, top, border)
	{

	    var rect = new fabric.Rect({
		left: parseFloat(left),
		top: parseFloat(top),
		fill: "transparent",
		opacity: 1,
		width: width,
		height: height,
		selectable: false,
		boundingBox: true,
	    });
	    if (border)
	    {
		rect.set("strokeWidth", 1);
		rect.set("stroke", border);
	    }

	    _setCustomProperties(rect);
//            console.log(rect.boundingBox);
	    pcd_editor.canvas.add(rect);
	    pcd_editor.canvas.renderAll();
	}

	function set_clipping_area()
	{
	    //We determine the best dimensions to use
	    var optimal_dimensions = get_optimal_canvas_dimensions();
	    pcd_editor.canvas.clipTo = null;
	    var scaleFactor = optimal_dimensions[0] / pcd.canvas_w;
	    if (scaleFactor != 1)
		pcd_editor.scale_factor = scaleFactor;
	    if (pcd.clip_w && pcd.clip_h && pcd.clip_w > 0 && pcd.clip_h > 0 && pcd.clip_type == "rect")
	    {
		var clip_x = (optimal_dimensions[0] - pcd.clip_w * scaleFactor) / 2;
		if (pcd.clip_x || pcd.clip_x == "0")
		{
		    clip_x = pcd.clip_x * scaleFactor;
		    pcd_editor.box_center_x = parseFloat(clip_x) + parseFloat(pcd.clip_w * scaleFactor) / 2;
		    console.log(pcd_editor.box_center_x);
		} else if (scaleFactor != 1)
		    pcd_editor.box_center_x = pcd.canvas_w / 2;
		else
		    pcd_editor.box_center_x = optimal_dimensions[0] / 2;
		var clip_y = (optimal_dimensions[1] - pcd.clip_h * scaleFactor) / 2;
		if (pcd.clip_y || pcd.clip_y == "0")
		{
		    clip_y = pcd.clip_y * scaleFactor;
		    pcd_editor.box_center_y = parseFloat(clip_y) + parseFloat(pcd.clip_h * scaleFactor) / 2;
		} else if (scaleFactor != 1)
		    pcd_editor.box_center_y = pcd.canvas_h / 2;
		else
		    pcd_editor.box_center_y = optimal_dimensions[1] / 2;
		pcd_editor.canvas.clipTo = function (ctx) {
		    if (pcd.clip_type == "rect" || pcd.clip_type == "")
		    {
			if (pcd.clip_rr > 0)
			    roundRect(ctx, (clip_x), (clip_y), parseFloat(pcd.clip_w * scaleFactor), parseFloat(pcd.clip_h * scaleFactor), parseFloat(pcd.clip_rr * scaleFactor), "", pcd.clip_border);
			else
			{
			    ctx.rect(clip_x, clip_y, pcd.clip_w * scaleFactor, pcd.clip_h * scaleFactor);
			    if (pcd.clip_border)
			    {
				ctx.strokeStyle = pcd.clip_border;
				ctx.stroke();
			    }
			}

		    }
		};
	    } else if (pcd.clip_r && pcd.clip_r > 0 && pcd.clip_type == "arc")
	    {
		var clip_x = pcd.canvas_w / 2;
		if (pcd.clip_x)
		    clip_x = pcd.clip_x * scaleFactor;
		var clip_y = optimal_dimensions[1] - pcd.clip_h * scaleFactor / 2;
		if (pcd.clip_y)
		    clip_y = pcd.clip_y;
		pcd_editor.canvas.clipTo = function (ctx) {
		    ctx.arc(clip_x, clip_y, pcd.clip_r * scaleFactor, 0, 2 * Math.PI);
		    if (pcd.clip_border)
		    {
			ctx.strokeStyle = pcd.clip_border;
			ctx.stroke();
		    }
		};
	    }
	}

	function load_canvas_listeners()
	{
	    pcd_editor.canvas.on('before:selection:cleared', function (options) {
		var image_type = open_src_panel(options);
		wp.hooks.doAction('PCD_EDITOR.object_deselected', options, image_type);
	    });
	    pcd_editor.canvas.on('object:selected', function (options) {
		//$("#cb-curved").removeAttr('checked');
		//$('.wpc-text-curved-wrap #cb-curved').parents('.wpc-text-curved-wrap').find('.wpc-text-curved-content').removeClass('is-active');
		wp.hooks.doAction('PCD_EDITOR.object_selected', options);
		if (options.target) {
		    var objectType = options.target.type;
//                   console.log(objectType);
//                    console.log(options.target.isSameColor && options.target.isSameColor() || !options.target.paths);
		    var arr_shapes = ["rect", "circle", "triangle", "polygon", "path"];
		    //console.log(options);
		    //console.log(objectType);
		    if (objectType == "i-text")
		    {
			//console.log(options.target.text);
//                        $("#text-tools").click();
			tools_accordion.openPanel("text-panel");
			wp.hooks.applyFilters('pcd.add_text_selected', options);
//                        var box_left=options.target.oCoords.br.x;
//                        var box_top=options.target.oCoords.br.y;
//                        $("#text-properties").css("left", box_left);
//                        $("#text-properties").css("top", box_top);
			$('#font-family-selector').val(options.target.get("fontFamily")); //.trigger('change');;
			$('#font-size-selector').val(options.target.get("fontSize"));
			$('#txt-color-selector .pcd-color-view').css("background-color", options.target.get("fill"));
			$('#txt-bg-color-selector .pcd-color-view').css("background-color", options.target.get("backgroundColor"));
			$('#new-text').val(options.target.get("text"));
			$(".txt-align[value='" + options.target.get("textAlign") + "']").attr('checked', 'checked');
			$(".txt-decoration[value='" + options.target.get("textDecoration") + "']").attr('checked', 'checked');
			var fontWeight = options.target.get("fontWeight");
			if (fontWeight == "bold")
			    $("#bold-cb").attr('checked', 'checked');
			else
			    $("#bold-cb").removeAttr('checked');
			var fontStyle = options.target.get("fontStyle");
			if (fontStyle == "italic")
			    $("#italic-cb").attr('checked', 'checked');
			else
			    $("#italic-cb").removeAttr('checked');
			if (options.target.get("stroke") != false && options.target.getStroke() != null)
			{
			    $('#txt-outline-color-selector').css("background-color", options.target.get("stroke"));
			    $('#o-thickness-slider').val(options.target.get("strokeWidth"));
			} else
			{
			    $('#o-thickness-slider').val(0);
			}

			var txt_opacity = options.target.opacity;
			$("#opacity-slider").val(txt_opacity);
		    } else if ((objectType == "group") && options.target.get("originalText"))
		    {
			//If it's a curved text, we load the first item properties (which should be the same than all other items
			if (options.target.get("originalText"))
			{
			    $("#cb-curved").attr('checked', 'checked');
			    tools_accordion.openPanel("text-panel");
			    // wp.hooks.applyFilters('pcd.add_text_selected',options);
			    $('.pcd-font-view').html(options.target.get("originalText"));
			    $('#font-family-selector').val(options.target.item(0).get("fontFamily")).trigger('change');
			    ;
			    $('#font-size-selector').val(options.target.item(0).get("fontSize"));
			    $('#txt-color-selector .pcd-color-view').css("background-color", options.target.item(0).get("fill"));
			    $('#txt-bg-color-selector .pcd-color-view').css("background-color", options.target.item(0).get("backgroundColor"));
			    $('#new-text').val(options.target.get("originalText"));
			    $("#curved-txt-radius-slider").val(options.target.get("radius"));
			    $("#curved-txt-spacing-slider").val(options.target.get("spacing"));
			    $(".txt-align[value='" + options.target.item(0).get("textAlign") + "']").attr('checked', 'checked');
			    $(".txt-decoration[value='" + options.target.item(0).get("textDecoration") + "']").attr('checked', 'checked');
			    var fontWeight = options.target.item(0).get("fontWeight");
			    if (fontWeight == "bold")
				$("#bold-cb").attr('checked', 'checked');
			    else
				$("#bold-cb").removeAttr('checked');
			    var fontStyle = options.target.item(0).get("fontStyle");
			    if (fontStyle == "italic")
				$("#italic-cb").attr('checked', 'checked');
			    else
				$("#italic-cb").removeAttr('checked');
			    if (options.target.item(0).get("stroke") != false && options.target.item(0).getStroke() != null)
			    {
				$('#txt-outline-color-selector').css("background-color", options.target.item(0).get("stroke"));
				$('#o-thickness-slider').val(options.target.item(0).get("strokeWidth"));
			    } else
			    {
				$('#o-thickness-slider').val(0);
			    }

			    var txt_opacity = options.target.item(0).opacity;
			    $("#opacity-slider").val(txt_opacity);
			}

		    } else if (jQuery.inArray(objectType, arr_shapes) >= 0)
		    {
			var shape_opacity = options.target.opacity;
			$("#shape-opacity-slider").val(shape_opacity);
			$('#shape-color-selector').css("background-color", options.target.get("fill"));
			$('#shape-outline-color-selector').css("background-color", options.target.get("stroke"));
			$("#shape-thickness-slider").val(options.target.get("strokeWidth"));
			wp.hooks.applyFilters('pcd.add_shape_selected');
			tools_accordion.openPanel("shapes-panel");
		    } else if (objectType == "image")
		    {
			//console.log(options.target);
			var img_src = options.target.getSrc();
			//console.log(img_src);
//                        var in_cliparts = $("#img-cliparts-accordion img[src='" + img_src + "']").length;
//                        var in_facebook = $("#facebook-panel img[src='" + img_src + "']").length;
//                        var in_instagram = $("#instagram-panel img[src='" + img_src + "']").length;
//
//                        if (in_cliparts)
//                            tools_accordion.openPanel("cliparts-panel");
//                        else if (in_facebook)
//                            tools_accordion.openPanel("facebook-panel");
//                        else if (in_instagram)
//                            tools_accordion.openPanel("instagram-panel");
//                        else
//                            tools_accordion.openPanel("uploads-panel");

//                        tools_accordion.openPanel("cliparts-panel");
			//wp.hooks.applyFilters('pcd.upload_img_selected');
			//wp.hooks.applyFilters('pcd.add_cliparts_selected');
			open_src_panel(options);
			var filters = options.target.filters;
			$("#img-effects input:checkbox").removeAttr('checked');
			$.each(filters, function (index, value) {
			    if (value)
			    {
				var filter = value.type;
				var matrix = value.matrix;
				var blur_matrix = [1 / 9, 1 / 9, 1 / 9, 1 / 9, 1 / 9, 1 / 9, 1 / 9, 1 / 9, 1 / 9];
				var sharpen_maxtrix = [0, -1, 0, -1, 5, -1, 0, -1, 0];
				var emboss_matrix = [1, 1, 1, 1, 0.7, -1, -1, -1, -1];
				if (filter == "Grayscale")
				    $(".acd-grayscale").attr('checked', 'checked');
				else if (filter == "Invert")
				    $(".acd-invert").attr('checked', 'checked');
				else if (filter == "Sepia")
				    $(".acd-sepia").attr('checked', 'checked');
				else if (filter == "Brownie")
				    $(".acd-brownie").attr('checked', 'checked');
				else if (filter == "Vintage")
				    $(".acd-vintage").attr('checked', 'checked');
				else if (filter == "Polaroid")
				    $(".acd-polaroid").attr('checked', 'checked');
				else if (filter == "Blackwhite")
				    $(".acd-blackwhite").attr('checked', 'checked');
				else if (filter == "Sepia2")
				    $(".acd-sepia2").attr('checked', 'checked');
				else if (filter == "Convolute")
				{
				    if (($(matrix).not(blur_matrix).length == 0 && $(blur_matrix).not(matrix).length == 0))
					$(".acd-blur").attr('checked', 'checked');
				    else if (($(matrix).not(sharpen_maxtrix).length == 0 && $(sharpen_maxtrix).not(matrix).length == 0))
					$(".acd-sharpen").attr('checked', 'checked');
				    else if (($(matrix).not(emboss_matrix).length == 0 && $(emboss_matrix).not(matrix).length == 0))
					$(".acd-emboss").attr('checked', 'checked');
				} else
				    console.log(filter, matrix);
			    }
			});
			var target = options.target;
			var image_type = open_src_panel(options);
			
			wp.hooks.doAction('PCD_EDITOR.image_selected', target, image_type);
		    } else if ((objectType == "path" || objectType == "path-group") || (objectType == "group") && pcd.svg_colorization != "none")
		    {
			var target = options.target;
			if ((objectType == "group")) {
			    wp.hooks.applyFilters('pcd.add_text_selected');
			}
			// wp.hooks.doAction('PCD_EDITOR.image_selected', target, image_type);
			// else{
			//    wp.hooks.applyFilters('pcd.upload_img_selected',target); 
			// }
			//tools_accordion.openPanel("uploads-panel");
			// $('#clipart-bg-color-selector').css("background-color",options.target.get("fill"));
			var active_tab = open_src_panel(options, "cliparts-panel");
			var target = options.target;
			var image_type = open_src_panel(options);
			console.log(active_tab);
			wp.hooks.doAction('PCD_EDITOR.image_selected', target, image_type);
			$("#" + active_tab + " .clipart-bg-color-container").html("");
			if (options.target.isSameColor && options.target.isSameColor() || !options.target.paths) {
			    var color_picker_id = 'clipart-bg-' + 1 + '-color-selector';
			    var colorpicker_tpl = '<span id="' + color_picker_id + '" class="svg-color-selector" data-placement="top" data-tooltip-title="' + pcd.translated_strings.svg_background_tooltip + '" style="background-color:' + options.target.get("fill") + '"></span>';
			    $("#" + active_tab + " .clipart-bg-color-container").append(colorpicker_tpl);
			    $("[data-tooltip-title]").otooltip();
			    load_svg_color_picker(color_picker_id);
			} else if (options.target.paths) {
			    var used_colors = [];
			    var picker_index = 0;
			    for (var i = 0; i < options.target.paths.length; i++) {
				var color_picker_id = 'clipart-bg-' + picker_index + '-color-selector';
				var current_color = options.target.paths[i].fill;
				var colorpicker_tpl = '<span id="' + color_picker_id + '" class="svg-color-selector" data-placement="top" data-tooltip-title="' + pcd.translated_strings.svg_background_tooltip + '" style="background-color:' + current_color + '" data-index="' + i + '"></span>';
				if (pcd.svg_colorization == "by-colors")
				{
				    var color_pos = jQuery.inArray(current_color, used_colors);
				    if (color_pos == -1)
				    {
					$("#" + active_tab + " .clipart-bg-color-container").append(colorpicker_tpl);
					$("[data-tooltip-title]").otooltip();
					load_svg_color_picker(color_picker_id);
					used_colors.push(current_color);
					picker_index++;
				    } else
				    {
					var original_picker_id = '#clipart-bg-' + color_pos + '-color-selector';
					var old_indexes = $(original_picker_id).attr("data-index");
					$(original_picker_id).attr("data-index", old_indexes + "," + i);
				    }
				} else
				{
				    $("#" + active_tab + " .clipart-bg-color-container").append(colorpicker_tpl);
				    $("[data-tooltip-title]").otooltip();
				    load_svg_color_picker(color_picker_id);
				    picker_index++;
				}
			    }
			}

		    }

		    if (options.target.get("lockMovementX"))
			$("#lock-mvt-x").attr('checked', 'checked');
		    else
			$("#lock-mvt-x").removeAttr('checked');
		    if (options.target.get("lockMovementY"))
			$("#lock-mvt-y").attr('checked', 'checked');
		    else
			$("#lock-mvt-y").removeAttr('checked');
		    if (options.target.get("lockScalingX"))
			$("#lock-scl-x").attr('checked', 'checked');
		    else
			$("#lock-scl-x").removeAttr('checked');
		    if (options.target.get("lockScalingY"))
			$("#lock-scl-y").attr('checked', 'checked');
		    else
			$("#lock-scl-y").removeAttr('checked');
		    if (options.target.get("lockDeletion"))
			$("#lock-Deletion").attr('checked', 'checked');
		    else
			$("#lock-Deletion").removeAttr('checked');
		}
	    });
	    pcd_editor.canvas.on('object:added', function (options) {
		if (options.target) {
		    pcd_editor.canvas.calcOffset();
		    pcd_editor.canvas.renderAll();
		    options.target.setCoords();
		    var objectType = options.target.type;
		    if (objectType == "i-text")
		    {
			reset_text_palette();
		    }
		    pcd_editor.canvas.calcOffset();
		}
	    });
	    pcd_editor.canvas.on('object:modified', function (options) {
		pcd_editor.canvas.calcOffset();
		pcd_editor.canvas.renderAll();
		options.target.setCoords();
		pcd_editor.save_canvas();
	    });
//            if (pcd.clip_w && pcd.clip_h && pcd.clip_w > 0 && pcd.clip_h > 0 && pcd.clip_type == "rect")
//            {
//                //Bounding box beta
//                pcd_editor.canvas.on("object:moving", function (event) {
//                    //We determine the best dimensions to use
//                    var optimal_dimensions = get_optimal_canvas_dimensions();
//                    var el = event.target;
//
//                    var ratio = optimal_dimensions[0] / pcd.canvas_w;
//                    var clip_w = parseFloat(pcd.clip_w * ratio);
//                    var clip_h = parseFloat(pcd.clip_h * ratio);
//
//                    var clip_x = (optimal_dimensions[0] - pcd.clip_w * ratio) / 2;
//                    if (pcd.clip_x || pcd.clip_x == "0")
//                    {
//                        clip_x = pcd.clip_x;
//                        pcd_editor.box_center_x = parseFloat(clip_x) + parseFloat(pcd.clip_w * ratio) / 2;
//                    }
//                    var clip_y = (optimal_dimensions[1] - pcd.clip_h * ratio) / 2;
//                    if (pcd.clip_y || pcd.clip_y == "0")
//                    {
//                        clip_y = pcd.clip_y;
//                        pcd_editor.box_center_y = parseFloat(clip_y) + parseFloat(pcd.clip_h * ratio) / 2;
//                    }
//
////                var section_pos = vpc.config.sections[el.section];
//                    if (el.left + el.width * el.scaleX > clip_w + clip_x)
//                        el.left = clip_w + clip_x - el.width * el.scaleX;
//                    else if (el.left < clip_x)
//                        el.left = clip_x;
//
//                    if (el.top + el.height * el.scaleY > clip_h + clip_y)
//                        el.top = clip_h + clip_y - el.height * el.scaleY;
//                    else if (el.top < clip_y)
//                        el.top = clip_y;
//                });
//            }
	}

	function _setCustomProperties(object)
	{
	    object.toObject = (function (toObject) {
		return function () {
		    if (!pcd_editor.isEmpty(this.box)) {
			return fabric.util.object.extend(toObject.call(this), {
			    lockMovementX: this.lockMovementX,
			    lockMovementY: this.lockMovementY,
			    lockScalingX: this.lockScalingX,
			    lockScalingY: this.lockScalingY,
			    lockDeletion: this.lockDeletion,
			    price: this.price,
			    originalText: this.originalText,
			    boundingBox: this.boundingBox,
			    clipName: this.clipName,
			    box: JSON.stringify(this.box.toJSON(['lockMovementX', 'lockMovementY', 'lockRotation', 'lockScalingX', 'lockScalingY', 'price', 'lockDeletion', 'originalText', 'radius', 'spacing', 'clipFor', 'clipId', 'clipName', 'clipTo', 'layout_name', 'type', 'box', 'is_bounding_box', 'is_bounding_box_upload_image', 'is_bounding_box_real_image', 'box_type'])),
			    is_bounding_box_real_image: this.is_bounding_box_real_image,
			    clipTo: this.clipTo,
			    radius: this.radius,
			    spacing: this.spacing
			});
		    } else
		    {
			return fabric.util.object.extend(toObject.call(this), {
			    lockMovementX: this.lockMovementX,
			    lockMovementY: this.lockMovementY,
			    lockScalingX: this.lockScalingX,
			    lockScalingY: this.lockScalingY,
			    lockDeletion: this.lockDeletion,
			    price: this.price,
			    originalText: this.originalText,
			    boundingBox: this.boundingBox,
			    clipName: this.clipName,
			    is_bounding_box_real_image: this.is_bounding_box_real_image,
			    clipTo: this.clipTo,
			    radius: this.radius,
			    spacing: this.spacing
			});
		    }
		};
	    })(object.toObject);
	}
	pcd_editor.setCustomProperties = function (object)
	{
	    _setCustomProperties(object);
	}

	pcd_editor.is_json = function (data)
	{
	    if (/^[\],:{}\s]*$/.test(data.replace(/\\["\\\/bfnrtu]/g, '@').
		    replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']').
		    replace(/(?:^|:|,)(?:\s*\[)+/g, '')))
		return true;
	    else
		return false;
	}

	pcd_editor.save_canvas = function ()
	{
	    var data_id = $('li.phone-type-details[data-index="' + pcd_editor.selected_index + '"]').attr("data-index");
	    if (typeof pcd_editor.serialized_parts[data_id] == "undefined")
		pcd_editor.serialized_parts[data_id] = ["{}"];
	    var i;
	    for (i = pcd_editor.canvasManipulationsPosition[data_id]; i <= pcd_editor.serialized_parts[data_id].length - 2; i++)
	    {
		pcd_editor.serialized_parts[data_id].pop();
	    }

	    pcd_editor.canvasManipulationsPosition[data_id]++;
	    var json = JSON.stringify(pcd_editor.canvas.toJSON(['lockMovementX', 'lockMovementY', 'lockRotation', 'lockScalingX', 'lockScalingY', 'price', 'lockDeletion', 'originalText', 'radius', 'spacing', 'clipFor', 'clipId', 'clipName', 'clipTo', 'layout_name', 'type', 'box', 'is_bounding_box', 'is_bounding_box_upload_image', 'is_bounding_box_real_image', 'box_type']));
	    pcd_editor.serialized_parts[data_id].push(json);
	    //update_price();
	    pcd_editor.refresh_undo_redo_status();
	};

	pcd_editor.reload_background_overlay_if_needed = function (index, callback)
	{
	    pcd_editor.load_background_overlay_if_needed(index, callback);
	    $('li.layout-img[data-id="layout_1"]').trigger("click");
	};

	pcd_editor.centerObjectH = function (object)
	{
	    if (pcd_editor.box_center_x)
	    {
		if (pcd_editor.scale_factor && pcd.clip_x)
		{
		    object.set("left", pcd_editor.box_center_x / pcd_editor.scale_factor);
		} else
		    object.set("left", pcd_editor.box_center_x);
	    } else
	    {
		var realWidth = object.getWidth();
		//We make sure we're making our calculations based on the scaled width
		if (pcd_editor.scale_factor)
		    realWidth = realWidth * pcd_editor.scale_factor;
		var left = (parseFloat(pcd.canvas_w)) / 2;
		if (pcd_editor.box_center_x)
		    left = pcd_editor.box_center_x - realWidth / 2;
//                console.log(object.originX);
		if (object.originX == 'left')
		    left = left - (realWidth / 2);
		//When the responsive mode is enabled, the scale factor already applies  as zoom 
		//so we remove it before setting the left
//                if (pcd_editor.scale_factor)
//                    left = left * pcd_editor.scale_factor;
//                console.log(left);

		object.set("left", left);
	    }
	}

	pcd_editor.centerObjectV = function (object)
	{
	    if (pcd_editor.box_center_y)
	    {
		if (pcd_editor.scale_factor && pcd.clip_y)
		    object.set("top", pcd_editor.box_center_y / pcd_editor.scale_factor);
		else
		    object.set("top", pcd_editor.box_center_y);
	    } else
	    {
		var realHeight = object.getHeight();
		//We make sure we're making our calculations based on the scaled height
		if (pcd_editor.scale_factor)
		    realHeight = realHeight * pcd_editor.scale_factor;
		var top = (parseFloat(pcd.canvas_h)) / 2;
		if (pcd_editor.box_center_y)
		    top = parseFloat(pcd_editor.box_center_y) - realHeight / 2;
		//When the responsive mode is enabled, the scale factor already applies as zoom
		//so we remove it before setting the top
//                if (pcd_editor.scale_factor)
//                    top = top * pcd_editor.scale_factor;

		object.set("top", top);
	    }
	}

	pcd_editor.centerObject = function (object)
	{
	    pcd_editor.centerObjectV(object);
	    pcd_editor.centerObjectH(object);
	}

	pcd_editor.change_item_color = function (id, hex)
	{

	    id = id + " .pcd-color-view";
	    $('#' + id).css('background-color', '#' + hex);
	    var selected_object = pcd_editor.canvas.getActiveObject();
	    if ((selected_object != null) && (selected_object.type != "group"))
	    {

		wpc_set_color(id, selected_object, hex);
	    } else if ((selected_object != null) && (selected_object.type == "group"))
	    {
		selected_object.forEachObject(function (a) {
		    wpc_set_color(id, a, hex);
		});
	    }
	}

	function open_src_panel(options, default_panel)
	{
	    var obj = options.target.toObject();
	    var img_src = obj.src;
	    var in_cliparts = $("#pcd-all-cliparts img[src='" + img_src + "']").length;
	    var in_facebook = $("#facebook-panel img[src='" + img_src + "']").length;
	    var in_instagram = $("#instagram-panel img[src='" + img_src + "']").length;
	    var in_uploads = $("#uploads-panel img[src='" + img_src + "']").length;
	    if (in_cliparts)
		tools_accordion.openPanel("cliparts-panel");
	    else if (in_facebook)
		tools_accordion.openPanel("facebook-panel");
	    else if (in_instagram)
		tools_accordion.openPanel("instagram-panel");
	    else if (!in_uploads && typeof default_panel != "undefined")
		tools_accordion.openPanel(default_panel);
	    else
		tools_accordion.openPanel("uploads-panel");
	    if (in_cliparts)
		return "cliparts-panel";
	    else if (in_facebook)
		return "facebook-panel";
	    else if (in_instagram)
		return "instagram-panel";
	    else if (!in_uploads && typeof default_panel != "undefined")
		return default_panel;
	    else
		return "uploads-panel";
	}


	function wpc_set_color(id, selected_object, hex)
	{

	    if ((id == "txt-color-selector .pcd-color-view") || (id == "shape-color-selector") || id == "clipart-bg-color-selector") {

		selected_object.set("fill", '#' + hex)
	    } else if (id == "txt-bg-color-selector .pcd-color-view")
		selected_object.set("backgroundColor", '#' + hex);
	    else if (id == "txt-outline-color-selector" || id == "shape-outline-color-selector")
		selected_object.set("stroke", '#' + hex);
	    else
		console.log("unknow color selector :#" + id);
	    wp.hooks.doAction('PCD_EDITOR.element_color_changed', id, selected_object, hex);
	    pcd_editor.canvas.renderAll();
	}

	pcd_editor.refresh_undo_redo_status = function ()
	{
	    var data_id = $('li.phone-type-details[data-index="' + pcd_editor.selected_index + '"]').attr("data-index");
	    if ((pcd_editor.serialized_parts[data_id].length == 1) || (pcd_editor.canvasManipulationsPosition[data_id] == 0))
		$("#undo-btn").addClass("disabled");
	    else
		$("#undo-btn").removeClass("disabled");
	    if ((pcd_editor.serialized_parts[data_id].length > 0) && (pcd_editor.canvasManipulationsPosition[data_id] < pcd_editor.serialized_parts[data_id].length - 1))
		$("#redo-btn").removeClass("disabled");
	    else
		$("#redo-btn").addClass("disabled");
	}

	function update_price()
	{
	    var variations = {};
	    var tpl = pcd.query_vars["tpl"];
	    if (typeof tpl == 'undefined')
		tpl = "";
	    $.each($(".wpc-qty-container"), function (key, curr_object) {
		var qty = $(this).find(".pcd-qty").val();
		variations[$(this).data("id")] = qty;
	    });
	    var parts_json = {};

	    var data_id = $('li.phone-type-details[data-index="' + pcd_editor.selected_index + '"]').attr("data-index");
	    if ((pcd_editor.serialized_parts[data_id]))
	    {
		var x = {};
		x["json"] = pcd_editor.serialized_parts[data_id][pcd_editor.canvasManipulationsPosition[data_id]];
		parts_json[data_id] = x;
	    }

	    var variation_id = pcd.global_variation_id;
	    var tthat = $('form.formbuilt');
	    if (tthat.length !== 0) {
		var form_fields = tthat.serializeJSON();
		delete form_fields.id_ofb;
		parts_json["form_fields"] = form_fields;
		parts_json["variation_id"] = variation_id;
	    }


	    $.post(
		    ajax_object.ajax_url,
		    {
			action: "get_design_price",
			variations: variations,
			serialized_parts: JSON.stringify(parts_json),
			tpl: tpl

		    },
		    function (data) {
			if (pcd_editor.is_json(data))
			{
			    var response = JSON.parse(data);
			    $.each($(".wpc-qty-container"), function (key, curr_object) {
				var variation_id = $(this).data("id");
				var price = response.prices[variation_id];
				var qty = $(this).find(".pcd-qty");
				$(this).find(".total_order").html(accounting.formatMoney(price));
				qty.attr("uprice", price);
				qty.trigger('change');
			    });
			} else
			    $("#debug").html(data);
		    }
	    );


	}
	pcd_editor.clipto_after_load_from_json = function () {
	    var boundind_boxs = _(pcd_editor.canvas.getObjects()).filter({
		is_bounding_box: true
	    });
	    var boundind_boxs_uploaded_image = _(pcd_editor.canvas.getObjects()).filter({
		is_bounding_box_upload_image: true
	    });
	    boundind_boxs.each(function (boundingbox) {
		boundingbox.set('selectable', false);
	    });
	    boundind_boxs_uploaded_image.each(function (click_to_upload_img) {
		click_to_upload_img.set('clipTo', function (ctx) {
		    return _.bind(PCD_EDITOR.clipByName, click_to_upload_img)(ctx);
		});
		click_to_upload_img.set('selectable', false);
		click_to_upload_img.on('mousedown', function (e) {
		    $("#uploads-panel").trigger("click");
		    if ($("#pcd-uploads-filters-wrap").hasClass("is-open"))
		    {
			$("#pcd-uploads-filters-wrap").removeClass("is-open");
		    }
                    $('.pcd-upload-notice').addClass('active');
		    pcd_editor.pcd_current_layout_image = this;
		});
	    });
	    var bounding_box_real_image = _(pcd_editor.canvas.getObjects()).filter({
		is_bounding_box_real_image: true
	    });

	    bounding_box_real_image.each(function (real_image) {
		real_image.set('clipTo', function (ctx) {
		    return _.bind(PCD_EDITOR.clipByName, real_image)(ctx);
		});
	    });
	    //console.log(bounding_box_real_image);
	    pcd_editor.canvas.renderAll.bind(pcd_editor.canvas);
	};
	function preload_canvas(data)
	{

	    var part_index = '';
	    if (typeof data == "object")
	    {
		var found_match = false;
		$.each(data, function (index, value) {

		    $.each(value, function (index1, value1) {
			if ("json" === index1 && "output" !== index)
			{
			    part_index = index;
			    pcd_editor.serialized_parts[index] = [];
			    pcd_editor.canvasManipulationsPosition[index] = 0;
			    var json_value = value1;
			    pcd_editor.serialized_parts[index].push(json_value);

			    found_match = true;
			    pcd_editor.selected_part = 0;

			    pcd_editor.canvas.loadFromJSON(json_value, function () {
				pcd_editor.clipto_after_load_from_json();
				var modelid = part_index.split('_')[0];
				var caseid = part_index.split('_')[1];
				var brand = pcd_models[modelid]["brand"];
				$('li.brand-name[data-value="' + brand + '"]').trigger("click");
				$('li.model-name[data-value="' + modelid + '"]').trigger("click");
				$('li.phone-type-details[data-index="' + part_index + '"]').trigger("click");
				pcd_editor.load_background_overlay_if_needed(index);
				pcd_editor.rescale_canvas_if_needed();
			    });
			    pcd_editor.canvas.calcOffset();
			    //load_first_part_img();
			    if (json_value.indexOf('{"type":"text"') > -1) {
				fabric_text_to_itext();
			    }


			}
		    });
		});
//                if (!found_match)
//                {
//                    if (typeof to_load !== 'undefined')
//                    {
//                        if ('' !== part_index)
//                        {
//
//                            var modelid = part_index.split('_')[0];
//                            var caseid = part_index.split('_')[1];
//                            var brand = pcd_models[modelid]["brand"];
//                            $('li.brand-name[data-value="' + brand + '"]').trigger("click");
//                            $('li.model-name[data-value="' + modelid + '"]').trigger("click");
//                            $('li.phone-type-details[data-index="' + part_index + '"]').trigger("click");
//
//                        }
//                    } else {
//                        if ($('li.phone-type-details[data-default="1"]').length)
//                        {
//                            //$('li.phone-type-details[data-default="1"]').trigger("click");
//                            setTimeout(function () {
//                                $('li.phone-type-details[data-default="1"]').trigger("click");
//                            }, 1000);
//                        } else if ($('li.phone-type-details').first().length)
//                        {
//                            setTimeout(function () {
//                                $('li.phone-type-details').first().trigger("click");
//                            }, 1000);
//                        }
//                    }
//                } else {
//                    pcd_editor.load_background_overlay_if_needed(0);
//                }//Make sure the first part data are loaded when preloading the canvas
	    }
	    setTimeout(function () {
		pcd_editor.canvas.renderAll();
	    }, 500);
	}


	function load_first_part_img()
	{
	    var bg_included = "";
	    if ($('li.phone-type-details[data-default="1"]').length)
	    {

		bg_included = $('li.phone-type-details[data-default="1"]').attr("data-url");

	    } else if ($('li.phone-type-details').first().length)
	    {

		bg_included = $('li.phone-type-details').first().attr("data-url");

	    }
	    var bg_code = "url('" + bg_included + "') no-repeat center center";
	    $("wpc-editor-container .canvas-container").css("background", bg_code);
	}

//        function init_empty_canvas_data_array()
//        {
//            if (typeof to_load == 'undefined')
//            {
//               
//                    var data_id = $('li.phone-type-details[data-index="' + pcd_editor.selected_index + '"]').attr("data-index");
//                    pcd_editor.serialized_parts[data_id] = [];
//                    pcd_editor.canvasManipulationsPosition[data_id] = -1;
//                    var nb_parts = $("#wpc-parts-bar > li").length;
//                    if (key == nb_parts - 1)
//                    {
//                        loop_through_parts(pcd.output_loop_delay, click_on_part,
//                                function () {
//                                    $("#wpc-parts-bar > li").first().click();
//                                    pcd_editor.canvas.renderAll();
//                                    pcd_editor.rescale_canvas_if_needed();
//                                    $.unblockUI();
//                                });
//                    }
//                
//            }
//        }

	function click_on_part(part_index)
	{
	    $('li.phone-type-details[data-index="' + part_index + '"]').click();
	}

	function loop_through_parts(delay, loop_callback, end_callback)
	{
	    $.blockUI({message: pcd.translated_strings.loading_msg});
	    //var nb_parts = 1;
	    var current_part = pcd_editor.selected_index;
	    var loopKey = setInterval(function () {
		if ($.isFunction(loop_callback))
		    loop_callback(current_part);
//                if (current_part == nb_parts - 1)
//                {
		window.clearInterval(loopKey);
		if ($.isFunction(end_callback))
		{
		    setTimeout(function () {
			end_callback();
		    }, delay);
		} else
		    $.unblockUI();
//                } else
//                    current_part++;
	    }, delay);
	}

	pcd_editor.load_background_overlay_if_needed = function (index, callback, generating_output)
	{
	    var selector = $('li.phone-type-details[data-index="' + index + '"]');
	    var overlay_not_included = selector.attr("data-ovni");
	    if (typeof generating_output == 'undefined')
		generating_output = false;
	    var canvas_bg = selector.attr("data-bg");
	    var canvas_bgcolor = selector.attr("data-bgcolor");
	    if (canvas_bg == "")
		canvas_bg = null;
	    if (canvas_bgcolor == "")
		canvas_bgcolor = null;
	    var canvas_ov = selector.data("ov");
	    if (canvas_ov == "")
		canvas_ov = null;
	    var bg_img = new Image();
	    //Both background and overlay images consider the scale when being defined so we don't need to resize them
	    bg_img.onload = function () {
		var dimensions = pcd_editor.get_img_best_fit_dimensions(bg_img, pcd.canvas_w, pcd.canvas_h);
		pcd_editor.canvas.setBackgroundImage(bg_img.src, pcd_editor.canvas.renderAll.bind(pcd_editor.canvas), {
		    left: pcd.canvas_w / 2,
		    top: pcd.canvas_h / 2,
		    originX: 'center',
		    originY: 'center',
		    width: dimensions[0],
		    height: dimensions[1]
		});
	    };
	    if (canvas_bg != null)
		bg_img.src = canvas_bg;
	    else
		pcd_editor.canvas.backgroundImage = null;

	    if (canvas_bgcolor != null)
		pcd_editor.canvas.setBackgroundColor(canvas_bgcolor, pcd_editor.canvas.renderAll.bind(pcd_editor.canvas));
	    else
		pcd_editor.canvas.setBackgroundColor("", pcd_editor.canvas.renderAll.bind(pcd_editor.canvas));
	    ;
	    if (overlay_not_included == "-1" && generating_output)
	    {
		//White bg if CMYK mode
		if (pcd.output_format == "jpg")
		{
		    pcd_editor.canvas.setBackgroundColor("rgba(255, 255, 255, 1)", pcd_editor.canvas.renderAll.bind(pcd_editor.canvas));
		}
		pcd_editor.canvas.overlayImage = null;
		pcd_editor.canvas.renderAll.bind(pcd_editor.canvas);
	    } else
	    {
		//White bg if CMYK mode
		if (pcd.output_format == "jpg")
		{
		    pcd_editor.canvas.setBackgroundColor("", pcd_editor.canvas.renderAll.bind(pcd_editor.canvas));
		}
		var ov_img = new Image();
		ov_img.onload = function () {
		    var dimensions = pcd_editor.get_img_best_fit_dimensions(ov_img, pcd.canvas_w, pcd.canvas_h);
		    pcd_editor.canvas.setOverlayImage(ov_img.src, pcd_editor.canvas.renderAll.bind(pcd_editor.canvas), {
			left: pcd.canvas_w / 2,
			top: pcd.canvas_h / 2,
			originX: 'center',
			originY: 'center',
			width: dimensions[0],
			height: dimensions[1]
		    });
		};
		if (canvas_ov != null)
		    ov_img.src = canvas_ov;
		else
		    pcd_editor.canvas.overlayImage = null;
	    }

	    //Background not included
	    var bg_not_included_url = selector.attr("data-url");
	    if (bg_not_included_url == "")
		bg_not_included_url = null;
	    if (null != bg_not_included_url)
	    {
		var bg_code = "url('" + bg_not_included_url + "')";
		$("#wpc-editor-container .canvas-container").css("background-image", bg_code);
	    } else {
		$("#wpc-editor-container .canvas-container").css("background-image", "none");
	    }
	    if ($.isFunction(callback))
		setTimeout(function () {
		    callback(index);
		}, 200);
	}

	pcd_editor.get_img_best_fit_dimensions = function (img, max_width, max_height)
	{
	    var w = img.width;
	    var h = img.height;
	    if (w < max_width && h < max_height)
		return [w, h];
	    var ratio = w / h;
	    w = max_width;
	    h = max_width / ratio;
	    if (h > max_height)
	    {
		h = max_height;
		w = max_height * ratio;
	    }
//            var new_w=wp.hooks.applyFilters('PCD_EDITOR.pcd_img_width', w, img);
//            console.log(new_w);
	    return wp.hooks.applyFilters('PCD_EDITOR.pcd_img_dimensions', [w, h], img);
	}

	function load_svg_color_picker(id)
	{
	    var selector = $('#' + id);
	    var index = selector.data("index");
	    var initial_color = selector.css("background-color");
	    if (!initial_color)
		initial_color = "#0000ff";
	    if (pcd.palette_type == "custom")
	    {
		selector.qtip({
		    content: "<div class='wpc-custom-svg-colors-container' data-id='" + id + "' data-index='" + index + "'>" + pcd.palette_tpl + "</div>",
		    position: {
			corner: {
			    target: 'middleRight',
			    tooltip: 'leftTop'
			}
		    },
		    style: {
			width: 200,
			padding: 5,
			background: 'white',
			color: 'black',
			//                        textAlign: 'center',
			border: {
			    width: 1,
			    radius: 1,
			    color: '#08AED6'
			}
		    },
		    tip: 'bottomLeft',
		    show: 'click',
		    hide: {when: {event: 'unfocus'}}
		});
	    } else
	    {
		selector.ColorPicker({
		    color: initial_color,
		    onShow: function (colpkr) {
			$(colpkr).fadeIn(500);
			return false;
		    },
		    onHide: function (colpkr) {
			$(colpkr).fadeOut(500);
			var selected_object = pcd_editor.canvas.getActiveObject();
			if ((selected_object != null))
			{
			    pcd_editor.save_canvas();
			}
			return false;
		    },
		    onChange: function (hsb, hex, rgb) {
			change_svg_color(id, hex, index);
		    }
		});
	    }
	}

	function change_svg_color(id, hex, index)
	{
	    $('#' + id).css('background-color', '#' + hex);
	    var selected_object = pcd_editor.canvas.getActiveObject();
	    if ((selected_object != null) && (selected_object.type == "path" || selected_object.type == "path-group" || selected_object.type == "group"))
	    {
		{
		    if (selected_object.isSameColor && selected_object.isSameColor() || !selected_object.paths) {
			selected_object.set("fill", '#' + hex);
		    } else if (selected_object.paths) {
			if (pcd.svg_colorization == "by-colors")
			{
			    index = $("#" + id).attr("data-index");
			    var indexes = index.split(',');
			    $.each(indexes, function (key, value)
			    {
				selected_object.paths[value].setFill('#' + hex);
			    });
			} else
			    selected_object.paths[index].setFill('#' + hex);
		    }
		}
		pcd_editor.canvas.renderAll();
	    }
	}

	$(document).on("click", ".wpc-custom-colors-container span", function (e) {
	    var id = $(this).parent().data("id");
	    var hex = $(this).data("color");
	    pcd_editor.change_item_color(id, hex);
	});
	$(document).on("click", ".wpc-custom-svg-colors-container span", function (e) {
	    var id = $(this).parent().data("id");
	    console.log(id);
	    var index = $(this).parent().data("index");
	    var hex = $(this).data("color");
	    change_svg_color(id, hex, index);
	});
	function fabric_text_to_itext() {
	    //Array of property which will be used to create the i-text object
	    var text_prop_array = ['active', 'angle', 'backgroundColor', 'clipTo', 'currentHeight', 'currentWidth', 'fill', 'currentWidth', 'flipX', 'flipY', 'fontFamily', 'fontSize', 'fontStyle', 'fontWeight', 'height', 'left', 'lineHeight', 'originX', 'originY', 'scaleX', 'scaleY', 'shadow', 'text', 'textAlign', 'textBackgroundColor', 'textDecoration', 'top', 'width', 'lockMovementX', 'lockMovementY', 'lockRotation', 'lockScalingX', 'lockScalingY', 'lockUniScaling'];
	    setTimeout(function () {
		var canvas_objs = pcd_editor.canvas.getObjects().map(function (o) {
		    return o;
		});
		$.each(canvas_objs, function (obj_index, obj_value) {
		    if (obj_value.type == 'text') {
			var itext = new fabric.IText("");
			$.each(text_prop_array, function (prop_index, prop_name) {
			    itext.set(prop_name, obj_value.get(prop_name));
			});
			pcd_editor.canvas.remove(obj_value);
			pcd_editor.canvas.add(itext);
		    }
		});
		pcd_editor.canvas.renderAll.bind(pcd_editor.canvas);
	    }, 3600);
	}

	function reset_text_palette()
	{
	    $("#new-text").val("");
	    $(".txt-align").removeAttr('checked');
	    $(".txt-decoration").removeAttr('checked');
	    $("#bold-cb").removeAttr('checked');
	    $("#italic-cb").removeAttr('checked');
	    $("#font-family-selector").val($("#font-family-selector option:first").val()).trigger('change');
	    ;
	    $("#o-thickness-slider").val($("#o-thickness-slider option:first").val());
	    $("#opacity-slider").val(1);
	}

	//Editor Actions
//        $(document).on("touchstart click", ".pcd-rp-attribute", function ()
//        {
//            var current_key=$(this).data("key");
//            var current_value=$(this).data("value");
//            //We try to find which variation is it
//            $(".pcd-rp-attribute[data-key!='"+current_key+"'").each(function (key, curr_object) {
//                
//            });
//        });

	//Preview
	$(document).on("touchstart click", "#preview-btn", function (e)
	{
	    e.preventDefault();
	    $("#pcd-modal .omodal-body").html("");
	    //Make sure the last modification is handled
	    pcd_editor.save_canvas();

	    //if (pcd.clip_include_in_output == "no")
	    // pcd_editor.canvas.clipTo = null;
	    loop_through_parts(pcd.output_loop_delay,
		    generate_canvas_part,
		    function () {
			// $('li.phone-type-details[data-index="' + pcd_editor.selected_index + '"]').click();
			$('#pcd-modal').omodal("show");
			//set_clipping_area();
			$.unblockUI();
		    }
	    );

	});
	//Download design
	$(document).on("click", "#download-btn", function ()
	{
	    $("#debug").html("");
	    if (pcd.clip_include_in_output == "no")
		pcd_editor.canvas.clipTo = null;
	    loop_through_parts(pcd.output_loop_delay,
		    generate_final_canvas_part,
		    function () {
			if (jQuery.isEmptyObject(pcd_editor.final_canvas_parts))
			{
			    $("#debug").html("<div class='wpc-failure'>" + pcd.translated_strings.empty_object_msg + "</div>");
			    set_clipping_area();
			    $.unblockUI();
			} else
			{
			    var variation_id = pcd.global_variation_id;
			    var frm_data = new FormData();
			    frm_data.append("action", "generate_downloadable_file");
			    frm_data.append("variation_id", variation_id);
			    frm_data.append("format", pcd.output_format);
			    frm_data = convert_final_canvas_parts_to_blob(frm_data);
			    $.ajax({
				type: 'POST',
				url: ajax_object.ajax_url,
				data: frm_data,
				processData: false,
				contentType: false
			    }).done(function (data) {
				set_clipping_area();
				$.unblockUI();
				if (pcd_editor.is_json(data))
				{
				    var response = JSON.parse(data);
				    if ($('li.phone-type-details[data-index="' + pcd_editor.selected_index + '"]'))
				    {
					$('li.phone-type-details[data-index="' + pcd_editor.selected_index + '"]').click();
				    } else
					reload_first_part_data();
				    $("#debug").html(response.message);
				    wp.hooks.doAction('PCD_EDITOR.download_files_complete');
				} else
				    $("#debug").html(data);
			    });
			}
		    }
	    );
	});
	//Save design for later
	$(document).on("touchstart click", "#save-btn", function ()
	{
	    var index = $(this).data("index");
	    var data_action = $(this).attr("data-action");
	    if (typeof data_action === "undefined")
		data_action = "new-save";

	    var design_name = $("#design-name").val();
	    if ('undefined' !== design_name && "" !== design_name) {
		$(this).parent().parent().find(".close.ti-close").click();
		pcd_editor.save_canvas();
		loop_through_parts(pcd.output_loop_delay,
			generate_final_canvas_part,
			function () {
			    if (jQuery.isEmptyObject(pcd_editor.final_canvas_parts))
			    {
				console.log("hi");
				$("#debug").html("<div class='wpc-failure'>" + pcd.translated_strings.empty_object_msg + "</div>");
				$.unblockUI();
			    } else
			    {
				var variation_id = pcd.global_variation_id;
				var frm_data = new FormData();
				frm_data.append("action", "save_design_for_later");
				frm_data.append("design_index", index);
				frm_data.append("design_name", design_name);
				frm_data.append("variation_id", variation_id);
				frm_data.append("format", pcd.output_format);
				frm_data.append("data_action", data_action);
				frm_data = convert_final_canvas_parts_to_blob(frm_data);
				$.ajax({
				    type: 'POST',
				    url: ajax_object.ajax_url,
				    data: frm_data,
				    processData: false,
				    contentType: false
				}).done(function (data) {
				    $.unblockUI();
				    if (pcd_editor.is_json(data))
				    {
					var response = JSON.parse(data);
					$('li.phone-type-details[data-index="' + pcd_editor.selected_index + '"]').click();
					if (!data.is_logged)
					    $(location).attr('href', response.url);
					else
					{
					    if (data.success)
						$(location).attr('href', response.url);
					}
				    } else
					$("#debug").html(data);
				});
			    }
			}
		);
	    }
//            loop_through_parts(pcd.output_loop_delay,
//                    generate_final_canvas_part,
//                    function () {
//                        if (jQuery.isEmptyObject(pcd_editor.final_canvas_parts))
//                        {
//                            $("#debug").html("<div class='wpc-failure'>" + pcd.translated_strings.empty_object_msg + "</div>");
//                            $.unblockUI();
//                        } else
//                        {
//                            var quantity = $("#pcd-qty").val();
//                            var index = $("#save-btn").data("index");
//                            var variation_id = pcd.global_variation_id;
//                            var frm_data = new FormData();
//                            frm_data.append("action", "save_custom_design_for_later");
//                            frm_data.append("variation_id", variation_id);
//                            frm_data.append("design_index", index);
//                            frm_data.append("format", pcd.output_format);
//                            frm_data = convert_final_canvas_parts_to_blob(frm_data);
//                            $.ajax({
//                                type: 'POST',
//                                url: ajax_object.ajax_url,
//                                data: frm_data,
//                                processData: false,
//                                contentType: false
//                            }).done(function (data) {
//                                $.unblockUI();
//                                if (pcd_editor.is_json(data))
//                                {
//                                    var response = JSON.parse(data);
//                                    $('li.phone-type-details[data-index="' + pcd_editor.selected_index + '"]').click();
//                                    if (!data.is_logged)
//                                        $(location).attr('href', response.url);
//                                    else
//                                    {
//                                        if (data.success)
//                                            $(location).attr('href', response.url);
//                                    }
//                                } else
//                                    $("#debug").html(data);
//                            });
//                        }
//                    }
//            );
	});
	//Quantity setter
	$(document).on('click', '.wpc-qty-container .plus, .wpc-qty-container .minus', function () {

	    // Get values
	    var $qty = $(this).siblings(".pcd-qty"); //$("#pcd-qty"),
	    var currentVal = parseFloat($qty.val());
	    var max = parseFloat($qty.attr('max'));
	    var min = parseFloat($qty.attr('min'));
	    var step = $qty.attr('step');
	    // Format values
	    if (!currentVal || currentVal === '' || currentVal === 'NaN')
		currentVal = 0;
	    if (max === '' || max === 'NaN')
		max = '';
	    if (min === '' || min === 'NaN')
		min = 0;
	    if (step === 'any' || step === '' || step === undefined || parseFloat(step) === 'NaN')
		step = 1;
	    // Change the value
	    if ($(this).is('.plus')) {

		if (max && (max == currentVal || currentVal > max)) {
		    $qty.val(max);
		} else {
		    $qty.val(currentVal + parseFloat(step));
		}

	    } else {

		if (min && (min == currentVal || currentVal < min)) {
		    $qty.val(min);
		} else if (currentVal > 0) {
		    $qty.val(currentVal - parseFloat(step));
		}

	    }

	    // Trigger change event
	    $qty.trigger('change');
	    //For WAD (bulk discounts)
	    update_price();
	});
	$('.pcd-rp-attribute.cart-item-edit').click(function () {
	    return confirm(pcd.translated_strings.cart_item_edition_switch);
	});
	//We remove the existing cookie if needed
//        $.removeCookie('pcd-data-to-load');

//         $(document).on("touchstart click", ".pcd-rp-attribute", function (e) {
//             e.preventDefault();
//             $.blockUI({message: pcd.translated_strings.loading_msg});
//             var serialized_parts = {};
//             var href = $(this).attr("href");
//             $.each(pcd_editor.serialized_parts, function (key, curr_object) {
//                 serialized_parts[key] = curr_object[curr_object.length - 1];
// //                console.log(curr_object);
//             });

//             var json_parts = JSON.stringify(serialized_parts);
// //            console.log(json_parts);

//             $.post(
//                     ajax_object.ajax_url,
//                     {
//                         action: "save_data_to_reload",
//                         serialized_parts: json_parts
//                     },
//                     function (data) {
//                         if (pcd_editor.is_json(data))
//                         {
//                             $.unblockUI();
// //                            var response = JSON.parse(data);
//                             $(location).attr('href', href);
//                         } else
//                             $("#debug").html(data);
//                     }
//             );
//         });

	$(document).on("change", '.pcd-qty', function ()
	{
	    var qty = $(this).val();
	    var unit_price = $(this).attr("uprice");
	    var opt_price = $(this).attr("opt_price");
	    var total_field = $(this).siblings(".total-price").find(".total_order");
	    if (!$.isNumeric(qty))
	    {
		$(this).val(1);
		total_field.html(accounting.formatMoney(unit_price));
		return;
	    }
	    if ($.isNumeric(opt_price)) {
		unit_price = parseFloat(unit_price) + parseFloat(opt_price);
		unit_price = wp.hooks.applyFilters('pcd.unit_price', unit_price, $(this));
	    }
	    var total = unit_price * qty;
	    //total_field.html($.number(total, pcd.nb_decimals, pcd.decimal_sep, pcd.thousand_sep));
	    total_field.html(accounting.formatMoney(total));
	    //$("#total_order").html(total.toFixed(2));

	});
	//ninja form validation
	var pcd_ninja_form_validation = function () {
	    var deferred = new $.Deferred();
	    if ($('.wpc-container .ninja-forms-form').length > 0) {


		$(".wpc-container form.ninja-forms-form").each(function () {
		    var form = $(this);
		    if (form.find('input[type="submit"]').length < 1) {
			form.append('<input type="submit" class="ninja-forms-field" style="display:none;"/>');
		    }
		    var form_id = form.attr('id');
		    $('#' + form_id).submit();
		    $(document).on('submitResponse.example', function (e, response) {
			//console.log(response);
			form.show();
			if (response.success) {
			    deferred.resolve(true);
			} else {
			    if ($('li.phone-type-details[data-index="' + pcd_editor.selected_index + '"]').length > 1)
			    {
				$('li.phone-type-details[data-index="' + pcd_editor.selected_index + '"]').click();
			    } else
				reload_first_part_data();
			    //$("#debug").html("<div class='wpc-failure'>" + pcd.translated_strings.empty_object_msg + "</div>");
			    // responses.push(false);
			    //console.log('false');
			    deferred.resolve(false);
			    //$.unblockUI();
			    // return false;
			}
		    });
		});
	    } else {
		deferred.resolve(true);
	    }
	    return deferred.promise();
	}

	//Add to cart
	$(document).on("touchstart click", "#add-to-cart-btn", function () {

	    $("#debug").html("");
	    var variations = {};

	    $.each($(".wpc-qty-container"), function (key, curr_object) {
		var qty = $(this).find(".pcd-qty").val();
		var variation_name = key;
		variations[variation_name] = {};
		variations[variation_name]["qty"] = qty;
		variations[variation_name]["id"] = $(this).data("id");
	    });
	    var form_builder_is_validate = false;
	    if ($('form.formbuilt').length === 0) {
		form_builder_is_validate = true;
	    } else {
		form_builder_is_validate = $('form.formbuilt').validationEngine('validate', {showArrow: false});
	    }
	    //Make sure the last modification is handled
	    pcd_editor.save_canvas();

	    pcd_ninja_form_validation().then(function function_name(form_is_valid) {
		if (!form_is_valid || !form_builder_is_validate) {
		    //console.log('! form_is_valid');
		    $.unblockUI();
		    // return false;
		} else {
		    if (pcd.clip_include_in_output == "no")
			pcd_editor.canvas.clipTo = null;
		    loop_through_parts(pcd.output_loop_delay,
			    generate_final_canvas_part,
			    function () {
				if (jQuery.isEmptyObject(pcd_editor.final_canvas_parts))
				{
				    $("#debug").html("<div class='wpc-failure'>" + pcd.translated_strings.empty_object_msg + "</div>");
				    set_clipping_area();
				    $.unblockUI();
				} else
				{
				    //console.log(variations.toString());
				    var quantity = $("#pcd-qty").val();
				    var variation_id = pcd.global_variation_id;
				    //var cart_item_key = GetURLParameter("edit");
				    var cart_item_key = pcd.query_vars["edit"];
				    if (typeof cart_item_key == 'undefined')
					cart_item_key = "";
				    var tpl = pcd.query_vars["tpl"];
				    if (typeof tpl == 'undefined')
					tpl = "";
				    var frm_data = new FormData();
				    frm_data.append("variation_id", variation_id);
				    frm_data.append("variations", JSON.stringify(variations));
				    frm_data.append("format", pcd.output_format);
				    frm_data.append("action", "add_custom_design_to_cart");
				    frm_data.append("cart_item_key", cart_item_key);
				    frm_data.append("tpl", tpl);
				    frm_data.append("final_canvas_parts", pcd_editor.final_canvas_parts);
				    frm_data.append("quantity", quantity);
				    if (typeof window.pcd_key !== 'undefined') {
					frm_data.append("pcd_key", window.pcd_key);
				    }
				    var pcd_design_options = JSON.stringify(get_design_options());
				    frm_data.append("pcd-design-opt", pcd_design_options);
				    frm_data = convert_final_canvas_parts_to_blob(frm_data);
				    var tthat = $('form.formbuilt');
				    if (tthat.length !== 0) {
					tthat.validationEngine('validate', {showArrow: false});
					var form_fields = tthat.serializeJSON();
					delete form_fields.id_ofb;
					//console.log(form_fields);
					var jsonform_fields = JSON.stringify(form_fields);
					frm_data.append("form_fields", jsonform_fields);
				    }
				    $.ajax({
					type: 'POST',
					url: ajax_object.ajax_url,
					data: frm_data,
					processData: false,
					contentType: false
				    }).done(function (data) {
					if (pcd_editor.is_json(data))
					{
					    var response = JSON.parse(data);
					    if ($('li.phone-type-details[data-index="' + pcd_editor.selected_index + '"]').length > 1)
						$('li.phone-type-details[data-index="' + pcd_editor.selected_index + '"]').click();
					    else
						reload_first_part_data();
					    if (pcd.redirect_after == 1 && response.success)
					    {
						$(location).attr('href', response.url);
					    } else
					    {
						$("#debug").html(response.message);
						set_clipping_area();
						$.ajax($fragment_refresh);
						$.unblockUI();
					    }
					} else
					{
					    $("#debug").html(data);
					    set_clipping_area();
					    $.ajax($fragment_refresh);
					    $.unblockUI();
					}

				    });
				}
			    }
		    );
		}
	    });
	    pcd_editor.after_preview_or_donwload();
	});
	if (typeof wc_cart_fragments_params != 'undefined')
	{

	    var $fragment_refresh = {
		url: wc_cart_fragments_params.wc_ajax_url.toString().replace('%%endpoint%%', 'get_refreshed_fragments'),
		type: 'POST',
		success: function (data) {
		    if (data && data.fragments) {

			$.each(data.fragments, function (key, value) {
			    $(key).replaceWith(value);
			});
			var test = JSON.stringify(data.fragments);
			$(document.body).trigger('wc_fragments_refreshed');
			$('.wc-mini-cart').html(test);
		    }
		}
	    };
	}













	/*function GetURLParameter(sParam)
	 {
	 var sPageURL = window.location.search.substring(1);
	 var sURLVariables = sPageURL.split('&');
	 for (var i = 0; i < sURLVariables.length; i++)
	 {
	 var sParameterName = sURLVariables[i].split('=');
	 if (sParameterName[0] == sParam)
	 {
	 return sParameterName[1];
	 }
	 }
	 
	 console.log(pcd.query_vars[sParam]);
	 if (pcd.query_vars.sParam != undefined) {
	 return wpb.query_vars.sParam;
	 };
	 }*/



	$("#lock-mvt-x, #lock-mvt-y, #lock-scl-x, #lock-scl-y, #lock-Deletion").change(function (e)
	{
	    var property = $(this).data("property");
	    var selected_object = pcd_editor.canvas.getActiveObject();
	    var selected_group = pcd_editor.canvas.getActiveGroup();
	    if (selected_object != null)
	    {
		if ($(this).is(':checked'))
		    selected_object[property] = true;
		else
		    selected_object[property] = false;
		pcd_editor.save_canvas();
	    } else if (selected_group != null)
	    {
		if ($(this).is(':checked'))
		    selected_group[property] = true;
		else
		    selected_group[property] = false;
		pcd_editor.save_canvas();
	    }
	});
	$('.post-type-wpc-template #publish').click(function (e)
	{
	    e.preventDefault();
	    loop_through_parts(pcd.output_loop_delay,
		    generate_final_canvas_part,
		    function () {
			if (jQuery.isEmptyObject(pcd_editor.final_canvas_parts))
			{
			    alert(pcd.translated_strings.empty_object_msg);
			    $.unblockUI();
			} else
			{
			    var frm_data = new FormData();
			    frm_data.append("action", "save_canvas_to_session");
			    frm_data = convert_final_canvas_parts_to_blob(frm_data);
			    $.ajax({
				type: 'POST',
				url: ajax_object.ajax_url,
				data: frm_data,
				processData: false,
				contentType: false
			    }).done(function (data) {
//                                console.log(data);
//                                $("#wpc-parts-bar > span").first().click();
				$("#post").submit();
			    });
			}

		    }
	    );
	});

	pcd_editor.before_preview_or_donwload = function ()
	{
	    var boundind_boxs = _(pcd_editor.canvas.getObjects()).filter({
		is_bounding_box: true
	    });
	    boundind_boxs.each(function (box) {
		box.set('strokeWidth', 0);
	    });
	    var boundind_boxs_uploaded_image = _(pcd_editor.canvas.getObjects()).filter({
		is_bounding_box_upload_image: true
	    });
	    boundind_boxs_uploaded_image.each(function (click_to_upload_img) {
		click_to_upload_img.set({
		    opacity: 0,
		    selectable: false
		});
	    });
	    pcd_editor.canvas.renderAll();
	};

	pcd_editor.after_preview_or_donwload = function ()
	{
	    var boundind_boxs = _(pcd_editor.canvas.getObjects()).filter({
		is_bounding_box: true
	    });
	    boundind_boxs.each(function (box) {
		if ("layout_1" !== box.layout_name)
		{
		    box.set('strokeWidth', 0.2);
		}
	    });
	    var boundind_boxs_uploaded_image = _(pcd_editor.canvas.getObjects()).filter({
		is_bounding_box_upload_image: true
	    });
	    boundind_boxs_uploaded_image.each(function (click_to_upload_img) {
		click_to_upload_img.set({
		    opacity: 1,
		    selectable: false
		});
	    });
	    pcd_editor.canvas.renderAll();
	};

	//Generate design for output
	function generate_final_canvas_part(part_index)
	{
	    //        resetZoom(true); 
	    generate_canvas_part(part_index, false);
	}
	function makeBig(canvas,multiplier) {
	    var canvasEl = canvas.wrapperEl.childNodes[0];
	    var big = document.createElement("canvas");
	    big.width = canvasEl.width * multiplier;
	    big.height = canvasEl.height * multiplier;
	    var ctx = big.getContext('2d');
	    ctx.drawImage(canvasEl, 0, 0, big.width, big.height);
	    return big.toDataURL({format: pcd.output_format, quality: 1});
	}
	function generate_canvas_part(part_index, preview)
	{
	    pcd_editor.selected_index = part_index;
	    preview = typeof preview !== 'undefined' ? preview : true;

	    var data_id = $('li.phone-type-details[data-index="' + pcd_editor.selected_index + '"]').attr("data-index");
	    var data_part_img = $('li.phone-type-details[data-index="' + pcd_editor.selected_index + '"]').attr("data-url");
	    var modal_content = "";
	    pcd_editor.canvas.clear();
	    if (typeof pcd_editor.serialized_parts[data_id] == "undefined")
	    {
		pcd_editor.serialized_parts[data_id] = ["{}"];
	    }

	    pcd_editor.canvas.loadFromJSON(pcd_editor.serialized_parts[data_id][pcd_editor.canvasManipulationsPosition[data_id]],
		    function () {
			applyImageFilters();
			pcd_editor.clipto_after_load_from_json();
			pcd_editor.load_background_overlay_if_needed(pcd_editor.selected_index, function () {

			    var multiplier = pcd.output_w / pcd_editor.canvas.getWidth();
			   
			    //We split the multiplier per 2 if we're in retina mode
			    if (window.devicePixelRatio !== 1 && pcd.responsive != 1 && pcd.enable_retina === "yes") {
				multiplier = multiplier / 2;
			    }
			    multiplier = 1830 / 500;
			     if (preview)
				multiplier = 1;
			    pcd_editor.before_preview_or_donwload();
			    //var image = pcd_editor.canvas.toDataURL({format: pcd.output_format, multiplier: multiplier, quality: 1});
			    var image=makeBig(pcd_editor.canvas,multiplier);
			    pcd_editor.after_preview_or_donwload();
			    var svg = "";
			    if (pcd.generate_svg)
				svg = pcd_editor.canvas.toSVG();
			    var blob_image = dataURItoBlob(image);
			    if (preview)
			    {
				var modal_content = "";
				if (pcd.watermark)
				{

				    var frm_data = new FormData();
				    frm_data.append("action", "get_watermarked_preview");
				    frm_data.append("watermark", pcd.watermark);
				    frm_data.append("format", pcd.output_format);
				    frm_data.append("product-id", pcd.global_variation_id);
				    frm_data.append("image", blob_image);
				    //                                    frm_data = convert_final_canvas_parts_to_blob(frm_data);

				    $.ajax({
					type: 'POST',
					url: ajax_object.ajax_url,
					data: frm_data,
					processData: false,
					contentType: false
				    }).done(function (data) {
					if (pcd_editor.is_json(data))
					{
					    var response = JSON.parse(data);
					    if (data_part_img)
						modal_content = "<div style='background-image:url(" + data_part_img + ");'><img src='" + response.url + "'></div>";
					    else
						modal_content = "<div><img src='" + response.url + "'></div>";
					    $("#pcd-modal .omodal-body").append(modal_content);
					} else
					{
					    $("#debug").html(data);
					}

				    });
				} else
				{

				    if (data_part_img) {
					modal_content = "<div id='preview_bg_image'><img src='" + image + "'></div>";
				    } else {
					modal_content = "<div><img src='" + image + "'></div>";
				    }
				    $("#pcd-modal .omodal-body").append(modal_content);
				    if (data_part_img) {
					var bg_code = "url('" + data_part_img + "')";
					$("#pcd-modal .omodal-body #preview_bg_image").css("background-image", bg_code);
					$("#pcd-modal .omodal-body #preview_bg_image").css("width", pcd.canvas_w);
					$("#pcd-modal .omodal-body #preview_bg_image").css("height", pcd.canvas_h);

				    }
				}
			    } else
			    {
				var canvas_obj = $.parseJSON(pcd_editor.serialized_parts[data_id][pcd_editor.canvasManipulationsPosition[data_id]]);
				var layers = [];
				if (pcd.print_layers)
				{
				    var objects = canvas_obj.objects;
				    $.each(objects, function (key, curr_object) {
					pcd_editor.canvas.clear();
					var tmp_canvas_obj = canvas_obj;
					tmp_canvas_obj.objects = [curr_object];
					var tmp_canvas_json = JSON.stringify(tmp_canvas_obj);
					pcd_editor.canvas.loadFromJSON(tmp_canvas_json, function () {
					    applyImageFilters();
					    pcd_editor.clipto_after_load_from_json();
					    pcd_editor.canvas.renderAll.bind(pcd_editor.canvas);
					    //Removes overlay not included from layers
					    pcd_editor.load_background_overlay_if_needed(pcd_editor.selected_index, "", true);
					    var multiplier = pcd.output_w / pcd_editor.canvas.getWidth();
					    var layer = pcd_editor.canvas.toDataURL({format: pcd.output_format, multiplier: multiplier, quality: 1});
					    //console.log(layer);
					    var blob_layer = dataURItoBlob(layer);
					    layers.push(blob_layer);
					    //Loads the complete canvas before the save later otherwise, we end up with the last layer loaded as part data
					    if (key == objects.length - 1)
					    {
						pcd_editor.canvas.loadFromJSON(pcd_editor.serialized_parts[data_id][pcd_editor.canvasManipulationsPosition[data_id]], pcd_editor.clipto_after_load_from_json());
						applyImageFilters();
					    }
					});
				    });
				}
				pcd_editor.final_canvas_parts[data_id] = {json: pcd_editor.serialized_parts[data_id][pcd_editor.canvasManipulationsPosition[data_id]], image: blob_image, original_part_img: data_part_img, layers: layers, svg: svg};
			    }

			    pcd_editor.load_background_overlay_if_needed(pcd_editor.selected_index);
			}, true);

		    });

	}

	function dataURItoBlob(dataURI) {
	    // convert base64/URLEncoded data component to raw binary data held in a string
	    var byteString;
	    if (dataURI.split(',')[0].indexOf('base64') >= 0)
		byteString = atob(dataURI.split(',')[1]);
	    else
		byteString = unescape(dataURI.split(',')[1]);
	    // separate out the mime component
	    var mimeString = dataURI.split(',')[0].split(':')[1].split(';')[0];
	    // write the bytes of the string to a typed array
	    var ia = new Uint8Array(byteString.length);
	    for (var i = 0; i < byteString.length; i++) {
		ia[i] = byteString.charCodeAt(i);
	    }

	    var blob = new Blob([ia], {type: mimeString});
//            console.log(blob.size);

	    return blob;
	}

	function convert_final_canvas_parts_to_blob(frm_data)
	{
	    $.each(pcd_editor.final_canvas_parts, function (part_key, part_data) {
		$.each(part_data, function (data_key, data_value) {
		    if (data_key == "image")
			frm_data.append(part_key + "[" + data_key + "]", data_value);
		    else if (data_key == "layers")
		    {
			$.each(data_value, function (layer_index, layer_data) {
			    frm_data.append("layers[" + part_key + "][]", layer_data);
			});
		    } else
			frm_data.append("final_canvas_parts[" + part_key + "][" + data_key + "]", data_value);
		});
	    });
	    return frm_data;
	}

	function reload_first_part_data()
	{
	    var data_id = $('li.phone-type-details[data-index="' + pcd_editor.selected_index + '"]').attr("data-index");
	    pcd_editor.canvas.clear();
	    //console.log(pcd_editor.serialized_parts[data_id][pcd_editor.canvasManipulationsPosition[data_id]])
	    pcd_editor.canvas.loadFromJSON(pcd_editor.serialized_parts[data_id][pcd_editor.canvasManipulationsPosition[data_id]], function () {
		pcd_editor.clipto_after_load_from_json();
		pcd_editor.canvas.renderAll.bind(pcd_editor.canvas);
		pcd_editor.rescale_canvas_if_needed();
	    });
	}



	pcd_editor.rescale_canvas_if_needed = function ()
	{
	    if (pcd.responsive != 1)
		return false;
	    var optimal_dimensions = get_optimal_canvas_dimensions();
	    var scaleFactor = optimal_dimensions[0] / pcd.canvas_w;
//            var current_canvas_w=pcd_editor.canvas.getWidth();
//            
//            console.log(current_canvas_w+"=>"+optimal_dimensions[0]);
	    if (scaleFactor != 1) {
//                console.log("Factor: "+scaleFactor);
		pcd_editor.scale_factor = scaleFactor;
		pcd_editor.canvas.setWidth(optimal_dimensions[0]);
		pcd_editor.canvas.setHeight(optimal_dimensions[1]);
//                var xpos=optimal_dimensions[0]/2;
//                var ypos=optimal_dimensions[1]/2;
		pcd_editor.canvas.setZoom(scaleFactor);
		pcd_editor.canvas.calcOffset();
		pcd_editor.canvas.renderAll();
	    }

	    applyImageFilters();
	}

	$(window).resize(function () {
	    clearTimeout(resizeId);
	    resizeId = setTimeout(handle_resize, 500);
	});
	function handle_resize()
	{
	    $(".canvas-container").hide();
	    pcd_editor.rescale_canvas_if_needed();
	    set_clipping_area();
	    $(".canvas-container").show();
	}

//        Shortcuts
	if (parseInt(pcd.disable_shortcuts) != 1)
	{
	    $(document).keydown(function (e) {
		var selected_object = pcd_editor.canvas.getActiveObject();
		var selected_group = pcd_editor.canvas.getActiveGroup();
		if (e.which == 46) //Delete button
		    $("#delete_btn").click();
		else if (e.which == 37) //Left button
		{
		    if (selected_group != null && !selected_group.get("lockMovementX"))
		    {
			selected_group.set("left", selected_group.left - 1);
			pcd_editor.canvas.renderAll();
			pcd_editor.save_canvas();
		    } else if ((selected_object != null) && !selected_object.get("lockMovementX"))
		    {
			selected_object.set("left", selected_object.left - 1);
			pcd_editor.canvas.renderAll();
			pcd_editor.save_canvas();
		    }

		} else if (e.which == 39) //Right button
		{
		    if (selected_group != null && !selected_group.get("lockMovementX"))
		    {
			selected_group.set("left", selected_group.left + 1);
			pcd_editor.canvas.renderAll();
			pcd_editor.save_canvas();
		    } else if ((selected_object != null) && !selected_object.get("lockMovementX"))
		    {
			selected_object.set("left", selected_object.left + 1);
			pcd_editor.canvas.renderAll();
			pcd_editor.save_canvas();
		    }
		} else if (e.which == 38) //Top button
		{

		    if (selected_group != null && !selected_group.get("lockMovementY"))
		    {
			e.preventDefault();
			selected_group.set("top", selected_group.top - 1);
			pcd_editor.canvas.renderAll();
			pcd_editor.save_canvas();
		    } else if ((selected_object != null) && !selected_object.get("lockMovementY"))
		    {
			e.preventDefault();
			selected_object.set("top", selected_object.top - 1);
			pcd_editor.canvas.renderAll();
			pcd_editor.save_canvas();
		    }
		} else if (e.which == 40) //Bottom button
		{
		    if (selected_group != null && !selected_group.get("lockMovementY"))
		    {
			e.preventDefault();
			selected_group.set("top", selected_group.top + 1);
			pcd_editor.canvas.renderAll();
			pcd_editor.save_canvas();
		    } else if ((selected_object != null) && !selected_object.get("lockMovementY"))
		    {
			e.preventDefault();
			selected_object.set("top", selected_object.top + 1);
			pcd_editor.canvas.renderAll();
			pcd_editor.save_canvas();
		    }

		} else if (e.keyCode == 67 && e.ctrlKey)//ctrl+c
		{
		    $("#copy_paste_btn").click();
		}
		//        else if(e.keyCode == 86 && e.ctrlKey)//ctrl+v
		//        {
		//            $("#copy_paste_btn").click();
		//        }
		else if (e.keyCode == 90 && e.ctrlKey)//ctrl+z
		{
		    $("#undo-btn").click();
		} else if (e.keyCode == 89 && e.ctrlKey)//ctrl+y
		{
		    $("#redo-btn").click();
		}
	    });
	}

	$(".pcd-rp-attribute").mouseenter(function () {
	    $("#pcd-rp-desc").html($(this).data("desc"));
	});
	$(".pcd-rp-attribute").mouseout(function () {
	    var default_desc = $(".pcd-rp-attribute.selected").data("desc");
	    $("#pcd-rp-desc").html(default_desc);
	});
	$('canvas').bind('contextmenu', function (e) {
	    return false;
	});
	$(document).on('click', '[id$="color-selector"] .o-colorpicker_clear', function (event) {
	    var parent_id = $(this).parents(".wpc-colorpicker").attr("id");
	    var selected_object = pcd_editor.canvas.getActiveObject();
	    if (parent_id.indexOf("bg-color-selector") >= 0 && selected_object != null)
	    {
		selected_object.set("backgroundColor", "transparent");
		pcd_editor.canvas.renderAll();
		pcd_editor.save_canvas();
	    } else if (parent_id.indexOf("outline-color-selector") >= 0 && selected_object != null)
	    {
		selected_object.set("stroke", "transparent");
		pcd_editor.canvas.renderAll();
		pcd_editor.save_canvas();
	    } else if (parent_id.indexOf("color-selector") >= 0 && selected_object != null)
	    {
		selected_object.set("fill", "transparent");
		pcd_editor.canvas.renderAll();
		pcd_editor.save_canvas();
	    }
	});
	/**
	 * Draws a rounded rectangle using the current state of the canvas.
	 */
	function roundRect(ctx, x, y, width, height, radius, fill, stroke) {
	    if (typeof stroke == "undefined") {
		stroke = false;
	    }
	    if (typeof radius === "undefined") {
		radius = 5;
	    }
	    ctx.beginPath();
	    ctx.moveTo(x + radius, y);
	    ctx.lineTo(x + width - radius, y);
	    ctx.quadraticCurveTo(x + width, y, x + width, y + radius);
	    ctx.lineTo(x + width, y + height - radius);
	    ctx.quadraticCurveTo(x + width, y + height, x + width - radius, y + height);
	    ctx.lineTo(x + radius, y + height);
	    ctx.quadraticCurveTo(x, y + height, x, y + height - radius);
	    ctx.lineTo(x, y + radius);
	    ctx.quadraticCurveTo(x, y, x + radius, y);
	    ctx.closePath();
	    if (stroke) {
		ctx.strokeStyle = stroke;
		ctx.stroke();
	    }
	    if (fill) {
		ctx.fill();
	    }
	}
    });
    return pcd_editor;
}(jQuery, PCD_EDITOR));