var PCD_EDITOR = (function ($, pcd_editor) {
    'use strict';
    //var editor;
    $(document).ready(function () {
	//Text
	//var pcd_editor.canvas ;//= get_editor_pcd_editor.canvas();
	$(document).on('click', '#wpc-add-text', function (event) {
	    event.preventDefault();
	    var new_text = $("#new-text").val();
	    var is_curved = $("#cb-curved").is(":checked");
	    if (new_text.length == 0)
		alert(pcd.translated_strings.empty_txt_area_msg);
	    else if (!is_curved) {
		add_text(new_text, false, false);
	    } else
	    {
		add_curved_text(new_text);
	    }
	});

	function add_text(txt, left, top) {
	    var text = create_text_elmt(txt);
	    pcd_editor.canvas.add(text);
	    if (left)
	    {
		text.set("left", left);
		text.set("top", top);
	    } else
	    {
//                if (pcd_editor.box_center_x)
//                {
//                    text.set("originX", "center");
//                    text.set("originY", "center");
//                    text.set("left", pcd_editor.box_center_x);
//                    text.set("top", pcd_editor.box_center_y);
//                }
//                else
//                {
		pcd_editor.centerObjectH(text);
		pcd_editor.centerObjectV(text);
//                }
	    }
	    var pcd_canvas = pcd_editor.canvas;
	    wp.hooks.doAction('PCD_EDITOR.after_adding_text_on_canvas', text, pcd_canvas);
	    pcd_editor.canvas.renderAll();
	    text.setCoords();

	    $("#new-text").val("");
	    pcd_editor.save_canvas();
	}

	$("#font-family-selector").trigger('change');

	$("#font-family-selector").css('font-family', $("#font-family-selector").val());
	$("#font-family-selector").change(function ()
	{
	    var selected_object = pcd_editor.canvas.getActiveObject();
	    var font_size = parseInt($("#font-size-selector").val());
	    var font_family = $("#font-family-selector").attr("value");
	    // console.log(font_family);
	    $(this).css('font-family', font_family);
	    if ((!pcd_editor.isEmpty(selected_object)) && (selected_object.type == "i-text"))
	    {
		selected_object.set('fontFamily', font_family);
		if (font_size)
		    selected_object.setFontSize(parseInt(font_size));
		pcd_editor.canvas.renderAll();
		pcd_editor.save_canvas();
	    } else if ((!pcd_editor.isEmpty(selected_object)) && (selected_object.type == "group"))
	    {
		selected_object.forEachObject(function (a) {
		    a.set('fontFamily', font_family);
		    if (font_size)
			a.setFontSize(parseInt(font_size));
		    pcd_editor.canvas.renderAll();
		    pcd_editor.save_canvas();
		});
	    }
	});


	$("#font-size-selector").change(function ()
	{
	    var selected_object = pcd_editor.canvas.getActiveObject();
	    var font_size = parseInt($("#font-size-selector").val());
	    if ((!pcd_editor.isEmpty(selected_object)) && (selected_object.type == "i-text"))
	    {
		selected_object.setFontSize(parseInt(font_size));
		pcd_editor.canvas.renderAll();
	    } else if ((!pcd_editor.isEmpty(selected_object)) && (selected_object.type == "group"))
	    {
		recreate_group(selected_object);
	    }
	});

	$("#letter-space-selector").change(function ()
	{
	    var selected_object = pcd_editor.canvas.getActiveObject();
	    var letter_space = parseInt($("#letter-space-selector").val());
	    if ((!pcd_editor.isEmpty(selected_object)) && (selected_object.type == "i-text"))
	    {
		selected_object.set('charSpacing', parseInt(letter_space));
		pcd_editor.canvas.renderAll();
	    } else if ((!pcd_editor.isEmpty(selected_object)) && (selected_object.type == "group"))
	    {
		selected_object.forEachObject(function (a) {
		    a.set('charSpacing', parseInt(letter_space));
		    pcd_editor.canvas.renderAll();
		});
	    }
	});
	$(".txt-align").change(function ()
	{
	    var align = $(this).val();
	    var selected_object = pcd_editor.canvas.getActiveObject();

	    if ((!pcd_editor.isEmpty(selected_object)) && (selected_object.type == "i-text"))
	    {
		selected_object.set("textAlign", align);
		pcd_editor.canvas.renderAll();
	    } else if ((!pcd_editor.isEmpty(selected_object)) && (selected_object.type == "group"))
	    {
		selected_object.forEachObject(function (a) {
		    a.set("textAlign", align);
		    pcd_editor.canvas.renderAll();
		});
	    }

	});

	//Bold styles
	$("#bold-cb").change(function ()
	{
	    var selected_object = pcd_editor.canvas.getActiveObject();
	    var is_bold = $("#bold-cb").is(":checked");
	    if ((!pcd_editor.isEmpty(selected_object)) && (selected_object.type == "i-text"))
	    {
		if (is_bold)
		    selected_object.set("fontWeight", "bold");
		else
		    selected_object.set("fontWeight", "normal");
		pcd_editor.canvas.renderAll();
	    } else if ((!pcd_editor.isEmpty(selected_object)) && (selected_object.type == "group"))
	    {
		selected_object.forEachObject(function (a) {
		    if (is_bold)
			a.set("fontWeight", "bold");
		    else
			a.set("fontWeight", "normal");
		    pcd_editor.canvas.renderAll();
		});
	    }
	});

	$("#italic-cb").change(function ()
	{
	    var selected_object = pcd_editor.canvas.getActiveObject();
	    var is_italic = $("#italic-cb").is(":checked");
	    if ((!pcd_editor.isEmpty(selected_object)) && (selected_object.type == "i-text"))
	    {
		if (is_italic)
		    selected_object.set("fontStyle", "italic");
		else
		    selected_object.set("fontStyle", "normal");
		pcd_editor.canvas.renderAll();
	    } else if ((!pcd_editor.isEmpty(selected_object)) && (selected_object.type == "group"))
	    {
		selected_object.forEachObject(function (a) {
		    if (is_italic)
			a.set("fontStyle", "italic");
		    else
			a.set("fontStyle", "normal");
		    pcd_editor.canvas.renderAll();
		});
	    }
	});

	$("#o-thickness-slider").change(function ()
	{
	    var selected_object = pcd_editor.canvas.getActiveObject();
	    if ((!pcd_editor.isEmpty(selected_object)) && (selected_object.type == "i-text"))
	    {
		if ($(this).val() > 0)
		{
		    var stroke = $("#txt-outline-color-selector").css('background-color');
		    selected_object.set("strokeWidth", parseInt($(this).val()));
		    selected_object.set("stroke", stroke);
		} else
		    selected_object.set("stroke", false);
		pcd_editor.canvas.renderAll();
	    } else if ((!pcd_editor.isEmpty(selected_object)) && (selected_object.type == "group"))
	    {
		recreate_group(selected_object);
	    }
	});


	//Is curved checkbox

	function pcd_get_curved_state() {
	    if ($('.wpc-text-curved-wrap #cb-curved').is(':checked')) {

		$('.wpc-text-curved-wrap #cb-curved').parents('.wpc-text-curved-wrap').find('.wpc-text-curved-content').addClass('is-active');
	    } else {

		$('.wpc-text-curved-wrap #cb-curved').parents('.wpc-text-curved-wrap').find('.wpc-text-curved-content').removeClass('is-active');
	    }
	}

	$("#cb-curved").change(function ()
	{
	    pcd_get_curved_state();
	    var is_curved = $("#cb-curved").is(":checked");
	    var selected_object = pcd_editor.canvas.getActiveObject();

	    if (is_curved)
	    {
		if (!pcd_editor.isEmpty(selected_object))
		{

		    var left = selected_object.get("left");
		    var top = selected_object.get("top");
		    if (selected_object.type == "i-text")
		    {

			var text = selected_object.get("text");


			pcd_editor.canvas.remove(selected_object);
			add_curved_text(text, top, left);
			pcd_editor.save_canvas();
			pcd_editor.canvas.renderAll();
			$("#cb-curved").attr('checked', 'checked');
			$('.pcd-font-view').html(text);
		    }
		}
	    } else
	    {
		if (!pcd_editor.isEmpty(selected_object))
		{
		    var left = selected_object.get("left");
		    var top = selected_object.get("top");
		    if (selected_object.type == "group")
		    {
			var text = selected_object.get("originalText");
			pcd_editor.canvas.remove(selected_object);
			add_text(text, top, left);
			pcd_editor.save_canvas();
			pcd_editor.canvas.renderAll();
		    }
		}
	    }


	});

	$("#curved-txt-radius-slider, #curved-txt-spacing-slider").change(function () {
	    var selected_object = pcd_editor.canvas.getActiveObject();
	    if ((!pcd_editor.isEmpty(selected_object)) && (selected_object.type == "group"))
		recreate_group(selected_object);
	});

	$("[id$='opacity-slider']").change(function ()
	{
	    var selected_object = pcd_editor.canvas.getActiveObject();
	    if (!pcd_editor.isEmpty(selected_object))
	    {
		selected_object.set("opacity", $(this).val());
		pcd_editor.canvas.renderAll();
		pcd_editor.save_canvas();
	    }
	});
	$("#txt-text-color").css('background-color', $("#txt-text-color").val());
	$("#txt-text-color").bind("change", function () {
	    if ($(this).is('select')) {
		$(this).css('background-color', $(this).val());
		var selected_object = pcd_editor.canvas.getActiveObject();
		if (!pcd_editor.isEmpty(selected_object) && selected_object.type === "i-text")
		{
		    selected_object.set("fill", $(this).val());
		    pcd_editor.canvas.renderAll();
		    pcd_editor.save_canvas();
		}
	    }
	});
	$(".txt-decoration").change(function () 
	{
	    var selected_object = pcd_editor.canvas.getActiveObject();
	    var decoration = $(this).val();
            var decorations = ["underline", "linethrough", "overline"];
            
            


	    if ((!pcd_editor.isEmpty(selected_object)) && (selected_object.type == "i-text"))
	    {
                if(decoration == "none"){
                    $.each(decorations, function(index, value){
                        selected_object.set(value, false);
                    });
                }
                selected_object.set(decoration,true);
		pcd_editor.canvas.renderAll();
		
	    }
            pcd_editor.save_canvas();
	});



	function add_curved_text(str, custom_top, custom_left)
	{
	    var len = str.length;
	    var s;
	    var radius = $("#curved-txt-radius-slider").val();
	    var spacing = $("#curved-txt-spacing-slider").val();
	    var font_color = $("#txt-color-selector .pcd-color-view").css('background-color');
	    if (!radius)
		radius = 150;
	    if (!spacing)
		spacing = 10;
	    var curAngle = 0;
	    var angleRadians = 0;
	    var align = 0;
	    var centerX = pcd_editor.canvas.getWidth() / 2;
	    var centerY = pcd_editor.canvas.getHeight() - 30;
	    align = (spacing / 2) * (len - 1);
	    var reverse = false;
	    var coef = 1;
	    if (reverse)
		coef = -1;
	    var items = [];
	    for (var n = 0; n < len; n++) {
		s = str[n];

		var text = create_text_elmt(s);
		curAngle = (n * parseInt(spacing, 10)) - align;
		angleRadians = curAngle * (Math.PI / 180);
		if (reverse)
		{
		    curAngle = (-n * parseInt(spacing, 10)) + align;
		    angleRadians = curAngle * (Math.PI / 180);
		}

		var top = (centerX + (-Math.cos(angleRadians) * radius)) * coef;
		var left = (centerY + (Math.sin(angleRadians) * radius)) * coef;
		text.set('top', top);
		text.set('left', left);
		text.setAngle(curAngle);
		items.push(text);
	    }
	    var group = new fabric.Group(items, {
		left: 150,
		top: 100,
//                fontFamily: fontFamily,
//                fontSize: font_size,
//                fontWeight: fontWeight,
//                fontStyle: fontStyle,
//                textDecoration: textDecoration,
//                selectable: true,
		fill: font_color,
//                opacity: opacity,
	    });

	    if (custom_top != null)
		pcd_editor.canvas.setActiveObject(group);
	    pcd_editor.setCustomProperties(group);
	    group["originalText"] = str;
	    group["radius"] = radius;
	    group["spacing"] = spacing;
	    pcd_editor.canvas.add(group);

	    if (custom_top == null)
		group.center();
	    else
	    {
		group.set("left", custom_left);
		group.set("top", custom_top);
	    }

	    pcd_editor.save_canvas();
	    pcd_editor.canvas.renderAll();
	    group.setCoords();
	}

	function create_text_elmt(txt)
	{
	    var strokeWidth = $("#o-thickness-slider").val();
	    var fontWeight = "normal";
	    var textDecoration = "";
	    var fontStyle = "";
	    //var font_color = $("#txt-color-selector .pcd-color-view").css('background-color');
	    if (!$("#txt-text-color").length) {
		var font_color = $("#txt-text-color-value").val();
	    } else {
		var font_color = $("#txt-text-color").val();
	    }
	    var fontFamily = $("#font-family-selector").attr("value");;
	    var font_size = parseInt($("#font-size-selector").val());
	    var opacity = $("#opacity-slider").val();
	    var strokeColor = $("#txt-outline-color-selector").css('background-color');
//            var bgColor = $("#txt-bg-color-selector").css('background-color');

	    var is_bold = $("#bold-cb").is(":checked");
	    var is_underlined = $("#underline-cb").is(":checked");
	    var is_italic = $("#italic-cb").is(":checked");

	    if (is_bold)
		fontWeight = "bold";
	    if (is_underlined)
		textDecoration = "underline";
	    if (is_italic)
		fontStyle = "italic";
	    if (!fontFamily)
		fontFamily = 'Arial';
	    if (!font_size)
		font_size = 30;
	    if (!fontWeight)
		fontWeight = "normal";
	    if (!font_color)
		font_color = "rgb(198, 196, 196)";

	    if (!opacity)
		opacity = 1;
	    var text = new fabric.IText(txt, {
		left: 30,
		top: 70,
		fontFamily: fontFamily,
		fontSize: font_size,
		fontWeight: fontWeight,
		fontStyle: fontStyle,
		textDecoration: textDecoration,
		selectable: true,
		fill: font_color,
		opacity: opacity,

	    });
	    text.set("originX", pcd.originX);
	    text.set("originY", "center");
	    if (!pcd_editor.isEmpty(pcd_editor.pcd_metas["max-length"]))
	    {
		text.on('editing:entered', () => {
		    text.hiddenTextarea.setAttribute('maxlength', pcd_editor.pcd_metas["max-length"]);
		});
	    }

	    if (strokeWidth > 0)
	    {
		text.set("stroke", strokeColor);
		text.set("strokeWidth", parseInt(strokeWidth));
	    }
	    pcd_editor.setCustomProperties(text);

	    return text;
	}

	function recreate_group(group)
	{
	    var left = group.get("left");
	    var top = group.get("top");
	    pcd_editor.canvas.remove(group);
	    add_curved_text(group.originalText, top, left);
	}

	$('#new-text').keyup(function ()
	{
	    var selected_object = pcd_editor.canvas.getActiveObject();
	    var new_text = $('#new-text').val();
	    if ((!pcd_editor.isEmpty(selected_object)) && (selected_object.type == "i-text"))
	    {
		selected_object.set("text", new_text);
		pcd_editor.save_canvas();
		pcd_editor.canvas.renderAll();
	    } else if ((!pcd_editor.isEmpty(selected_object)) && (selected_object.type == "group"))
	    {
		var left = selected_object.get("left");
		var top = selected_object.get("top");
		pcd_editor.canvas.remove(selected_object);
		add_curved_text(new_text, top, left);
	    }
	});


	$('[id$="color-selector"]').each(function ()
	{
	    var id = $(this).attr("id");
	    var initial_color = $(this).css("background-color");
	    if (!initial_color)
		initial_color = "#0000ff";
	    if (pcd.palette_type == "custom")
	    {
		$('#' + id).qtip({
		    content: "<div class='wpc-custom-colors-container' data-id='" + id + "'>" + pcd.palette_tpl + "</div>",
		    position: {
			corner: {
			    target: 'middleRight',
			    tooltip: 'leftTop'
			}
		    },
		    style: {
			width: 200,
			padding: 5,
			background: 'white',
			color: 'black',
			//                        textAlign: 'center',
			border: {
			    width: 1,
			    radius: 1,
			    color: '#08AED6'
			}
		    },
		    tip: 'bottomLeft',
		    show: 'click',
		    hide: {when: {event: 'unfocus'}}
		});
	    } else
	    {
		/*$('#' + id).ColorPicker({
		 color: initial_color,
		 onShow: function (colpkr) {
		 $(colpkr).fadeIn(500);
		 return false;
		 },
		 onHide: function (colpkr) {
		 $(colpkr).fadeOut(500);
		 var selected_object = pcd_editor.canvas.getActiveObject();
		 if ((!pcd_editor.isEmpty(selected_object)))
		 {
		 pcd_editor.save_canvas();
		 }
		 return false;
		 },
		 onChange: function (hsb, hex, rgb) {
		 pcd_editor.change_item_color(id, hex);
		 }
		 });*/

		$('#' + id).spectrum({
		    flat: true,
		    showAlpha: false,
		    allowAlpha: true,
		    showPalette: false,
		    showButtons: false,
		    clickoutFiresChange: true,

		    color: initial_color,
		    show: function (colpkr) {
			$(colpkr).fadeIn(500);
			return false;
		    },
		    hide: function (colpkr) {
			$(colpkr).fadeOut(500);
			var selected_object = pcd_editor.canvas.getActiveObject();
			if ((!pcd_editor.isEmpty(selected_object)))
			{
			    pcd_editor.save_canvas();
			}
			return false;
		    },
		    change: function (hsb, hex, rgb) {
			console.log(id);
			pcd_editor.change_item_color(id, hex);
		    }
		});
	    }

	});


	//End Text

    })
    return pcd_editor;
}(jQuery, (PCD_EDITOR || {})))