var PCD_EDITOR = (function ($, pcd_editor) {

    $(document).on("touchstart click", "#grid-btn", function (e)
    {
	$(".upper-canvas").toggleClass("wpc-canvas-grid");
    });

    $(document).on("touchstart click", "#clear_all_btn", function (e)
    {
	e.preventDefault();
	var is_confirmed = confirm(pcd.translated_strings.delete_all_msg);
	if (is_confirmed)
	{
	    pcd_editor.canvas.clear();
	    pcd_editor.reload_background_overlay_if_needed(pcd_editor.selected_index, pcd_editor.save_canvas);
	}
    });

    $(document).on("touchstart click", "#delete_btn", function (e)
    {
	e.preventDefault();
	var selected_object = pcd_editor.canvas.getActiveObject();
	var selected_group = pcd_editor.canvas.getActiveGroup();
	var is_confirmed;
	if (selected_object != null)
	{
	    if (selected_object['lockDeletion']) {
		alert(pcd.translated_strings.deletion_error_msg);
	    } else
	    {
		is_confirmed = confirm(pcd.translated_strings.delete_msg);
		if (is_confirmed)
		{
		    if (selected_object.get('is_bounding_box_real_image'))
		    {
			window['box_img' + selected_object.box.clipId] = new fabric.Image.fromURL(PCD_EDITOR.upload_image_path, function (img) {
			    img.setPositionByOrigin({x: selected_object.box.left + selected_object.box.width / 2, y: selected_object.box.top + selected_object.box.height / 2}, 'center', 'center');
			    img.setCoords();
			    img.set('strokeWidth', selected_object.box.strokeWidth);
			    img.set('selectable', false);
			    img.set('clipName', selected_object.box.clipFor);
			    img.set('box', selected_object.box);
			    img.set('clipTo', function (ctx) {
				return _.bind(PCD_EDITOR.clipByName, img)(ctx);
			    });
			    img.set('is_bounding_box_upload_image', true);
			    img.on('mousedown', function (e) {
				$("#uploads-panel").trigger("click");
				$('.pcd-upload-notice').addClass('active');
				PCD_EDITOR.pcd_current_layout_image = this;
			    });
			    PCD_EDITOR.canvas.add(img);
			});
		    }
		    pcd_editor.canvas.remove(selected_object);
		    //                selected_object.remove();
		    pcd_editor.canvas.calcOffset();
		    pcd_editor.canvas.renderAll();
		    pcd_editor.save_canvas();
		}
	    }
	    ;
	} else if (selected_group != null)
	{
	    if (selected_group['lockDeletion']) {
		alert(pcd.translated_strings.deletion_error_msg);
	    } else
	    {
		is_confirmed = confirm('Do you really want to delete the selected items?'); // untranslated string
		if (is_confirmed)
		{
		    selected_group.forEachObject(function (a) {
			pcd_editor.canvas.remove(a);
		    });
		    pcd_editor.canvas.discardActiveGroup();
		    pcd_editor.canvas.calcOffset();
		    pcd_editor.canvas.renderAll();
		    pcd_editor.save_canvas();
		}

	    }
	    ;
	}
    });

    $(document).on("touchstart click", "#copy_paste_btn", function (e)
    {
	e.preventDefault();
	var selected_object = pcd_editor.canvas.getActiveObject();
	var selected_group = pcd_editor.canvas.getActiveGroup();
	if (selected_group != null)
	{
	    var new_group = new fabric.Group();
	    pcd_editor.canvas.discardActiveGroup();
	    pcd_editor.canvas.renderAll();
	    var objects = canvas.getObjects();
	    $.each(objects, function (key, current_item)
	    {
		if (selected_group.contains(current_item))
		{
		    cloneObject(current_item, false);
		}
	    });
	    pcd_editor.canvas.renderAll();
	    pcd_editor.save_canvas();
	} else if (selected_object != null)
	{
	    pcd_editor.canvas.discardActiveObject();
	    cloneObject(selected_object, true);
	    pcd_editor.save_canvas();
	}
    });

    function cloneObject(object, render_after)
    {
	var new_object = fabric.util.object.clone(object);
	new_object.set("top", new_object.top + 5);
	new_object.set("left", new_object.left + 5);
	pcd_editor.setCustomProperties(new_object);
	pcd_editor.canvas.add(new_object);
	if (render_after)
	{
	    pcd_editor.canvas.renderAll();
	    pcd_editor.save_canvas();
	}

    }

    $(document).on("touchstart click", "#bring_to_front_btn", function (e)
    {
	e.preventDefault();
	var selected_object = pcd_editor.canvas.getActiveObject();
	var selected_group = pcd_editor.canvas.getActiveGroup();
	if (selected_object != null)
	{
	    pcd_editor.canvas.bringForward(selected_object);
	    pcd_editor.canvas.renderAll();
	    pcd_editor.save_canvas();

	} else if (selected_group != null)
	{
	    selected_group.forEachObject(function (a) {
		pcd_editor.canvas.bringForward(a);
	    });
	    pcd_editor.canvas.discardActiveGroup();
	    pcd_editor.canvas.renderAll();
	    pcd_editor.save_canvas();
	}
    });

    $(document).on("touchstart click", "#send_to_back_btn", function (e)
    {
	e.preventDefault();
	var selected_object = pcd_editor.canvas.getActiveObject();
	var selected_group = pcd_editor.canvas.getActiveGroup();
	if (selected_object != null)
	{
	    pcd_editor.canvas.sendBackwards(selected_object);
	    pcd_editor.canvas.renderAll();
	    pcd_editor.save_canvas();
	} else if (selected_group != null)
	{
	    selected_group.forEachObject(function (a) {
		pcd_editor.canvas.sendBackwards(a);
	    });
	    pcd_editor.canvas.discardActiveGroup();
	    pcd_editor.canvas.renderAll();
	    pcd_editor.save_canvas();

	}
    });

    $(document).on("touchstart click", "#flip_h_btn", function (e)
    {
	e.preventDefault();
	var selected_object = pcd_editor.canvas.getActiveObject();
	var selected_group = pcd_editor.canvas.getActiveGroup();
	if (selected_object != null)
	{
	    if (selected_object.get("flipX") == true)
		selected_object.set("flipX", false);
	    else
		selected_object.set("flipX", true);
	    pcd_editor.canvas.renderAll();
	    pcd_editor.save_canvas();
	} else if (selected_group != null)
	{
	    if (selected_group.get("flipX") == true)
		selected_group.set("flipX", false);
	    else
		selected_group.set("flipX", true);
	    pcd_editor.canvas.renderAll();
	    pcd_editor.save_canvas();
	}
    });

    $(document).on("touchstart click", "#flip_v_btn", function (e)
    {
	e.preventDefault();
	var selected_object = pcd_editor.canvas.getActiveObject();
	var selected_group = pcd_editor.canvas.getActiveGroup();
	if (selected_object != null)
	{
	    if (selected_object.get("flipY") == true)
		selected_object.set("flipY", false);
	    else
		selected_object.set("flipY", true)
	    pcd_editor.canvas.renderAll();
	    pcd_editor.save_canvas();
	} else if (selected_group != null)
	{
	    if (selected_group.get("flipY") == true)
		selected_group.set("flipY", false);
	    else
		selected_group.set("flipY", true)
	    pcd_editor.canvas.renderAll();
	    pcd_editor.save_canvas();
	}

    });

    $(document).on("touchstart click", "#align_h_btn", function (e)
    {
	e.preventDefault();
	var selected_object = pcd_editor.canvas.getActiveObject();
	var selected_group = pcd_editor.canvas.getActiveGroup();
	if (selected_object != null)
	{
//            if (pcd_editor.box_center_x)
//            {
//                //Tmp fix to allow the center in the clipping area
//                selected_object.set("left", pcd_editor.box_center_x);
//            }
//            else
//            {
	    pcd_editor.centerObjectH(selected_object);
//            }
	    pcd_editor.canvas.renderAll();
	    selected_object.setCoords();
	    pcd_editor.save_canvas();
	} else if (selected_group != null)
	{
	    pcd_editor.centerObjectH(selected_group);
	    pcd_editor.canvas.renderAll();
	    selected_group.setCoords();
	    pcd_editor.save_canvas();
	}
    });

    $(document).on("touchstart click", "#align_v_btn", function (e)
    {
	e.preventDefault();
	var selected_object = pcd_editor.canvas.getActiveObject();
	var selected_group = pcd_editor.canvas.getActiveGroup();
	if (selected_object != null)
	{
//            if (pcd_editor.box_center_x)
//            {
//                //Tmp fix to allow the center in the clipping area
//                selected_object.set("top", pcd_editor.box_center_y);
//            }
//            else
	    pcd_editor.centerObjectV(selected_object);
	    pcd_editor.canvas.renderAll();
	    selected_object.setCoords();
	    pcd_editor.save_canvas();
	} else if (selected_group != null)
	{
	    pcd_editor.centerObjectV(selected_group);
	    pcd_editor.canvas.renderAll();
	    selected_group.setCoords();
	    pcd_editor.save_canvas();
	}


    });

    $(document).on("touchstart click", "#undo-btn", function (e)
    {
	e.preventDefault();
//                console.log()
	var current_data_id = $('li.phone-type-details[data-index="' + pcd_editor.selected_index + '"]').attr("data-index");
//                console.log(current_data_id, pcd_editor.canvasManipulationsPosition[current_data_id]);
	if (!$(this).hasClass("disabled") && pcd_editor.canvasManipulationsPosition[current_data_id] > 0)
	{
	    pcd_editor.canvas.clear();
	    pcd_editor.canvasManipulationsPosition[current_data_id]--;
	    pcd_editor.canvas.loadFromJSON(pcd_editor.serialized_parts[current_data_id][pcd_editor.canvasManipulationsPosition[current_data_id]], function () {
		pcd_editor.clipto_after_load_from_json();
		pcd_editor.load_background_overlay_if_needed(current_data_id);
		pcd_editor.rescale_canvas_if_needed();
	    });
	    pcd_editor.refresh_undo_redo_status();
	}
    });

    $(document).on("touchstart click", "#redo-btn", function (e)
    {
	e.preventDefault();
	var current_data_id = $('li.phone-type-details[data-index="' + pcd_editor.selected_index + '"]').attr("data-index");
	var next_index = pcd_editor.canvasManipulationsPosition[current_data_id] + 1;
	if (!$(this).hasClass("disabled") && typeof pcd_editor.serialized_parts[current_data_id][next_index] != "undefined")
	{
	    pcd_editor.canvas.clear();
	    pcd_editor.canvasManipulationsPosition[current_data_id] = next_index;
	    pcd_editor.canvas.loadFromJSON(pcd_editor.serialized_parts[current_data_id][next_index], function () {
		pcd_editor.clipto_after_load_from_json();
		pcd_editor.load_background_overlay_if_needed(current_data_id);
		pcd_editor.rescale_canvas_if_needed();
	    });
	    pcd_editor.refresh_undo_redo_status();
	}
    });
    return pcd_editor;
}(jQuery, (PCD_EDITOR || {})))