(function ($) {
    "use strict";
    $(document).ready(function () {
	var pcd_metas = JSON.parse(JSON.stringify(pcd_metas_json));
	PCD_EDITOR.pcd_metas=pcd_metas;
	$(".pcd-color-spectrum").spectrum({
	    flat: true,
	    showAlpha: false,
	    allowAlpha: true,
	    showPalette: false,
	    showButtons: false,
	    clickoutFiresChange: true,
	    preferredFormat: "hex",
	    move: function (color) {
		$(this).parents(".pcd-tool-row").find(".pcd-color-value").val(color);
		$(this).parents(".pcd-tool-row").find(".pcd-color-value").css('background-color', color);
		if ($(this).filter("#tab-background *").length > 0)
		{
		    PCD_EDITOR.setBackgroundColor(color);
		}
		if ($(this).is("#txt-text-color"))
		{
		    var selected_object = PCD_EDITOR.canvas.getActiveObject();
		    if (selected_object !== null && selected_object.type === "i-text")
		    {
			selected_object.set("fill",color);
			PCD_EDITOR.canvas.renderAll();
			PCD_EDITOR.save_canvas();
		    }
		}
	    }
	});

	$("#outline-color-selector").spectrum({
	    showAlpha: false,
	    allowAlpha: true,
	    showPalette: false,
	    showButtons: false,
	    clickoutFiresChange: true,
	    preferredFormat: "hex",
	    move: function (color) {
		$(this).parents(".pcd-tool-row").find(".pcd-color-value").val(color);

	    }
	});
	var pcd_brand_tab = [];
	PCD_EDITOR.setBackgroundColor = function (color)
	{
	    if ($('label.pcd-bg-or-not input[type="checkbox"]').is(":checked")) {
		$('label.pcd-bg-or-not input[type="checkbox"]').trigger("click");
	    }
	    if (jQuery.type(color) === "object") {
		color = color.toRgbString();
	    }
	    PCD_EDITOR.canvas.setBackgroundColor(color, PCD_EDITOR.canvas.renderAll.bind(PCD_EDITOR.canvas));
	    var selector = $('li.phone-type-details[data-index="' + PCD_EDITOR.selected_index + '"]');
	    selector.attr("data-bgcolor", color);
	    selector.attr("data-bg", "");
	    selector.attr("data-url", "");
	    PCD_EDITOR.save_canvas();
	};
	PCD_EDITOR.setBackgroundImage = function (src)
	{
	    var selector = $('li.phone-type-details[data-index="' + PCD_EDITOR.selected_index + '"]');
	    selector.attr("data-bgcolor", "");
	    selector.attr("data-url", "");
	    selector.attr("data-bg", src);
	    PCD_EDITOR.load_background_overlay_if_needed(PCD_EDITOR.selected_index);
	    PCD_EDITOR.save_canvas();
	};
	$(document).on('click', '.image-bg img', function ()
	{
	    var medium_url = $(this).attr("src");
	    PCD_EDITOR.setBackgroundImage(medium_url);
	});
	PCD_EDITOR.resetBackgroundColor = function ()
	{
	    var selector = $('li.phone-type-details[data-index="' + PCD_EDITOR.selected_index + '"]');

	    PCD_EDITOR.canvas.setBackgroundColor("", PCD_EDITOR.canvas.renderAll.bind(PCD_EDITOR.canvas));

	    selector.attr("data-bgcolor", "");
	    selector.attr("data-bg", "");
	    if ("undefined" !== typeof (pcd_models[PCD_EDITOR.pcd_metas["models"]]["cases"][selector.attr("data-caseid")]["image"]))
	    {
		selector.attr("data-url", pcd_models[PCD_EDITOR.pcd_metas["models"]]["cases"][selector.attr("data-caseid")]["image"]);
	    }
	    PCD_EDITOR.load_background_overlay_if_needed(PCD_EDITOR.selected_index);
	    PCD_EDITOR.save_canvas();


	};
	PCD_EDITOR.init_layouts = function (layouts)
	{

	    if (!PCD_EDITOR.isEmpty(layouts)) {
		$("#layout-container").html('');
		$.each(layouts, function (index, value) {
		    $("#layout-container").append('<li class="template-img layout-img" data-id="' + value["general_info"]["id"] + '"><img alt="image" src="' + value["general_info"]["path"] + '" class=""></li>');
		});
	    }
	};

	PCD_EDITOR.init_phone_case_editor = function (pcd_metas, pcd_layouts)
	{
	    var model = pcd_metas["models"];
//            $.each(pcd_metas["models"], function (index, value) {
	    if ("undefined" !== typeof (pcd_brand_tab[pcd_models[model]['brand']]) && null !== pcd_brand_tab[pcd_models[model]['brand']])
	    {
		pcd_brand_tab[pcd_models[model]['brand']].push(model);
	    } else
	    {
		$("#brand-loader").append('<li class="brand-name" data-value="' + pcd_models[model]['brand'] + '">' + pcd_models[model]['brand'] + '</li>');

		pcd_brand_tab[pcd_models[model]['brand']] = [];
		pcd_brand_tab[pcd_models[model]['brand']].push(model);
	    }
//            });
	    PCD_EDITOR.init_layouts(pcd_layouts);
//            $.each(pcd_templates, function (index, value) {
//                $("#pcd-templates-container").append('<li class="template-img pcd-templates-img" id="' + value["id"] + '"><img alt="image" src="' + value["path"] + '" class=""></li>');
//            });
	    PCD_EDITOR.pcd_metas = pcd_metas;
	    PCD_EDITOR.pcd_layouts = pcd_layouts;
	    // PCD_EDITOR.pcd_templates = pcd_templates;
	    if (typeof to_load === 'undefined')
	    {
		$("li.brand-name").first().trigger("click");
		$("li.model-name").first().trigger("click");
		if ($('li.phone-type-details[data-default="1"]').length)
		{
		    //$('li.phone-type-details[data-default="1"]').trigger("click");
		    setTimeout(function () {
			$('li.phone-type-details[data-default="1"]').trigger("click");
		    }, 1000);
		} else if ($('li.phone-type-details').first().length)
		{
		    setTimeout(function () {
			$('li.phone-type-details').first().trigger("click");
		    }, 1000);
		}
		$('li.wpc-tab-link[data-tab="tab-brand"]').trigger("click");

	    }
	    setTimeout(function () {
		$('#text-panel').trigger("click");
	    }, 3000);


	};
	PCD_EDITOR.get_canvas_image = function ()
	{
	    var boundind_boxs = _(PCD_EDITOR.canvas.getObjects()).filter({
		is_bounding_box: true
	    });
	    boundind_boxs.each(function (box) {
		box.set('strokeWidth', 0);
	    });
	    var boundind_boxs_uploaded_image = _(PCD_EDITOR.canvas.getObjects()).filter({
		is_bounding_box_upload_image: true
	    });
	    boundind_boxs_uploaded_image.each(function (click_to_upload_img) {
		click_to_upload_img.set({
		    opacity: 0,
		    selectable: false
		});
	    });

	    var link = document.getElementById('link');
	    link.setAttribute('download', 'MintyPaper.png');
	    link.setAttribute('href', PCD_EDITOR.canvas.toDataURL("image/png").replace("image/png", "image/octet-stream"));
	    link.click();
	    boundind_boxs.each(function (box) {
		if ("layout_1" !== box.layout_name)
		{
		    box.set('strokeWidth', 0.2);
		}
	    });
	    boundind_boxs_uploaded_image.each(function (click_to_upload_img) {
		click_to_upload_img.set({
		    opacity: 1,
		    selectable: false
		});
	    });
	    PCD_EDITOR.canvas.renderAll();
	};

	PCD_EDITOR.get_canvas_string = function ()
	{

	    var canvas_string = '';

	    var boundind_boxs_uploaded_image = _(PCD_EDITOR.canvas.getObjects()).filter({
		is_bounding_box_upload_image: true
	    });
	    boundind_boxs_uploaded_image.each(function (click_to_upload_img) {
		click_to_upload_img.set({
		    opacity: 0,
		    selectable: false
		});
	    });

	    canvas_string = JSON.stringify(PCD_EDITOR.canvas.toJSON(['lockMovementX', 'lockMovementY', 'lockRotation', 'lockScalingX', 'lockScalingY', 'price', 'lockDeletion', 'originalText', 'radius', 'spacing', 'clipFor', 'clipTo', 'clipId', 'clipName', 'layout_name', 'type', 'box', 'is_bounding_box', 'is_bounding_box_upload_image', 'is_bounding_box_real_image', 'selectable', 'box_type']));

	    boundind_boxs_uploaded_image.each(function (click_to_upload_img) {
		click_to_upload_img.set({
		    opacity: 1,
		    selectable: false
		});
	    });
	    PCD_EDITOR.canvas.renderAll();
	    canvas_string;
	    return canvas_string;
	};

	PCD_EDITOR.get_canvas_string_and_image = function ()
	{
	    PCD_EDITOR.get_canvas_image();
	    console.log(PCD_EDITOR.get_canvas_string());
	};


	PCD_EDITOR.upload_image = function (upload_path)
	{
	    var extension = upload_path.substr((upload_path.lastIndexOf('.') + 1));
	    console.log(extension);
	    var imgExts = ["jpg", "jpeg", "png", "gif", "ico"];
	    if (-1 !== $.inArray(extension, imgExts))
	    {
		$("#pcd-upload-image").prepend('<li class="clipart-img  image-uploaded"><span class="pcd-del-img fa fa-close"></span><img alt="image" id="5be08de62ecd2" src="' + upload_path + '"> </li>');
	    } else
	    {
		PCD_EDITOR.show_notification("Format not supported, try again.");
	    }
	};

	wp.hooks.addFilter('pcd.after_upload_image', 'get_tools_content_height');
	//PCD_EDITOR.upload_image("http://localhost/wpcd/wp-content/plugins/phone-case-designer/includes/skins/default/assets\/images\/iconLayout\/Uniongrid1.svg");



	$(document).on('click', 'li.brand-name', function () {

	    var model_content = '';
	    $.each(pcd_brand_tab[$(this).attr("data-value")], function (index, value) {
		model_content += '<li class="model-name" data-value="' + value + '">' + pcd_models[value]["name"] + '</li>';
	    });
	    $("#model-loader").html(model_content);
	    $('li.wpc-tab-link[data-tab="tab-model"]').trigger("click");
	});

//        $(document).on('click', 'li.pcd-templates-img', function () {
//            var template_id = $(this).attr("id");
//            PCD_EDITOR.save_canvas();
//            PCD_EDITOR.canvas.clear();
//            PCD_EDITOR.canvas.loadFromJSON(PCD_EDITOR.pcd_templates[template_id]['stringify'], function () {
//                var boundind_boxs = _(PCD_EDITOR.canvas.getObjects()).filter({
//                    is_bounding_box: true
//                });
//                var boundind_boxs_uploaded_image = _(PCD_EDITOR.canvas.getObjects()).filter({
//                    is_bounding_box_upload_image: true
//                });
//                boundind_boxs_uploaded_image.each(function (click_to_upload_img) {
//                    click_to_upload_img.set('clipTo', function (ctx) {
//                        return _.bind(PCD_EDITOR.clipByName, click_to_upload_img)(ctx);
//                    });
//                });
//                var bounding_box_real_image = _(PCD_EDITOR.canvas.getObjects()).filter({
//                    is_bounding_box_real_image: true
//                });
//                bounding_box_real_image.each(function (real_image) {
//
//                    real_image.set('clipTo', function (ctx) {
//                        return _.bind(PCD_EDITOR.clipByName, real_image)(ctx);
//                    });
//                });
//
//                PCD_EDITOR.canvas.renderAll.bind(PCD_EDITOR.canvas);
//                PCD_EDITOR.rescale_canvas_if_needed();
//            });
//
//
//            PCD_EDITOR.save_canvas();
//        });

	$(document).on('click', 'li.model-name', function () {
	    var case_content = '';
	    var model_id = $(this).attr("data-value");
	    var overlay = "";
	    var ovni = -1;
	    if ("undefined" !== typeof (pcd_models[$(this).attr("data-value")]["cases"]) && null !== pcd_models[$(this).attr("data-value")]["cases"] && $.isArray(pcd_models[$(this).attr("data-value")]["cases"]))
	    {
		$.each(pcd_models[$(this).attr("data-value")]["cases"], function (index, value) {
		    var brand = pcd_models[model_id]['brand'];
		    if ("" !== value.overlay)
		    {
			overlay = value.overlay;
			ovni = 1;
		    } else
		    {
			overlay = "";
			ovni = -1;

		    }
		    case_content += ' <li class="phone-type-details" data-bgcolor data-default="" data-index="' + model_id + '_' + index + '" data-url="' + pcd_background_model + brand + '/' + value.image + '" data-bg="" data-caseid="' + index + '" data-modelid="' + model_id + '" data-placement="top"  data-ov="' + pcd_overlay_model + brand + '/' + overlay + '" data-ovni="' + ovni + '"><div><img alt="image" src="' + pcd_icon_model + brand + '/' + value.icon + '" class="phone-type-img"><span class="type-name">' + value.name + '</span> <span class="type-description">' + value.desc + '</span></div></li>';

		});
	    }
	    $("#cases-loader").html(case_content);
	    $('li.wpc-tab-link[data-tab="tab-type"]').trigger("click");
	    if (!PCD_EDITOR.isEmpty(PCD_EDITOR.pcd_metas) && !PCD_EDITOR.isEmpty(PCD_EDITOR.pcd_metas["cases-type-settings"]) && PCD_EDITOR.pcd_metas["cases-type-settings"] === "photo")
	    {
		var selected_layouts = pcd_models[$(this).attr("data-value")]["select-layouts"];

		if (!PCD_EDITOR.isEmpty(selected_layouts))
		{
		    var layouts_tab = [];
		    $.each(selected_layouts, function (index, value) {
			if (value === "all")
			{
			    PCD_EDITOR.init_layouts(PCD_EDITOR.pcd_layouts);
			} else
			{
			    layouts_tab.push(PCD_EDITOR.pcd_layouts[value]);
			}
		    });
		    if (!PCD_EDITOR.isEmpty(layouts_tab))
		    {
			PCD_EDITOR.init_layouts(layouts_tab);
		    }
		}
	    }

	});

	//var pcd_templates = {"template_1": {"id": "template_1", "name": "Template 1", "path": "http://localhost/wpcd/wp-content/plugins/phone-case-designer/includes/skins/default/assets\/images\/template1.png", "stringify": "{\"objects\":[{\"type\":\"circle\",\"originX\":\"left\",\"originY\":\"top\",\"left\":60,\"top\":196.33,\"width\":180,\"height\":180,\"fill\":\"transparent\",\"stroke\":\"red\",\"strokeWidth\":0.2,\"strokeDashArray\":[5,5],\"strokeLineCap\":\"butt\",\"strokeLineJoin\":\"miter\",\"strokeMiterLimit\":10,\"scaleX\":1,\"scaleY\":1,\"angle\":0,\"flipX\":false,\"flipY\":false,\"opacity\":1,\"shadow\":null,\"visible\":true,\"clipTo\":null,\"backgroundColor\":\"\",\"fillRule\":\"nonzero\",\"globalCompositeOperation\":\"source-over\",\"lockMovementX\":false,\"lockMovementY\":false,\"lockRotation\":false,\"lockScalingX\":false,\"lockScalingY\":false,\"radius\":90,\"clipFor\":\"box_0_0_layout_6\",\"clipId\":\"box_0_0_layout_6\",\"layout_name\":\"layout_6\",\"is_bounding_box\":true,\"selectable\":false,\"box_type\":\"circle\",\"startAngle\":0,\"endAngle\":6.283185307179586},{\"type\":\"image\",\"originX\":\"left\",\"originY\":\"top\",\"left\":30.79,\"top\":182,\"width\":187.09,\"height\":180,\"fill\":\"rgb(0,0,0)\",\"stroke\":null,\"strokeWidth\":0.2,\"strokeDashArray\":null,\"strokeLineCap\":\"butt\",\"strokeLineJoin\":\"miter\",\"strokeMiterLimit\":10,\"scaleX\":1.17,\"scaleY\":1.22,\"angle\":0,\"flipX\":false,\"flipY\":false,\"opacity\":1,\"shadow\":null,\"visible\":true,\"backgroundColor\":\"\",\"fillRule\":\"nonzero\",\"globalCompositeOperation\":\"source-over\",\"lockMovementX\":false,\"lockMovementY\":false,\"lockRotation\":false,\"lockScalingX\":false,\"lockScalingY\":false,\"clipName\":\"box_0_0_layout_6\",\"box\":{\"type\":\"circle\",\"originX\":\"left\",\"originY\":\"top\",\"left\":60,\"top\":196.33,\"width\":180,\"height\":180,\"fill\":\"transparent\",\"stroke\":\"red\",\"strokeWidth\":0.2,\"strokeDashArray\":[5,5],\"strokeLineCap\":\"butt\",\"strokeLineJoin\":\"miter\",\"strokeMiterLimit\":10,\"scaleX\":1,\"scaleY\":1,\"angle\":0,\"flipX\":false,\"flipY\":false,\"opacity\":1,\"shadow\":null,\"visible\":true,\"clipTo\":null,\"backgroundColor\":\"\",\"fillRule\":\"nonzero\",\"globalCompositeOperation\":\"source-over\",\"radius\":90,\"startAngle\":0,\"endAngle\":6.283185307179586},\"is_bounding_box_real_image\":true,\"selectable\":true,\"src\":\"http:\/\/localhost\/phonecas-desktop-skin\/assets\/images\/hoodie-with-zipper.png\",\"filters\":[{\"type\":\"Grayscale\"}],\"crossOrigin\":\"\",\"alignX\":\"none\",\"alignY\":\"none\",\"meetOrSlice\":\"meet\"}],\"background\":\"rgb(48, 150, 157)\",\"overlayImage\":{\"type\":\"image\",\"originX\":\"center\",\"originY\":\"center\",\"left\":150,\"top\":294.5,\"width\":299.16,\"height\":589,\"fill\":\"rgb(0,0,0)\",\"stroke\":null,\"strokeWidth\":1,\"strokeDashArray\":null,\"strokeLineCap\":\"butt\",\"strokeLineJoin\":\"miter\",\"strokeMiterLimit\":10,\"scaleX\":1,\"scaleY\":1,\"angle\":0,\"flipX\":false,\"flipY\":false,\"opacity\":1,\"shadow\":null,\"visible\":true,\"clipTo\":null,\"backgroundColor\":\"\",\"fillRule\":\"nonzero\",\"globalCompositeOperation\":\"source-over\",\"src\":\"http:\/\/localhost\/phonecas-desktop-skin\/assets\/images\/iphoneXoverlay.png\",\"filters\":[],\"crossOrigin\":\"\",\"alignX\":\"none\",\"alignY\":\"none\",\"meetOrSlice\":\"meet\"},\"clipTo\":null}"}};
	PCD_EDITOR.init_phone_case_editor(pcd_metas, pcd_layouts);

	//Change ColorPicker value according to text user entered in field
	$(document).on('change', '.pcd-color-value', function () {
	    $(this).parents(".pcd-tool-row").find(".pcd-color-spectrum").spectrum("set", $(this).val());
	    //console.log( $(this).val(), $(this).parents(".pcd-tool-row").find(".pcd-color-spectrum").spectrum("get").toHexString())
	});
	$(document).on('change', '#bg-color-value', function () {
	    PCD_EDITOR.setBackgroundColor($(this).val());
	    //console.log( $(this).val(), $(this).parents(".pcd-tool-row").find(".pcd-color-spectrum").spectrum("get").toHexString())
	});

	//no background-color for Layout 
	$(document).on('change', 'label.pcd-bg-or-not input[type="checkbox"]', function () {
	    var fieldColorValue = $(this).parents(".pcd-tool-row").find(".pcd-color-value");
	    if ($(this).is(":checked")) {
		fieldColorValue.val('').prop('disabled', true);
		PCD_EDITOR.resetBackgroundColor();
	    } else
	    {
		fieldColorValue.prop('disabled', false);
	    }
	});


	/*close on click*/
	$(document).on('touchstart click', '.pcd-notifications span.wpc-tools-close', function () {
	    $(this).parent(".pcd-notifications").hide();
	});


    });
})(jQuery);