<?php
/**
 * Default skin code.
 *
 * @link       http://orionorigin.com
 * @since      1.0
 *
 * @package    Pcd
 * @subpackage Pcd/includes
 */

/**
 * Default skin class.
 *
 * This class defines all code necessary for default skin.
 *
 * @since      1.0
 * @package    Pcd
 * @subpackage Pcd/includes
 * @author     ORION <support@orionorigin.com>
 */
class PCD_Skin_Default {

    /**
     * The editor.
     *
     * @var type the editor.
     */
    public $editor;

    /**
     * The metta.
     *
     * @var type the meta.
     */
    public $pcd_metas;

    /**
     * The constructor.
     *
     * @param type $editor_obj the editor object.
     * @param type $pcd_metas the meta.
     */
    public function __construct( $editor_obj, $pcd_metas ) {
	if ( $editor_obj ) {
	    $this->editor	 = $editor_obj;
	    $this->pcd_metas = $pcd_metas;
	}
    }

    /**
     * Display skin.
     */
    public function display() {
	global $pcd_settings;
	$pcd_settings = apply_filters( 'pcd_global_settings', $pcd_settings );

	ob_start();

	$this->register_styles();
	$this->register_scripts();

	$uploads_options	 = get_proper_value( $pcd_settings, 'pcd-upload-options', array() );
	$pcd_social_networks	 = get_proper_value( $pcd_settings, 'pcd_social_networks', array() );
	$facebook_app_id	 = get_proper_value( $pcd_social_networks, 'pcd-facebook-app-id', '' );
	$facebook_app_secret	 = get_proper_value( $pcd_social_networks, 'pcd-facebook-app-secret', '' );
	$instagram_app_id	 = get_proper_value( $pcd_social_networks, 'pcd-instagram-app-id', '' );
	$instagram_app_secret	 = get_proper_value( $pcd_social_networks, 'pcd-instagram-app-secret', '' );
	?>
	<div class="phonecase-template" >
	    <span style="display: none"><input type="file" name="userfile" id="layout_file"></span>
	    <a id="link"></a>


	    <div class="wpc-container wpc-porto-skin pcd-responsive-mode">      
		<div class="wpc-editor-wrap ">
		    <div class="wpc-editor-col wpc-editor-col-tools is-open">
			<div class="wpc-tools-container"> 
			    <div class="wpc-tools-wrap">
				<?= $this->get_product_details(); ?>
			    </div>

			    <div class="wpc-tools-wrap">
				<?= $this->get_cliparts(); ?>
			    </div>
			    <div class="wpc-tools-wrap">
				<?php echo $this->get_uploads_tools( $facebook_app_id, $instagram_app_id, $facebook_app_secret, $instagram_app_secret, $uploads_options ); ?>
			    </div>
			    <div class="wpc-tools-wrap">
				<?= $this->get_layouts( $uploads_options ); ?>
			    </div>

			    <div class="wpc-tools-wrap">
				<?= $this->get_text_tools(); ?>
			    </div>     
			    <div class="pcd-tools-wrap">
				<?php echo $this->get_design_tools(); ?>
			    </div>
			    <div class="wpc-tools-wrap">
				<?= $this->get_cart_tools(); ?>
			    </div>
                            <div class="wpc-tools-wrap">
                                <div id="pcd-filters-tools-wrap" class="wpc-tools-content">
                                     <?php echo $this->get_uploads_filters_tools(); ?>
                                </div>
                            </div>

			</div>
		    </div>
		    <div class="wpc-editor-col-2">
			<div class="container">
			    <div id="tab-customize" class="wpc-tab-content current">

				<div id="wpc-editor-container">
				    <?= $this->get_toolbar(); ?>
				    <span>
					<canvas id="wpc-editor"></canvas>
				    </span>
				    <?= $this->get_rigth_toolbar(); ?>
				</div>
			    </div>                 
			    <div id="debug-wrap"><div id="debug"></div><div class="debug-icon ti-close"></div></div>       
			</div>

		    </div>
		</div>
	    </div>


	    <?= $this->get_preview_modal(); ?>

	</div>
	<?php
	$output			 = ob_get_clean();
	return $output;
    }

    /**
     * Get design tools.
     *
     * @return Sting $output The output.
     */
    private function get_design_tools() {
	ob_start();
	global $current_user;
	$user_designs		 = get_user_meta( $current_user->ID, 'pcd_saved_designs' );
	$user_orders_designs	 = pcd_get_user_orders_designs( $current_user->ID );
	?>
	<div class="wpc-tools-head" id="user-designs-panel">
	    <div id="my-designs" class="icon-342"></div>
	</div>
	<div id="user-designs-panel-content" class="wpc-tools-content">
	    <?php
	    if ( is_user_logged_in() ) {
		?>
	        <div  class="wpc-panel-head">
	    	<div class="wpc-panel-title">My Designs</div>
	    	<span id="user-designs-panel-close" class="wpc-tools-close fa fa-close"></span>
	    	<ul id="pcd-user-designs-tabs" class="wpc-tabs">
	    	    <li class="wpc-tab-link current" data-tab="tab-saved-design">Saved Designs</li>
	    	    <li class="wpc-tab-link" data-tab="tab-past-orders">Past Orders</li>
	    	</ul>
	        </div>
	        <div id="my-designs-accordions" class="" tabindex="0">
	    	<div id="tab-saved-design" class="wpc-tab-content current">
	    	    <div class="wpc-tab-content-wrapper">
			    <?= $this->get_user_design_output_block( $user_designs ); ?>
			    <?= $this->get_user_design_output_content( $user_designs ); ?>
	    	    </div>
	    	</div>
	    	<div id="tab-past-orders" class="wpc-tab-content ">
	    	    <div class="wpc-tab-content-wrapper">
	    		<div></div>
	    	    </div>
	    	</div>
	        </div>
		<?php
	    } else {
		?>
	        <div  class="wpc-panel-head">
	    	<div class="pcd-panel-title">My Designs</div>
	    	<span id="user-designs-panel-close" class="wpc-tools-close fa fa-close"></span>
	        </div>
		<?php
		_e( 'You need to be logged in before loading your designs.', 'pcd' );
	    }
	    ?>               
	</div>   
	<?php
	$output = ob_get_clean();
	return $output;
    }

    /**
     * Get user design output block.
     * 
     * @param type $user_designs The user design.
     * @return type The output.
     */
    private function get_user_design_output_block( $user_designs ) {
	ob_start();
	?>
	<div>
	    <?php
	    if ( ! empty( $user_designs ) ) {
		foreach ( $user_designs as $s_index => $user_design ) {
		    if ( ! empty( $user_design ) ) {
			$variation_id	 = $user_design[ 0 ];
			$save_time	 = $user_design[ 1 ];
			$design_name	 = $user_design[ 2 ];
			$order_item_id	 = '';
			if ( count( $user_design ) >= 5 ) {
			    $order_item_id = $user_design[ 4 ];
			}
			?>
		        <div class="pcd_order_item" data-variation-id="<?= $variation_id; ?>" data-save-time="<?= $save_time; ?>" data-item='<?= $variation_id; ?>' data-design-name="<?= $design_name; ?>" data-order-item-id="<?= $order_item_id; ?>"><div><?= $design_name . " - " . $save_time; ?></div></div>
			<?php
		    }
		}
	    }
	    ?>
	</div>
	<?php
	$output = ob_get_clean();
	return $output;
    }

    private function get_user_design_output_content( $user_designs ) {
	ob_start();
	foreach ( $user_designs as $s_index => $user_design ) {
	    if ( ! empty( $user_design ) ) {
		$variation_id	 = $user_design[ 0 ];
		$save_time	 = $user_design[ 1 ];
		$design_name	 = $user_design[ 2 ];
		$design_data	 = $user_design[ 3 ];
		$order_item_id	 = '';
		if ( count( $user_design ) >= 5 ) {
		    $order_item_id = $user_design[ 4 ];
		}
		?>
		<div id="my-design-options-wrap" class="pcd-group-child-wrap" data-variation-id="<?= $variation_id; ?>" data-save-time="<?= $save_time; ?>" data-design-name="<?= $design_name; ?>" data-order-item-id="<?= $order_item_id; ?>">
		    <div class="pcd-child-wrap-close icon-557"></div>
		    <div class="pcd-my-design-preview">
			<?php
			if ( is_array( $design_data ) ) {
			    $tmp_dir = $design_data[ 'output' ][ 'working_dir' ];
			    $datas	 = $design_data[ 'output' ][ 'files' ];
			    foreach ( $datas as $data_key => $data ) {
				if ( ! empty( $data ) ) {
				    $generation_url		 = PCD_SAVED_DESIGN_UPLOAD_URL . "/$tmp_dir/$data_key/";
				    $img_src		 = $generation_url . $data[ 'image' ];
				    $original_part_img_url	 = $design_data[ $data_key ][ "original_part_img" ];
				    echo $data_key;
				    ?>
			    	<div data-name="<?= $data_key; ?>" data-variation-id="<?= $variation_id; ?>" data-save-time="<?= $save_time; ?>" data-design-name="<?= $design_name; ?>" data-order-item-id="<?= $order_item_id; ?>" style="background-image:url('<?= $original_part_img_url; ?>')" class="my-design-bg-image">
			    	    <img src="<?= $img_src; ?>" alt="part">
			    	</div>
				    <?php
				}
			    }
			    ?>
		        </div>
		        <div class="pcd-tool-row">
			    <?php
			    $pcd_product = new PCD_Product( $variation_id );
			    if ( $order_item_id ) {
				$btn_load_url = $pcd_product->get_design_url( false, false, $order_item_id );
				?>
				<a class="wpc-btn-effect" href="<?= $btn_load_url; ?>" > Load </a>
				<?php
			    } else {
				$btn_load_url = $pcd_product->get_design_url( $s_index );
				?>
				<a class="wpc-btn-effect" href="<?= $btn_load_url; ?>" > Load </a>
				<a class="wpc-btn-effect pcd-delete-design" data-index="<?= $s_index; ?>"> Delete </a>
				<?php
			    }
			    ?>
		        </div>
		    </div>
		    <?php
		}
	    }
	}
	$output = ob_get_clean();
	return $output;
    }

    private function get_preview_modal() {
	ob_start();
	?>
	<div class="omodal fade o-modal pcd-modal" id="pcd-modal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
	    <div class="omodal-dialog">
		<div class="omodal-content">
		    <div class="omodal-header">
			<button type="button" class="close fa fa-close" data-dismiss="omodal" aria-hidden="true"></button>
			<h4 class="omodal-title" id="myModalLabel">PREVIEW</h4>
		    </div>
		    <div class="omodal-body txt-center">
		    </div>
		</div>
	    </div>
	</div>
	<?php
	$output = ob_get_clean();
	return $output;
    }

    private function get_rigth_toolbar() {
	ob_start();
	global $wp_query;
	$design_index = -1;
	if ( isset( $wp_query->query_vars[ 'design_index' ] ) ) {
	    $design_index = $wp_query->query_vars[ 'design_index' ];
	}
	?>

	<span class="pcd-editor-right-tools-wrap">
	    <div class="wpc-button-bar-wrap">
		<div class="wpc-button-bar">
		    <span id="undo-btn" class="icon-pcd_icons-09 disabled" data-placement="left" data-tooltip-title="Undo"></span>
		    <span id="redo-btn" class="icon-pcd_icons-08 disabled" data-placement="left" data-tooltip-title="Redo"></span>
                    <span id="clear_all_btn" class="icon-1407" data-placement="left" data-tooltip-title="Clear all"></span>

                </div>
		<div class="wpc-button-bar">
		    <span id="delete_btn" class="icon-014 pcd_btn_hidden" data-placement="left" data-tooltip-title="Delete"></span>
		</div>
		<div class="wpc-button-bar">

		    <span id="preview-btn" class="icon-491" data-placement="left" data-tooltip-title="Preview"></span>
		    <span id="download-btn" class="icon-1166" data-placement="left" data-tooltip-title="Download"></span>
		    <span id="save-btn" class="icon-612" data-placement="left" data-index="-1" data-tooltip-title="Save" data-toggle="o-modal" data-target="#pcd_save_design"></span>


		</div>
	    </div>
	    <div class="omodal fade o-modal pcd-modal" id="pcd_save_design" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
		<div class="omodal-dialog">
		    <div class="omodal-content">
			<div class="omodal-header">
			    <button type="button" class="close ti-close" data-dismiss="omodal" aria-hidden="true"></button>
			    <h4 class="omodal-title" id="myModalLabel">Save design</h4>
			</div>
			<div class="omodal-body txt-center">
			    <?php
			    if ( isset( $design_index ) && $design_index >= 0 ) {
				?>
	    		    <p>You try to make a backup from another save, Would you like to overwrite the previous backup by this one?</p>
	    		    <button id="save-btn" class="wpc-btn-effect" data-index="<?= $design_index; ?>" data-action="replace">Replace</button>
	    		    <button id="save-btn" class="wpc-btn-effect" data-index="<?= $design_index; ?>" data-action="new-save">New Save</button>
				<?php
			    } else {
				?>
	    		    <input id="design-name" type="text" class="text-element-border text-container " name="design-name" placeholder="Design name" required>
	    		    <button id="save-btn" class="wpc-btn-effect" data-index="<?= $design_index; ?>">Save</button>
				<?php
			    }
			    ?>
			</div>
		    </div>
		</div>
	    </div>
	</span>
	<?php
	$output = ob_get_clean();
	return $output;
    }

    private function get_toolbar() {
	ob_start();
	?>

	<span class="pcd-editor-left-tools-wrap">
	    <div class="wpc-button-bar-wrap">
		<div class="wpc-button-bar">
		    <!-- <span id="grid-btn" class="icon-1216 swiper-slide" data-placement="right" data-tooltip-title="grid"></span> -->
		    <span id="copy_paste_btn" class="icon-443 pcd_btn_hidden" data-placement="right" data-tooltip-title="Duplicate"></span>
		    <span id="align_btn" class="icon-683 pcd_btn_hidden" data-placement="right" data-tooltip-title="Alignments"></span>
		    <div class="align_btn_wrap">
			<div>
			    <span id="send_to_back_btn" class="icon-677" data-placement="bottom" data-tooltip-title="Send to back"></span>
			    <span id="bring_to_front_btn" class="icon-676" data-placement="bottom" data-tooltip-title="Bring to front"></span>
			    <span id="flip_h_btn" class="icon-687" data-placement="bottom" data-tooltip-title="Flip horizontally"></span>
			    <span id="flip_v_btn" class="icon-691" data-placement="top" data-tooltip-title="Flip vertically"></span>
			    <span id="align_h_btn" class="icon-680" data-placement="top" data-tooltip-title="Center horizontally"></span>
			    <span id="align_v_btn" class="icon-682" data-placement="top" data-tooltip-title="Center vertically"></span>
			</div>
		    </div>
		</div>

		<!--ici à dynamiser. le bloc doit partir. le lien chargé ne doit pas forcément se baser sur l'existence de cet élément de dom-->
		<div id="product-part-container" style="display: none;">
		    <ul id="wpc-parts-bar">
			<li data-id="front" data-url="" data-bg="<?= PCD_URL . 'includes/skins/default/assets/' ?>/images/preview.png" class="active first active" data-placement="top" data-tooltip-title="Front" data-ov="" data-ovni="-1">
			    <img alt="image" src="<?= PCD_URL . 'includes/skins/default/assets/' ?>/images/preview.png" class="mCS_img_loaded">          
			</li>
		    </ul>
		</div>
		<!--ici à dynamiser. Fin-->
	    </div>
	</span>
	<?php
	$output = ob_get_clean();
	return $output;
    }

    private function get_cart_tools() {

	global $wp_query;
	$product	 = wc_get_product( $this->editor->item_id );
	$tpl_price	 = 0;
	if ( isset( $wp_query->query_vars[ 'tpl' ] ) ) {
	    $tpl_id		 = $wp_query->query_vars[ 'tpl' ];
	    $tpl_price	 = pcd_get_template_price( $tpl_id );
	}

	$add_to_cart_label = __( 'Add to cart', 'pcd' );
	if ( isset( $wp_query->query_vars[ 'edit' ] ) ) {
	    $add_to_cart_label = __( 'Update cart item', 'pcd' );
	}

	ob_start();
	?>

	<div class="wpc-tools-head" id="add-cart-panel">
	    <div id="add-cart-content" class="iconB iconB-shopping-cart"></div>
	</div>
	<div id="add-cart-panel-content" class="wpc-tools-content">
	    <div  class="wpc-panel-head">
		Cart                                               
		<span id="add-cart-panel-close" class="wpc-tools-close fa fa-close"></span>
	    </div>
	    <div id="wpc-cart-box" class="">  
		<?php
		if ( isset( $this->pcd_meta[ 'related-quantities' ] ) && ! empty( $this->pcd_meta[ 'related-quantities' ] ) && $product->get_type() == 'variation' ) {
		    $related_attributes = $this->pcd_metas[ 'related-quantities' ];

		    $pcd_root_product = new PCD_Product( $this->editor->root_item_id );

		    $usable_attributes = $pcd_root_product->extract_usable_attributes();

		    $variation = wc_get_product( $this->editor->item_id );

		    $variation_to_load_tab = pcd_get_variation_from_attributes( $variation->get_parent_id() );

		    $_SESSION[ 'combinaison' ] = [];
		    if ( ! empty( $variation_to_load_tab ) ) {
			foreach ( $variation_to_load_tab as $variation_to_load ) {
			    $variation_to_load_ob	 = wc_get_product( $variation_to_load );
			    $quantity_display	 = '';
			    if ( $variation_to_load_ob->is_sold_individually() ) {
				$quantity_display = "style='display: none;'";
			    }

			    $pcd_variation		 = new PCD_Product( $variation_to_load );
			    $purchase_properties	 = $pcd_variation->get_purchase_properties();
			    $selected_attributes	 = wc_get_product( $variation_to_load )->get_variation_attributes();
			    $price			 = $variation_to_load_ob->get_price() + $tpl_price;
			    $price_html		 = ' <span class="total_order">' . wc_price( $price * $purchase_properties[ 'min_to_purchase' ] ) . '</span>';
			    $to_search		 = $selected_attributes;
			    foreach ( $usable_attributes as $attribute_name => $attribute_data ) {
				$attribute_key = $attribute_data[ 'key' ];
				if ( in_array( $attribute_key, $related_attributes ) ) {
				    $to_search[ $attribute_key ] = array();
				    foreach ( $attribute_data[ 'values' ] as $attribute_value ) {
					if ( is_object( $attribute_value ) ) {
					    $sanitized_value = $attribute_value->slug;
					    $label		 = $attribute_value->name;
					} else {
					    $sanitized_value = sanitize_title( $attribute_value );
					    $label		 = $attribute_value;
					}
					array_push( $to_search[ $attribute_key ], $label );
				    }
				}
			    }
			    $combinaisons	 = [];
			    $combinaisons[]	 = $selected_attributes;
			    $combine	 = false;
			    foreach ( $selected_attributes as $key => $value ) {
				if ( '' === $value && ! empty( $to_search[ $key ] ) ) {
				    $combine	 = true;
				    $combinaisons	 = pcd_make_variation_combine( $key, $to_search[ $key ], $combinaisons );
				}
			    }
			    // Variation properties
			    if ( $combine ) {
				foreach ( $combinaisons as $combinaison ) {
				    $array_key	 = array_keys( $combinaison );
				    $end		 = end( $array_key );
				    $key		 = '';
				    foreach ( $combinaison as $combinaison_key => $value ) {
					if ( $end !== $combinaison_key ) {
					    $key .= $value . '+';
					} else {
					    $key .= $value;
					}
				    }
				    $_SESSION[ 'combinaison' ][ $key ] = $combinaison;
				    ?>
			    	<div class="wpc-qty-container" data-id="<?php echo $variation_to_load; ?>" <?php echo $quantity_display; ?>>
			    	    <label><?php echo $key; ?></label>
			    	    <input type="button" id="minus" value="-" class="minus wpc-custom-right-quantity-input-set wpc-btn-effect">
			    	    <input type="number" variation_name="<?= $key ?>" step="<?php echo $purchase_properties[ 'step' ]; ?>" value="<?php echo $purchase_properties[ 'min_to_purchase' ]; ?>" class="wpc-custom-right-quantity-input pcd-qty" min="<?php echo $purchase_properties[ 'min' ]; ?>" max="<?php echo $purchase_properties[ 'max' ]; ?>" dntmesecondfocus="true" uprice="<?php echo $price; ?>"  >
			    	    <input type="button" id="plus" value="+" class="plus wpc-custom-right-quantity-input-set wpc-btn-effect">

			    	    <div class="total-price">
					    <?php echo $price_html; ?>
			    	    </div>
			    	</div>
				    <?php
				}
			    } else {
				$variation_to_load_attributes	 = $variation_to_load_ob->get_variation_attributes();
				$attribute_str			 = '';

				foreach ( $variation_to_load_attributes as $variation_to_load_attribute_key => $variation_to_load_attribute ) {
				    if ( in_array( $variation_to_load_attribute_key, $related_attributes ) ) {
					if ( ! empty( $attribute_str ) && '' !== $variation_to_load_attribute ) {
					    $attribute_str .= '+';
					}
					$attribute_str .= $variation_to_load_attribute;
				    }
				}
				?>
				<div class="wpc-qty-container" data-id="<?php echo $variation_to_load; ?>" <?php echo $quantity_display; ?>>
				    <label><?php echo $attribute_str; ?></label>
				    <input type="button" id="minus" value="-" class="minus wpc-custom-right-quantity-input-set wpc-btn-effect">
				    <input type="number" variation_name="<?= $attribute_str ?>" step="<?php echo $purchase_properties[ 'step' ]; ?>" value="<?php echo $purchase_properties[ 'min_to_purchase' ]; ?>" class="pcd-custom-right-quantity-input pcd-qty" min="<?php echo $purchase_properties[ 'min' ]; ?>" max="<?php echo $purchase_properties[ 'max' ]; ?>" dntmesecondfocus="true" uprice="<?php echo $price; ?>"  >
				    <input type="button" id="plus" value="+" class="plus wpc-custom-right-quantity-input-set wpc-btn-effect">
				    <div class="total-price">
					<?php echo $price_html; ?>
				    </div>
				</div>
				<?php
			    }
			}
		    }
		} else {
		    $purchase_properties	 = $this->editor->pcd_product->get_purchase_properties();
		    $price			 = $product->get_price() + $tpl_price;
		    $price_html		 = ' <span class="total_order">' . wc_price( $price * $purchase_properties[ 'min_to_purchase' ] ) . '</span>';
		    $custom_quantity	 = isset( $_GET[ 'custom_qty' ] ) ? $_GET[ 'custom_qty' ] : $purchase_properties[ 'min_to_purchase' ];
		    $quantity_display	 = '';
		    if ( $product->is_sold_individually() ) {
			$quantity_display = "style='display: none;'";
		    }
		    ?>
	    	<div class="wpc-qty-container" data-id="<?php echo $this->editor->item_id; ?>" <?php echo $quantity_display; ?>>
	    	    <input type="button" id="minus" value="-" class="minus wpc-custom-right-quantity-input-set wpc-btn-effect">
	    	    <input type="number" step="<?php echo $purchase_properties[ 'step' ]; ?>" value="<?php echo $custom_quantity ?>" class="pcd-custom-right-quantity-input pcd-qty" min="<?php echo $purchase_properties[ 'min' ]; ?>" max="<?php echo $purchase_properties[ 'max' ]; ?>" dntmesecondfocus="true" uprice="<?php echo $price; ?>">
	    	    <input type="button" id="plus" value="+" class="plus wpc-custom-right-quantity-input-set wpc-btn-effect">

	    	    <div class="total-price">
			    <?php echo $price_html; ?>
	    	    </div>
	    	</div>
		    <?php
		}
		?>
		<button id="add-to-cart-btn" class="wpc-btn-effect" data-id="<?php echo $this->editor->item_id; ?>"><?php echo $add_to_cart_label; ?></button>
	    </div>
	</div>     
	<?php
	$output = ob_get_clean();
	return $output;
    }

    private function get_product_details() {
	ob_start();
	?>
	<div class="wpc-tools-head is-active" id="product-panel" style="display:none;">
	    <div id="product" class="iconB iconB-Product_details_icon">

	    </div>
	</div>
	<div id="product-panel-content" class="wpc-tools-content " style="display:none;">
	    <div class="wpc-panel-head">
		Product details                                                
		<span id="product-panel-close" class="wpc-tools-close fa fa-close"></span>
		<ul id="wpc-products-tabs" class="wpc-tabs">
		    <li class="wpc-tab-link current" data-tab="tab-brand">Brand</li>
		    <li class="wpc-tab-link" data-tab="tab-model">Model</li>
		    <li class="wpc-tab-link" data-tab="tab-type">Type</li>
		</ul>
	    </div>
	    <div id="tab-brand" class="wpc-tab-content current">
		<div class="wpc-tab-content-wrapper">

		    <div id="product-brands" class="img-container brands-container">

			<div class="pcd-upload-search-wrap">
			    <span class="icon-464"></span>
			    <input id="pcd-computer-search" placeholder="Search" type="text">
			</div>

			<ul class="pcd-cliparts-groups-parent" id="brand-loader">

			</ul>
		    </div>
		</div>
	    </div>

	    <div id="tab-model" class="wpc-tab-content">
		<div class="wpc-tab-content-wrapper">

		    <div id="product-models" class="img-container models-container">

			<div class="pcd-upload-search-wrap">
			    <span class="icon-464"></span>
			    <input id="pcd-computer-search" placeholder="Search" type="text">
			</div>

			<ul class="pcd-cliparts-groups-parent" id="model-loader">

			</ul>
		    </div>

		</div><!--wpc-tab-content-wrapper-->
	    </div><!-- id="tab-model" class="wpc-tab-content"-->
	    <div id="tab-type" class="wpc-tab-content">

		<div class="pcd-upload-search-wrap">
		    <span class="icon-464"></span>
		    <input id="pcd-computer-search" placeholder="Search" type="text">
		</div>

		<div id="product-types" class="img-container types-container">

		    <ul class="pcd-cliparts-groups-parent" id="cases-loader">


		    </ul>

		</div>

	    </div>
	</div> 
	<?php
	$output = ob_get_clean();
	return $output;
    }

    private function get_cliparts() {
	ob_start();
	?>

	<div class="wpc-tools-head" id="cliparts-panel">
	    <div id="cliparts" class="iconB iconB-Cliparts_icon"></div>
	</div>
	<div id="cliparts-panel-content" class="wpc-tools-content">
	    <div id="pcd-clipart-group-container" class="pcd-group-parent-child-wrap">
		<div  class="wpc-panel-head">
		    <?php _e( 'Cliparts', 'pcd' ); ?> 
		    <span id="cliparts-panel-close" class="wpc-tools-close fa fa-close"></span>
		    <!--                    <div class="pcd-parent-wrap-close icon-557"></div>-->

		    <div class="pcd-upload-search-wrap">
			<span class="icon-464"></span>
			<input type="text" id="pcd-cliparts-group-search" placeholder="Search">
		    </div>
		</div>

		<div id="pcd-cliparts-groups-wrapper" class="pcd-tools-content-scroll-wrap">

		    <ul class="" id="pcd-search-cliparts-group-results"></ul>
		    <ul class="pcd-cliparts-groups">

			<?php
			$args		 = array(
			    'numberposts'	 => -1,
			    'post_type'	 => 'pcd-cliparts',
			);
			$cliparts_groups = get_posts( $args );
			if ( isset( $this->pcd_metas[ 'global-cliparts' ] ) && 'no' === $this->pcd_metas[ 'global-cliparts' ][ 'use-global-cliparts' ] && isset( $this->pcd_metas[ 'global-cliparts' ][ 'selected-cliparts' ] ) && ! empty( $this->pcd_metas[ 'global-cliparts' ][ 'selected-cliparts' ] ) ) {
			    $cliparts_groups_id	 = $this->pcd_metas[ 'global-cliparts' ][ 'selected-cliparts' ];
			    $cliparts_groups	 = array();
			    foreach ( $cliparts_groups_id as $cliparts_group_id ) {
				array_push( $cliparts_groups, get_post( $cliparts_group_id ) );
			    }
			}

			foreach ( $cliparts_groups as $cliparts_group ) {
			    $cliparts = get_post_meta( $cliparts_group->ID, 'pcd-cliparts-data', true );
			    if ( ! empty( $cliparts ) ) {
				?>
				<li data-group-name="<?= $cliparts_group->post_title; ?>" data-groupid="<?= $cliparts_group->ID; ?>"><?= $cliparts_group->post_title; ?></li>
				<?php
			    }
			}
			?>

		    </ul>

		</div>

	    </div>
	    <div id="cliparts-panel-content-child" class="wpc-tools-content-child pcd-group-child-wrap">
		<div  class="wpc-panel-head">
		    <span id="pcd-clipart-group-selected"></span>
		    <div class="pcd-child-wrap-close icon-557"></div>
		    <div class="pcd-upload-search-wrap">
			<span class="icon-464"></span>
			<input type="text" id="pcd-cliparts-search" placeholder="Search">
		    </div>
		</div>
		<div id="tab-clipart-upload-child" class="">

		    <div class="" id="pcd-search-cliparts-results"></div>
		    <div id="pcd-cliparts-wrapper" class="">

			<div class="" id="pcd-search-cliparts-results"></div>
			<div class="" id="pcd-all-cliparts">
			    <?php
			    foreach ( $cliparts_groups as $cliparts_group ) {
				$cliparts = get_post_meta( $cliparts_group->ID, 'pcd-cliparts-data', true );
				?>
	    		    <div class="pcd-cliparts-container" data-groupid="<?= $cliparts_group->ID; ?>">
				    <?php
				    if ( ! empty( $cliparts ) ) {

					foreach ( $cliparts as $clipart ) {
					    $attachment_url	 = o_get_proper_image_url( $clipart[ 'id' ] );
					    $name		 = $clipart[ 'name' ];
					    $price		 = $clipart[ 'price' ];
					    if ( empty( $price ) ) {
						$price = 0;
					    }
					    ?>


		    			<span class="clipart-img" data-src="<?= $attachment_url; ?>" style="background-image:url(<?= $attachment_url; ?>);" data-original="<?= $attachment_url; ?>" data-img-name="<?= $name; ?>" data-price="<?= $price; ?>">
		    			</span>

					    <?php
					}
				    }
				    ?>
	    		    </div>
				<?php
			    }
			    ?>
			</div>
		    </div>
		</div>       
	    </div>
	    



	</div>
	<?php
	$output = ob_get_clean();
	return $output;
    }

    /**
     * Get text alignement.
     *
     * @return Sting $output The output.
     */
    private function get_text_alignement() {
	ob_start();
	?>
	<span>Alignment</span>
	<div class="wpc-text-alignment">
	    <input type="radio" id="txt-align-left" name="radio" class="txt-align" value="left">
	    <label for="txt-align-left">
		<span class="icon-1342"></span>
	    </label>
	    <input type="radio" id="txt-align-center" name="radio" class="txt-align" value="center">
	    <label for="txt-align-center">
		<span class="icon-1343"></span>
	    </label>
	    <input type="radio" id="txt-align-right" name="radio" class="txt-align" value="right">
	    <label for="txt-align-right">
		<span class="icon-1270"></span>
	    </label>
	    <input type="radio" id="txt-align-justify" name="radio" class="txt-align" value="justify">
	    <label for="txt-align-justify">
		<span class="icon-1269"></span>
	    </label>


	</div>
	<?php
	$output = ob_get_clean();
	return $output;
    }

    /**
     * Get text size.
     *
     * @return Sting $output The output.
     */
    private function get_text_size() {
	ob_start();
	?>
	<span><?php _e( 'Size', 'pcd' ); ?></span>
	<?php
	//$options = array();
//        $max_filtered_size = apply_filters('wpd-max-font-size', 30);
//        $min_filtered_size = apply_filters('wpd-min-font-size', 8);
//        $selected_filtered_size = apply_filters('wpd-default-font-size', 30);
//
//        $default_size = intval(get_proper_value($setting_text, 'default-font-size', $selected_filtered_size));
//        $min_size = intval(get_proper_value($setting_text, 'min-font-size', $min_filtered_size));
//        $max_size = intval(get_proper_value($setting_text, 'max-font-size', $max_filtered_size));
//
//        for ($i = $min_size; $i <= $max_size; $i++) {
//            $options[$i] = $i;
//        }
	?>
	<div>
	    <div class="pcd-number-input">
		<button  class="minus" ></button>
		<input class="quantity" min="8" step="1" name="font-size-selector" id="font-size-selector" value="16" max="30" type="number">
		<button  class="plus"></button>
	    </div>
	</div>
	<?php
	$output = ob_get_clean();
	return $output;
    }

    /**
     * Get text size.
     *
     * @return Sting $output The output.
     */
    private function get_letter_spacing() {
	ob_start();
	?>
	<span><?php _e( 'Letter spacing', 'pcd' ); ?></span>
	<div>
	    <div class="pcd-number-input">
		<button  class="minus" ></button>
		<input class="quantity" min="8" step="1" name="letter-space-selector" id="letter-space-selector" value="16" max="30" type="number">
		<button  class="plus"></button>
	    </div>

	</div>
	<?php
	$output = ob_get_clean();
	return $output;
    }

    /**
     * Get text fonts family.
     *
     * @return Sting $output The output.
     */
    private function get_text_fonts_family() {
	ob_start();
	?>
	<div id="tab-font" class="wpc-tab-content">
	    <div class="wpc-tab-content-wrapper">
		<!--                 pcd-group-child-wrap-->
		<div  class="pcd-font-group-wrap">
		    <!--                    <div class="pcd-child-wrap-close icon-557"></div>-->
		    <div class="font-selector-container ">
			<div id="font-family-selector" class="text-element-border">
			    <?php
			    $fonts = get_option( 'pcd-fonts' );

			    if ( empty( $fonts ) ) {
				$fonts = pcd_get_default_fonts();
			    }

			    if ( isset( $this->pcd_metas[ 'global-fonts' ] ) && 'no' === $this->pcd_metas[ 'global-fonts' ][ 'use-global-fonts' ] && isset( $this->pcd_metas[ 'global-fonts' ][ 'selected-fonts' ] ) && ! empty( $this->pcd_metas[ 'global-fonts' ][ 'selected-fonts' ] ) ) {
				$fonts = $this->pcd_metas[ 'global-fonts' ][ 'selected-fonts' ];

				foreach ( $fonts as $font ) {
				    $font_label = json_decode( $font )[ 0 ];
				    ?>
				    <div style="font-family: <?php echo $font_label; ?>">
					<div class="pcd-font-view">Hello</div>
					<div class="pcd-font-name"><?php echo $font_label; ?></div>
				    </div>
				    <?php
				}
			    } else {

				foreach ( $fonts as $font ) {
				    $font_label = $font[ 0 ];
				    //die( var_dump($font));
				    ?>

				    <div style="font-family: <?php echo $font_label; ?>">
					<div class="pcd-font-view">Hello</div>
					<div class="pcd-font-name"><?php echo $font_label; ?></div>
				    </div>
				    <?php
				}
			    }
			    ?>
			</div>
		    </div>
		</div>
	    </div>
	</div>
	<?php
	$output = ob_get_clean();
	return $output;
    }

    private function get_text_style() {
	ob_start();
	?>
	<div class="wpc-text-style">
	    <input type="checkbox" id="italic-cb" class="custom-cb">
	    <label for="italic-cb"><span class="icon-pcd_icons-04"></span></label>
	    <input type="checkbox" id="bold-cb" class="custom-cb">
	    <label for="bold-cb"><span class="icon-pcd_icons-03"></span></label>

	</div>

	<?php
	$output = ob_get_clean();
	return $output;
    }

    /**
     * Get text decoration.
     *
     * @return Sting $output The output.
     */
    private function get_text_decoration() {
	ob_start();
	?>
	<span>Decoration</span>
	<div class="wpc-text-decoration">
	    <input type="radio" id="underline-cb" name="txt-decoration" class="txt-decoration" value="underline">
	    <label for="underline-cb"><span class="icon-pcd_icons-01"></span></label>
	    <input type="radio" id="strikethrough-cb" name="txt-decoration" class="txt-decoration" value="linethrough">
	    <label for="strikethrough-cb" ><span class="icon-pcd_icons-06"></span></label>
	    <input type="radio" id="overline-cb" name="txt-decoration" class="txt-decoration" value="overline">
	    <label for="overline-cb"><span class="icon-pcd_icons-05"></span></label>
	    <input type="radio" id="txt-none-cb" name="txt-decoration" class="txt-decoration" value="none">
	    <label for="txt-none-cb"><span class="icon-261"></span></label>
	</div>
	<?php
	$output = ob_get_clean();
	return $output;
    }

    /**
     * Get text background color.
     *
     * @return Sting $output The output.
     */
    private function get_text_bg_color() {
	ob_start();
	?>
	<span>Color</span>
	<?php if ( isset( $this->pcd_metas[ "colors-palette-type" ] ) && ! empty( $this->pcd_metas[ "colors-palette-type" ] && 'picker' === $this->pcd_metas[ "colors-palette-type" ] ) ) { ?>
	    <input type="text" name="color-value" value="" id="txt-text-color" class="pcd-color-spectrum">
	<?php } elseif ( isset( $this->pcd_metas[ "colors-palette-type" ] ) && ! empty( $this->pcd_metas[ "colors-palette-type" ] && 'palette' === $this->pcd_metas[ "colors-palette-type" ] ) ) { ?>
	    <select name="color-value" id="txt-text-color">
		<?php
		$palette_hex	 = get_proper_value( $this->pcd_metas, 'pcd-custom-palette-hex', '' );
		$palette_name	 = get_proper_value( $this->pcd_metas, 'pcd-custom-palette-name', '' );
		if ( isset( $palette_hex ) && is_array( $palette_hex ) && isset( $palette_name ) && is_array( $palette_name ) ) {
		    foreach ( $palette_hex as $key => $color ) {
			?>
		<option style="background-color:<?= $color ?>;"value="<?= $color ?>"><?= $palette_name[ $key ] ?></option>
			<?php
		    }
		}
		?>
	    <?php } ?>
	</select>
	<!-- <div class="pcd-colorpicker"></div> -->
	<?php
	if ( isset( $this->pcd_metas[ "pcd-default-color" ] ) && ! empty( $this->pcd_metas[ "pcd-default-color" ] ) ) {
	    $hex = $this->pcd_metas[ "pcd-default-color" ];
	} else {
	    $hex = "";
	}
	?>
	<input type="text" name="color-value" value="<?= $hex ?>" id="txt-text-color-value" class="pcd-color-value" placeholder="Color code here" style="display:none;">
	<?php
	$output = ob_get_clean();
	return $output;
    }

    /**
     * Get text opacity.
     *
     * @return Sting $output The output.
     */
    private function get_text_opacity() {
	ob_start();
	?>
	<span>Opacity</span>
	<div>
	    <div class="pcd-number-input">
		<button class="minus" ></button>
		<input class="quantity" name="opacity"  id="opacity-slider" data-opacity="true" step="0.1" min="0" max="1" value="1" type="number">
		<button  class="plus"></button>
	    </div>
	</div>
	<!--        <div>
		    <div class="pcd-range-input">
			<button class="minus" >-</button>
			<input class="quantity" name="opacity"  id="opacity-slider" data-opacity="true" step="0.1" min="0" max="1" value=".5" type="range">
			<button  class="plus">+</button>
		    </div>
		</div>-->
	<?php
	$output = ob_get_clean();
	return $output;
    }

    private function get_text_tools() {
	ob_start();
	?>
	<div class="wpc-tools-head" id="text-panel">
	    <div id="text" class="icon-261"></div>
	</div>
	<div id="text-panel-content" class="wpc-tools-content">
	    <div  class="wpc-panel-head">
		Editing text
		<span id="text-panel-close" class="wpc-tools-close fa fa-close"></span>
		<div class="wpc-text-area-wrap">
		    <?php
		    if ( isset( $this->pcd_metas[ "max-length" ] ) && ! empty( $this->pcd_metas[ "max-length" ] ) ) {
			$max = $this->pcd_metas[ "max-length" ];
		    } else {
			$max = "";
		    }
		    ?>
		    <textarea id="new-text" maxlength="<?= $max ?>" placeholder="Type something..." class="text-element-border text-container "></textarea>
		    <button id="wpc-add-text" class="wpc-btn-effect">ADD TEXT</button>
		</div>

		<ul id="wpc-text-tabs" class="wpc-tabs">
		    <li class="wpc-tab-link current" data-tab="tab-formatting">Formatting</li>
		    <li class="wpc-tab-link" data-tab="tab-font">Font Family</li>
		    <li class="wpc-tab-style" data-tab="tab-style">Style</li>
		</ul>  
	    </div>

	    <div class="effects-tool-container pcd-tools-content-scroll-wrap">

		<div id="tab-formatting" class="wpc-tab-content current">
		    <div class="wpc-tab-content-wrapper">
			<div class="">
			    <div class="pcd-tool-row">
				<?php echo $this->get_text_alignement(); ?>
			    </div>

			    <div class="pcd-tool-row">
				<?php echo $this->get_text_size(); ?>
			    </div>

			    <div class="pcd-tool-row">
				<?php echo $this->get_letter_spacing(); ?>
			    </div>

			</div>
		    </div>
		</div>
		<?php echo $this->get_text_fonts_family(); ?>


		<div id="tab-style" class="wpc-tab-content">
		    <div class="wpc-tab-content-wrapper">
			<div class="">
			    <div class="pcd-tool-row no-flex">
				<?php echo $this->get_text_style(); ?>
			    </div>

			    <div class="pcd-tool-row no-flex">
				<?php echo $this->get_text_decoration(); ?>
			    </div>
			    <div class="pcd-tool-row no-flex">
				<?php echo $this->get_text_bg_color(); ?>
			    </div>
			    <div class="pcd-tool-row ">
				<?php echo $this->get_text_opacity(); ?>
			    </div>


			</div>
		    </div>
		</div>

	    </div><!--end effects-tool-container-->

	</div>
	<?php
	$output = ob_get_clean();
	return $output;
    }

    private function get_layouts( $uploads_options ) {
	ob_start();
	?>
	<div class="wpc-tools-head" id="pcd-layout-panel">
	    <div id="layout" class="iconB iconB-Layout_icon">
	    </div>
	</div>
	<div id="layout-panel-content" class="wpc-tools-content">
	    <div  class="wpc-panel-head">
		Layout
		<span id="layout-panel-close" class="wpc-tools-close fa fa-close"></span>
		<ul id="wpc-layout-tabs" class="wpc-tabs">
		    <li class="wpc-tab-link current" data-tab="tab-grid">Grid</li>
		    <!--                    <li class="wpc-tab-link" data-tab="tab-template">Template</li>-->
		    <li class="wpc-tab-link" data-tab="tab-background">Background</li>
		</ul>
	    </div>
            <div class="pcd-tools-content-scroll-wrap">
	    <div id="tab-grid" class="wpc-tab-content current">
		<div class="wpc-tab-content-wrapper">
		    <div class="wpc-grids-container">
			<ul class="pcd-cliparts-groups-parent" id="layout-container">

			</ul>
		    </div>
		</div>
	    </div> <!--fin tab grid of Layout menu-->
	    

	    <div id="tab-background" class="wpc-tab-content">
		<div class="wpc-tab-content-wrapper wpc-backgrounds-container">
		    <div class="">
			<input type="text" name="color-value" value="" id="bg-color" class="pcd-color-spectrum">
			<!-- <div class="pcd-colorpicker"></div> -->
			<label class="pcd-bg-or-not">
			    <input type="checkbox" name="bg-or-not">
			    No Background
			</label>
			<input type="text" name="bg-color-value" value="" id="bg-color-value" class="pcd-color-value" placeholder="Color code here">

			<form id="userfile_upload_form" class="custom-uploader pcd-bg-uploader" method="POST" action="http://localhost/pcd/admin/admin-ajax.php" enctype="multipart/form-data">
			     <input type="hidden" name="nonce" value="<?php echo wp_create_nonce('pcd-bg-upload-nonce'); ?>">
			    <input type="hidden" name="action" value="pcd_handle_picture_upload">
			    <input type="hidden" name="is_bg_upload" value="1">
			    <div id="drop">
				<div class="wpc-uploader">
				    <span class="pcd-action-title">Choose a file :</span>
				    <div class="pcd-action-notice">
					<span>Supported formats: <?php echo implode( ',', $uploads_options[ 'pcd-upl-extensions' ] ); ?></span>
					<span>Min width: <?= $uploads_options[ 'pcd-min-upload-width' ] ?>, Min height: <?= $uploads_options[ 'pcd-min-upload-height' ] ?></span>
				    </div>
				    <a>
					Upload new image
					<label for="userfile"></label>
					<input type="file" name="userfile" id="userfile">
				    </a>
				</div>
				<div class="acd-upload-info"></div>
			    </div>
			</form>
			<div class="pcd-upload-search-wrap">
			    <span class="icon-464"></span>
			    <input id="pcd-computer-search"  placeholder="Search" type="text">
			</div>

			<div id="acd-bg-uploaded-img" class="img-container images-cliparts-container pcd-tools-content-scroll-wrap">
			    <ul class="pcd-cliparts-groups-parent" >
				<?php
				if ( ! is_user_logged_in() ) {
				    
				    if ( isset( $_COOKIE[ 'pcd-bg-upload' ] ) && ! empty( $_COOKIE[ 'pcd-bg-upload' ] ) ) {
					$pcd_upload_json = json_decode( base64_decode( $_COOKIE[ 'pcd-bg-upload' ] ),true);
					if ( null === $pcd_upload_json ) {
					    $pcd_upload = array();
					} else {
					    $pcd_upload = $pcd_upload_json;
					}
				    } else {
					$pcd_upload = array();
				    }
				   
				    if (is_array($pcd_upload) && !empty( $pcd_upload ) ) {

					foreach ( $pcd_upload as $image ) {
					    if ( isset( $image[ 'img_url' ] ) && ! empty( $image[ 'img_url' ] ) && isset( $image[ 'img_id' ] ) && ! empty( $image[ 'img_id' ] ) ) {
						?>

						<li class="clipart-img  image-bg">
						    <span class="pcd-del-img fa fa-close uploaded-bg-del"></span>
						    <img alt="image" src="<?php echo $image[ 'img_url' ]; ?>" data-upload-id="<?php echo $image[ 'img_id' ]; ?>" data-url="<?php echo $image[ 'img_url' ]; ?>" data-img-name="<?php echo $image[ 'img_name' ]; ?>"/>
						</li>   
						<?php
					    }
					}
				    } else {
					?>
					<p id="no-bg-img">No image found</p>
					<?php
				    }
				} else {
				    global $current_user;
				    $current_user_id = $current_user->ID;

				    if ( isset( get_user_meta( $current_user_id, 'pcd-bg-upload' )[ 0 ] ) && is_array( get_user_meta( $current_user_id, 'pcd-bg-upload' )[ 0 ] ) && ! empty( get_user_meta( $current_user_id, 'pcd-bg-upload' )[ 0 ] ) ) {
					$user_uploads = get_user_meta( $current_user_id, 'pcd-bg-upload' )[ 0 ];

					//die(var_dump($user_uploads));
					foreach ( $user_uploads as $image ) {
					    if ( isset( $image[ 'img_url' ] ) && ! empty( $image[ 'img_url' ] ) && isset( $image[ 'img_id' ] ) && ! empty( $image[ 'img_id' ] ) ) {
						?>
						<li class="clipart-img  image-bg">
						    <span class="pcd-del-img fa fa-close uploaded-bg-del"></span>
						    <img alt="image" src="<?php echo $image[ 'img_url' ]; ?>" data-upload-id="<?php echo $image[ 'img_id' ]; ?>" data-url="<?php echo $image[ 'img_url' ]; ?>" data-img-name="<?php echo $image[ 'img_name' ]; ?>"/>
						</li>   
						<?php
					    }
					}
				    } else {
					?>
					<p id="no-bg-img">No image found</p>
					<?php
				    }
				}
				?>
			    </ul>
			</div>

		    </div>

		</div>
	    </div>
            </div>
	</div>
	<?php
	$output = ob_get_clean();
	return $output;
    }

    private function get_uploads_tools( $facebook_app_id, $instagram_app_id, $facebook_app_secret, $instagram_app_secret, $uploads_options ) {
	ob_start();
	?>
	<div class="wpc-tools-head" id="uploads-panel">
	    <div id="uploads" class="icon-1197"></div>
	</div>
	<div id="uploads-panel-content" class="wpc-tools-content">
	    <div  class="wpc-panel-head">
		<div class="pcd-panel-title">Uploads</div>
		<span id="uploads-panel-close" class="wpc-tools-close fa fa-close"></span>
                <div class="pcd-upload-notice">
                    <?php echo __( "Please click on an image to add it to the phone case.", 'pcd' ); ?>
                </div>
		<ul id="wpc-uploads-tabs" class="wpc-tabs">
		    <li class="wpc-tab-link current" data-tab="tab-upload">Computer</li>
		    <?php
		    if ( ! empty( $facebook_app_id ) && ! empty( $facebook_app_secret ) && ! is_admin() ) {
			?>
	    	    <li class="wpc-tab-link" data-tab="tab-social-facebook">Facebook</li>
			<?php
		    }
		    ?>
		    <?php
		    if ( ! empty( $instagram_app_id ) && ! empty( $instagram_app_secret ) && ! is_admin() ) {
			?>
	    	    <li class="wpc-tab-link" data-tab="tab-social-instagram">Instagram</li>
			<?php
		    }
		    ?>
		</ul>
	    </div>
	    <div id="tab-upload" class="wpc-tab-content current">
		<?php echo $this->get_computer_uploads_tools( $uploads_options ); ?>
	    </div> 
	    <div id="tab-social-facebook" class="wpc-tab-content">
		<?php echo $this->get_facebook_tools(); ?>
	    </div>
	    <div id="tab-social-instagram" class="wpc-tab-content">
		<?php echo $this->get_instagram_tools(); ?>
	    </div>
	    
	</div>     
	<?php
	$output = ob_get_clean();
	return $output;
    }

    /**
     * Get computer uploads tools.
     *
     * @global type $current_user The current user.
     * @param type $uploads_options The uploads option.
     * @return String output.
     */
    private function get_computer_uploads_tools( $uploads_options ) {
	ob_start();
	?>
	<div class="wpc-tab-content-wrapper">
	    <div>
		<form id="userfile_upload_form" class="custom-uploader" method="POST" action="<?php echo esc_html( admin_url( 'admin-ajax.php' ) ); ?>" enctype="multipart/form-data">
		    <input type = "hidden" name = "nonce" value = "<?php echo esc_html( wp_create_nonce( 'pcd-picture-upload-nonce' ) ); ?>">
		    <input type = "hidden" name = "action" value="pcd_handle_picture_upload">
		    <div id="drop">
			<div>
			    <p><b>Allowed uploads extensions:</b> <?php echo implode( ',', $uploads_options[ 'pcd-upl-extensions' ] ); ?></p>
			    <?php
			    if ( ! empty( $uploads_options[ 'pcd-min-upload-width' ] ) ) {
				echo "<p><b>Uploads min width:</b> " . $uploads_options[ 'pcd-min-upload-width' ] . "</p>";
			    }
			    ?>
			    <?php
			    if ( ! empty( $uploads_options[ 'pcd-min-upload-height' ] ) ) {
				echo "<p><b>Uploads min height:</b> " . $uploads_options[ 'pcd-min-upload-height' ] . "</p>";
			    }
			    ?>
			</div>
			<div class="wpc-uploader">
			    Add new file:
			    <a>
				Upload a new image
				<label for="userfile"></label>
				<input type="file" name="userfile" id="userfile">
			    </a>
			</div>
			<div class="acd-upload-info"></div>
		    </div>
		</form>
		<div class="pcd-upload-search-wrap">
		    <span class="icon-464"></span>
		    <input id="pcd-computer-search"  placeholder="Search" type="text">
		</div>

		<div id="acd-uploaded-img" class="img-container images-cliparts-container pcd-tools-content-scroll-wrap">
		    <ul class="pcd-cliparts-groups-parent" >
			<?php
			if ( ! is_user_logged_in() ) {
			    //die(var_dump($_COOKIE[ 'pcd-upload' ]));
			    if ( isset( $_COOKIE[ 'pcd-upload' ] ) && ! empty( $_COOKIE[ 'pcd-upload' ] ) ) {
				$pcd_upload_json = json_decode( base64_decode( $_COOKIE[ 'pcd-upload' ] ));
				if ( null === $pcd_upload_json ) {
				    $pcd_upload = array();
				} else {
				    $pcd_upload = $pcd_upload_json;
				}
			    } else {
				$pcd_upload = array();
			    }
			    if (! empty( $pcd_upload ) ) {

				foreach ( $pcd_upload as $image ) {
				    if ( isset( $image->img_url ) && ! empty( $image->img_url ) && isset( $image->img_id ) && ! empty( $image->img_id ) ) {
					?>

					<li class="clipart-img  image-uploaded">
					    <span class="pcd-del-img fa fa-close"></span>
					    <img alt="image" src="<?php echo $image->img_url; ?>" data-upload-id="<?php echo $image->img_id; ?>" data-url="<?php echo $image->img_url; ?>" data-img-name="<?php echo $image->img_name; ?>"/>
					</li>
					<?php
				    }
				}
			    } else {
				?>
				<p id="no-uploaded-img">No image found</p>
				<?php
			    }
			} else {
			    global $current_user;
			    $current_user_id = $current_user->ID;

			    if ( isset( get_user_meta( $current_user_id, 'pcd-upload' )[ 0 ] ) && is_array( get_user_meta( $current_user_id, 'pcd-upload' )[ 0 ] ) && ! empty( get_user_meta( $current_user_id, 'pcd-upload' )[ 0 ] ) ) {
				$user_uploads = get_user_meta( $current_user_id, 'pcd-upload' )[ 0 ];

//                                die(var_dump($user_uploads));
				foreach ( $user_uploads as $image ) {
				    if ( isset( $image[ 'img_url' ] ) && ! empty( $image[ 'img_url' ] ) && isset( $image[ 'img_id' ] ) && ! empty( $image[ 'img_id' ] ) ) {
					?>
					<li class="clipart-img  image-uploaded">
					    <span class="pcd-del-img fa fa-close"></span>
					    <img alt="image" src="<?php echo $image[ 'img_url' ]; ?>" data-upload-id="<?php echo $image[ 'img_id' ]; ?>" data-url="<?php echo $image[ 'img_url' ]; ?>" data-img-name="<?php echo $image[ 'img_name' ]; ?>"/>
					</li>   
					<?php
				    }
				}
			    } else {
				?>
				<p id="no-uploaded-img">No image found</p>
				<?php
			    }
			}
			?>
		    </ul>
		</div>
	    </div>
	</div>
	<?php
	$output = ob_get_clean();
	return $output;
    }

    /**
     * Get facebook tools.
     *
     * @return String output.
     */
    private function get_facebook_tools() {
	ob_start();
	?>
	<div class="wpc-tab-content-wrapper">
	    <div>
		<div class="wpc-rs-app">
		    Sign in to use your files:
		    <a class="wpc-facebook acd-social-login" href="<?php echo $this->get_social_login_url( 'instagram' ); ?>">Extract my pictures</a>
		</div>
		<div class="pcd-upload-search-wrap">
		    <span class="icon-464"></span>
		    <input id="wpc-facebook-search"  placeholder="Search" type="text">
		</div>
		<div class="img-container pcd-tools-content-scroll-wrap">
		    <?php
		    if ( isset( $_SESSION[ 'wpc-facebook-images' ] ) ) {
			foreach ( $_SESSION[ 'wpc-facebook-images' ] as $facebook_img ) {
			    echo "<span class='clipart-img'><img src='$facebook_img'></span>";
			}
		    }
		    ?>
		</div>
	    </div>
	</div>
	<?php
	$output = ob_get_clean();
	return $output;
    }

    /**
     * Get instagram tools.
     *
     * @return String output.
     */
    private function get_instagram_tools() {
	ob_start();
	?>
	<div class="wpc-tab-content-wrapper">
	    <div>
		<div class="wpc-rs-app">
		    Sign in to use your files:
		    <a class="wpc-instagram acd-social-login" href="<?php echo $this->get_social_login_url( 'instagram' ); ?>">Extract my pictures</a>
		</div>
		<div class="pcd-upload-search-wrap">
		    <span class="icon-464"></span>
		    <input id="wpc-instagram-search"  placeholder="Search" type="text">
		</div>
		<div class="img-container pcd-tools-content-scroll-wrap">
		    <?php
		    if ( isset( $_SESSION[ 'wpc-instagram-images' ] ) ) {
			foreach ( $_SESSION[ 'wpc-instagram-images' ] as $instagram_img ) {
			    echo "<span class='clipart-img'><img src='$instagram_img'></span>";
			}
		    }
		    ?>
		</div>
	    </div>>
	</div>
	<?php
	$output = ob_get_clean();
	return $output;
    }

    /**
     * Get uploads filters tools.
     *
     * @return String output.
     */
    private function get_uploads_filters_tools() {
	ob_start();
	?>
	<div id="pcd-uploads-filters-wrap">
	    <div  class="wpc-panel-head">
                 <div class="pcd-panel-title"><?php _e('Edit image', 'pcd'); ?></div>
                 <span id="" class="wpc-tools-close ti-close"></span>
	    </div>
	    <div class="pcd-tools-content-scroll-wrap">
		<div class="filter-set-container">
		    <span class="filter-set-label">Filters</span>
		    <div class="txt-center ">
			<input type="checkbox" id="grayscale-2" class="custom-cb filter-cb acd-grayscale">
			<label for="grayscale-2">Grayscale</label>
			<input type="checkbox" id="invert-2" class="custom-cb filter-cb acd-invert">
			<label for="invert-2">Invert</label>
			<input type="checkbox" id="sepia-2" class="custom-cb filter-cb acd-sepia">
			<label for="sepia-2">Sepia 1</label>
			<input type="checkbox" id="brownie" class="custom-cb filter-cb acd-brownie">
			<label for="brownie">brownie</label>
			<input type="checkbox" id="blur-2" class="custom-cb filter-cb acd-blur">
			<label for="blur-2">Blur</label>
			<input type="checkbox" id="vintage" class="custom-cb filter-cb acd-vintage">
			<label for="vintage">Vintage</label>
			<input type="checkbox" id="polaroid" class="custom-cb filter-cb acd-polaroid">
			<label for="polaroid">Polaroid</label>
			<input type="checkbox" id="blackwhite" class="custom-cb filter-cb acd-blackwhite">
			<label for="blackwhite">Blackwhite</label>
			<div class="clipart-bg-color-container"></div>
		    </div>
		</div>
		<div class="pcd-tool-row">
		    <span>Opacity</span>
		    <div>   
			<div class="pcd-number-input">
			    <button class="minus" ></button>
			    <input class="quantity" name="img-opacity-slider"  id="img-opacity-slider" data-opacity="true" step="0.1" min="0" max="1" value="1" type="number">
			    <button  class="plus"></button>
			</div> 
		    </div>
		</div>
	    </div>
	</div>
	<?php
	$output = ob_get_clean();
	return $output;
    }

    /**
     * Get social login url.
     *
     * @param type $network The network.
     * @return string The output url.
     */
    private function get_social_login_url( $network ) {
	$url = $_SERVER[ 'REQUEST_URI' ];

	$url_parts = parse_url( $url );
	if ( ! isset( $url_parts[ 'query' ] ) ) {
	    $url_parts[ 'query' ] = '';
	}
	parse_str( $url_parts[ 'query' ], $params );

	$params[ 'social-login' ] = $network;

	$output_url	 = '?';
	$count		 = 1;
	foreach ( $params as $key => $value ) {
	    $output_url .= "$key=$value";
	    if ( $count < count( $params ) ) {
		$output_url .= '&';
	    }
	}

	return $output_url;
    }

    private function register_styles() {
	wp_enqueue_style( 'pcd-porto-css', PCD_URL . 'includes/skins/default/assets/css/porto.css', array(), PCD_VERSION, 'all' );
	wp_enqueue_style( 'pcd-phonecase-css', PCD_URL . 'includes/skins/default/assets/css/pcd.css', array(), PCD_VERSION, 'all' );

	wp_enqueue_style( 'pcd-line-icons-css', PCD_URL . 'includes/skins/default/assets/css/line-icons.css', array(), PCD_VERSION, 'all' );
	wp_enqueue_style( 'pcd-pcd_icons-css', PCD_URL . 'includes/skins/default/assets/css/pcd_icons.css', array(), PCD_VERSION, 'all' );
	//wp_enqueue_style('pcd-template-icons-css', PCD_URL . 'includes/skins/default/assets/css/template-icon-style.css', array(), PCD_VERSION, 'all');
	wp_enqueue_style( 'pcd-colorpicker-css', PCD_URL . 'includes/skins/default/assets/css/colorpicker.min.css', array(), PCD_VERSION, 'all' );
	wp_enqueue_style( 'pcd-font-awesome-css', PCD_URL . 'includes/skins/default/assets/css/font-awesome.min.css', array(), PCD_VERSION, 'all' );
	wp_enqueue_style( 'pcd-jquery-mCustomScrollbar-css', PCD_URL . 'includes/skins/default/assets/css/jquery.mCustomScrollbar.min.css', array(), PCD_VERSION, 'all' );

	//wp_enqueue_style('pcd-modal-css', PCD_URL . 'includes/skins/default/assets/css/modal.min.css', array(), PCD_VERSION, 'all');
	wp_enqueue_style( 'pcd-spectrum-css', PCD_URL . 'includes/skins/default/assets/css/spectrum.min.css', array(), PCD_VERSION, 'all' );
	wp_enqueue_style( 'pcd-style-css', PCD_URL . 'includes/skins/default/assets/css/style.css', array(), PCD_VERSION, 'all' );
	wp_enqueue_style( 'pcd-swiper-css', PCD_URL . 'includes/skins/default/assets/css/swiper.min.css', array(), PCD_VERSION, 'all' );
	wp_enqueue_style( 'pcd-tooltip-css', PCD_URL . 'includes/skins/default/assets/css/tooltip.min.css', array(), PCD_VERSION, 'all' );
	pcd_register_fonts();
    }

    /**
     * Register the JavaScript for the public-facing side of the site.
     */
    private function register_scripts() {
	wp_enqueue_script( 'pcd-accounting-js', PCD_URL . 'includes/skins/default/assets/js/accounting.min.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-lodash-js', PCD_URL . 'includes/skins/default/assets/js/lodash.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-fabric-js', PCD_URL . 'includes/skins/default/assets/js/fabric.all.min.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-editor-js', PCD_URL . 'includes/skins/default/assets/js/editor.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-phonecase-js', PCD_URL . 'includes/skins/default/assets/js/pcd.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-colorpicker-js', PCD_URL . 'includes/skins/default/assets/js/colorpicker.min.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-editor-img-js', PCD_URL . 'includes/skins/default/assets/js/editor.img.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-editor-text-js', PCD_URL . 'includes/skins/default/assets/js/editor.text.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-editor-toolbar-js', PCD_URL . 'includes/skins/default/assets/js/editor.toolbar.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-editor-shapes-js', PCD_URL . 'includes/skins/default/assets/js/editor.shapes.js', array(), PCD_VERSION, false );

	// wp_enqueue_script( 'pcd-fabric-js', PCD_URL . 'includes/skins/default/assets/js/fabric-2.4.6.min.min.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-jquery-form-js', PCD_URL . 'includes/skins/default/assets/js/jquery.form.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-jquery-lazyload-js', PCD_URL . 'includes/skins/default/assets/js/jquery.lazyload.min.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-jquery-mCustomScrollbar-js', PCD_URL . 'includes/skins/default/assets/js/jquery.mCustomScrollbar.min.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-jquery-number-js', PCD_URL . 'includes/skins/default/assets/js/jquery.number.min.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-jquery-qtip-js', PCD_URL . 'includes/skins/default/assets/js/jquery.qtip-1.0.0-rc3.min.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-jquery-serializejson-js', PCD_URL . 'includes/skins/default/assets/js/jquery.serializejson.js', array(), PCD_VERSION, false );

	wp_enqueue_script( 'pcd-scrollevent-js', PCD_URL . 'includes/skins/default/assets/js/scrollevent.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-porto-js', PCD_URL . 'includes/skins/default/assets/js/porto.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-spectrum-js', PCD_URL . 'includes/skins/default/assets/js/spectrum.min.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-swiper-js', PCD_URL . 'includes/skins/default/assets/js/swiper.min.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-tooltip-js', PCD_URL . 'includes/skins/default/assets/js/tooltip.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-wp-js-hooks-js', PCD_URL . 'includes/skins/default/assets/js/wp-js-hooks.min.js', array(), PCD_VERSION, false );

	wp_enqueue_script( 'pcd-SpryAccordion-js', PCD_URL . 'includes/skins/default/assets/js/SpryAssets/SpryAccordion.min.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-jquery-blockUI-js', PCD_URL . 'includes/skins/default/assets/js/blockUI/jquery.blockUI.min.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-modal-js', PCD_URL . 'includes/skins/default/assets/js/modal/modal.min.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-jquery-ui-widget-js', PCD_URL . 'includes/skins/default/assets/js/upload/js/jquery.ui.widget.min.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-jquery-fileupload-js', PCD_URL . 'includes/skins/default/assets/js/upload/js/jquery.fileupload.min.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-jquery-iframe-transport-js', PCD_URL . 'includes/skins/default/assets/js/upload/js/jquery.iframe-transport.min.js', array(), PCD_VERSION, false );
	wp_enqueue_script( 'pcd-jquery-knob-js', PCD_URL . 'includes/skins/default/assets/js/upload/js/jquery.knob.min.js', array(), PCD_VERSION, false );
    }

}
