<?php

/**
 * The plugin bootstrap file
 *
 * This file is read by WordPress to generate the plugin information in the plugin
 * admin area. This file also includes all of the dependencies used by the plugin,
 * registers the activation and deactivation functions, and defines a function
 * that starts the plugin.
 *
 * @link              orionorigin@orionorigin.com
 * @since             1.0.0
 * @package           Pcd
 *
 * @wordpress-plugin
 * Plugin Name:       Phone Case Designer
 * Plugin URI:        https://designersuiteforwp.com/products/woocommerce-custom-phone-case-designer/?utm_source=plugin%20details&utm_campaign=kandi 
 * Description:       The ultimate woocommerce phone case designer plugin.
 * Version:           1.1.2
 * Author:            ORION
 * Author URI:        orionorigin@orionorigin.com
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       pcd
 * Domain Path:       /languages
 */
// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
    die;
}

/**
 * Currently plugin version.
 * Start at version 1.0.0 and use SemVer - https://semver.org
 * Rename this for your plugin and update it as you release new versions.
 */
define( 'PCD_VERSION', '1.1.2' );
define( 'PCD_URL', plugins_url( '/', __FILE__ ) );
define( 'PCD_DIR', dirname( __FILE__ ) );
define( 'PCD_MAIN_FILE', 'pcd/pcd.php' );
define( 'PCD_PLUGIN_NAME', 'Phone Case Designer' );

$upload_dir	 = wp_upload_dir();
$generation_path = $upload_dir[ 'basedir' ] . "/KANDI/";
$generation_url	 = $upload_dir[ 'baseurl' ] . "/KANDI/";

define( 'PCD_TMP_UPLOAD_PATH', $generation_path . "UPLOADTMP" );
define( 'PCD_TMP_UPLOAD_URL', $generation_url . "UPLOADTMP" );

define( 'PCD_TMP_BG_PATH', $generation_path . "BGTMP" );
define( 'PCD_TMP_BG_URL', $generation_url . "BGTMP" );

define( 'PCD_ORDER_UPLOAD_PATH', $generation_path . "ORDERS" );
define( 'PCD_ORDER_UPLOAD_URL', $generation_url . "ORDERS" );

define( 'PCD_SAVED_DESIGN_UPLOAD_PATH', $generation_path . "SAVED-DESIGN" );
define( 'PCD_SAVED_DESIGN_UPLOAD_URL', $generation_url . "SAVED-DESIGN" );

/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-pcd-activator.php
 */
function activate_pcd() {
    require_once plugin_dir_path( __FILE__ ) . 'includes/class-pcd-activator.php';
    Pcd_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-pcd-deactivator.php
 */
function deactivate_pcd() {
    require_once plugin_dir_path( __FILE__ ) . 'includes/class-pcd-deactivator.php';
    Pcd_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'activate_pcd' );
register_deactivation_hook( __FILE__, 'deactivate_pcd' );

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require plugin_dir_path( __FILE__ ) . 'includes/class-pcd.php';

require_once PCD_DIR . DIRECTORY_SEPARATOR . 'includes' . DIRECTORY_SEPARATOR . 'class-pcd-clipart.php';
require_once PCD_DIR . DIRECTORY_SEPARATOR . 'admin' . DIRECTORY_SEPARATOR . 'class-pcd-post-types.php';
require_once PCD_DIR . DIRECTORY_SEPARATOR . 'admin' . DIRECTORY_SEPARATOR . 'class-pcd-config.php';
require_once PCD_DIR . DIRECTORY_SEPARATOR . 'includes' . DIRECTORY_SEPARATOR . 'class-pcd-editor.php';
require_once PCD_DIR . DIRECTORY_SEPARATOR . 'includes' . DIRECTORY_SEPARATOR . 'class-pcd-design.php';
require_once PCD_DIR . DIRECTORY_SEPARATOR . 'includes' . DIRECTORY_SEPARATOR . 'class-pcd-retarded-actions.php';


// Default skins.
require_once PCD_DIR . DIRECTORY_SEPARATOR . 'includes' . DIRECTORY_SEPARATOR . 'skins' . DIRECTORY_SEPARATOR . 'default' . DIRECTORY_SEPARATOR . 'class-pcd-skin-default.php';

if ( ! function_exists( 'o_admin_fields' ) ) {
    require_once plugin_dir_path( __FILE__ ) . 'includes/utils.php';
}

require_once plugin_dir_path( __FILE__ ) . 'includes/functions.php';

/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.0
 */
function run_pcd() {

    $plugin = new Pcd();
    $plugin->run();
}

run_pcd();
